package gov.anl.gss.sdm.server.model.analysis.graphtheory;

import java.util.LinkedHashMap;
import java.util.Map;

public class PairFactory {
	
	private static Map<String, Pair> definedPairs = new LinkedHashMap<String, Pair>();
	
	public static Pair getPair(String u, String v) {

		if (!pairExists(u,v))
			addPair(u,v);
		return definedPairs.get(makeKey(u,v));
	}
	
	private static boolean pairExists(String u, String v) {
		if (definedPairs.containsKey(makeKey(u,v)))
			return true;
		else
			return false;
	}
	
	private static void addPair(String u, String v) {
		Pair p = new Pair(u,v);
		definedPairs.put(makeKey(u,v), p);
//		definedPairs.put(makeKey(v,u), p);
	}
	
	private static String makeKey(String u, String v) {
		return u + "<#>" + v;
	}

}
