package gov.anl.gss.sdm.server.model.analysis.graphtheory;

import gov.anl.gss.sdm.server.model.tools.AdjacencyToMap;

public class Position {

	private String x;
	private String y;
	private int textPos;
	private int heightAdjustment = 0;
	
	public Position(String v1, String v2, int textPos, int heightAdjustment) {
		this.x = v1;
		this.y = v2;
		this.textPos = textPos;
		this.heightAdjustment = heightAdjustment;
	}
	
	public int getXasInt() {
		return Integer.parseInt(x);
	}

	public int getYasInt() {
		return Integer.parseInt(y);
	}

	public String getX() {
		return x;
	}

	public String getY() {
		return y;
	}
	
	public int getTextPos() {
		return textPos;
	}

	public String toString() {
		return x+","+y+","+textPos+","+heightAdjustment;
	}

	public int getHeightAdjustment() {
		return heightAdjustment;
	}

	public void setHeightAdjustment(int heightAdjustment) {
		this.heightAdjustment = heightAdjustment;
	}
	
	public boolean isTextAbove() {
		return textPos == AdjacencyToMap.TEXTPOS_ABOVE;
	}
	
	public boolean isTextBelow() {
		return textPos == AdjacencyToMap.TEXTPOS_BELOW;
	}
}
