package gov.anl.gss.sdm.server.model.analysis.leea;

import gov.anl.gss.sdm.server.model.analysis.polarity.EquationAnalyzer;
import gov.anl.gss.sdm.server.model.analysis.polarity.PolarityResults;
import gov.anl.gss.sdm.server.model.translator.Equation;
import gov.anl.gss.sdm.server.model.translator.EquationComponents;
import gov.anl.gss.sdm.server.model.translator.InformationManagers;
import gov.anl.gss.sdm.server.model.translator.NativeDataTypeManager;

import java.util.LinkedHashSet;
import java.util.Set;

public class LeeaEquationAnalyzer extends EquationAnalyzer {

	public LeeaEquationAnalyzer(EquationComponents lEqn,
			Equation originalEquation, PolarityResults polarityResultsNoIVV,
			PolarityResults polarityResultsWithIVV, NativeDataTypeManager ndtm) {
		super(lEqn, originalEquation, polarityResultsNoIVV, polarityResultsWithIVV,
				ndtm);
		
	}
	
	public void initialize() {
		try {
			if (originalEquation.getVensimEquation().contains("STEP("))
				System.out.println("DEBUG _SDMlookup or STEP");
			reduced = leeaReduceEquations();
			analyze();
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			cannotProcess = true;
			System.out.println("LEEA FAILURE EqnAnalyze: "+originalEquation);
			System.out.println(e.getMessage());
			
		}
	}
	
	@Override
	public void analyze(Equation t) {

		LeeaCodeBuilder leeaCodeBuilder = new LeeaCodeBuilder(t, originalEquation, false);
		leeaCodeBuilder.setDt(InformationManagers.getInstance().getDataBridge().getDt());
		leeaCodeBuilder.buildCode();
		if (!leeaCodeBuilder.hasTreeRoot())
			return;

		if (leeaCodeBuilder.getGeneratedCode() == null)
			return;


		LeeaRunner runner = new LeeaRunner(leeaCodeBuilder);
		
		LeeaResultsAnalyzer lleaResultsAnalyzer = new LeeaResultsAnalyzer(runner);
		lleaResultsAnalyzer.analyze(polarityResultsNoIVV);

//		if (originalEquation.isStock()) {
//			analyzePolarityForIVVArrows(originalEquation);
//		}
	}

	
	protected Set<Equation> leeaReduceEquations() {
		Set<Equation> redEqn = new LinkedHashSet<Equation>();
		redEqn.add(equation);
		return redEqn;
	}
}
