package gov.anl.gss.sdm.server.model.analysis.leea.gui;

public class LabelValuePair {
	
	private String label;
	private String value;
	private boolean initialValueIsString = false;
	
	public LabelValuePair(String label, int value) {
		this.label = label;
		this.value = Integer.toString(value);
	}
	
	public LabelValuePair(String label, String value) {
		this.label = label;
		this.value = value;
		initialValueIsString = true;
	}
	
	public String toLabelString() {
		if (label.equals("Model") || (label.equals("Data") && initialValueIsString)) {
			return label+" : "+value;
		} else {
			return lPad(label)+" : "+value;
		}
	}

	public String getLabel() {
		return label;
	}

	public String getValue() {
		return value;
	}
	
	private String lPad(String s) {
		String toReturn = s;
		while (toReturn.length() < StandaloneGUI.MODEL_CONTROL_INFORMATION_LENGTH)
			toReturn = "." + toReturn;
		return toReturn;
	}

}
