package gov.anl.gss.sdm.server.model.analysis.leea.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

public class ModelControlModelInformationModelInfoPanel extends JPanel{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private ModelInformationRaw modelInformationRaw;
	private ModelInformation modelInformation;
	
	private StandaloneGUI gui;
	
	public ModelControlModelInformationModelInfoPanel(StandaloneGUI gui, ModelInformationRaw modelInformationRaw) {
		super();
		this.gui = gui;
		this.modelInformationRaw = modelInformationRaw;
		modelInformation = new ModelInformation(this.modelInformationRaw);
		
		setBorder(BorderFactory.createTitledBorder(null, "", TitledBorder.LEFT , 
				TitledBorder.TOP,  new Font("Arial", Font.BOLD,12) , Color.black));
		
		GridBagLayout grid = new GridBagLayout();
		setLayout(grid);
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		
		c.insets = new Insets(3,10,3,10); // top padding
//		c.fill = GridBagConstraints.CENTER;
		c.weightx = .50;
		c.weighty = .50;

	
		c.gridy = 0;
		c.gridx = 0;
		
		c.gridwidth = 1;
		
		c.gridy = 1;
		c.gridx = 0;
		JLabel mi = new JLabel("Model Info");
		
		mi.setFont(new Font("Arial", Font.BOLD,12));
		
		
		add(mi, c);
		c.gridx++;
		
		
		
		
		c.gridy = 2;
		c.gridx = 0;
		
		add(new JLabel(modelInformation.getLevels().getLabel()+":"), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getVariables().getLabel()+":"), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getConstants().getLabel()+":"), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getTableFunctions().getLabel()+":"), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getData().getLabel()+":"), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getInitialTime().getLabel()+":"), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getFinalTime().getLabel()+":"), c);
		c.gridy++;
		
		
		c.gridy = 2;
		c.gridx = 1;
		
		add(new JLabel(modelInformation.getLevels().getValue()), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getVariables().getValue()), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getConstants().getValue()), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getTableFunctions().getValue()), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getData().getValue()), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getInitialTime().getValue()), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getFinalTime().getValue()), c);
		c.gridy++;
		
		
	}

}
