package gov.anl.gss.sdm.server.model.analysis.leea.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

public class ModelControlModelInformationPanel extends JPanel{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private ModelInformationRaw modelInformationRaw;
	private ModelInformation modelInformation;
	private StandaloneGUI gui;
	private JLabel mn;
	private JLabel md;
	private GridBagConstraints c;
	
	public ModelControlModelInformationPanel(StandaloneGUI gui, ModelInformationRaw modelInformationRaw) {
		super();
		this.modelInformationRaw = modelInformationRaw;
		modelInformation = new ModelInformation(this.modelInformationRaw);
		
		setBorder(BorderFactory.createTitledBorder(null, "", TitledBorder.LEFT , 
				TitledBorder.TOP,  new Font("Arial", Font.BOLD,12) , Color.black));
		
		GridBagLayout grid = new GridBagLayout();
		setLayout(grid);
		c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		
		c.insets = new Insets(3,10,3,10); // top padding
		c.weightx = .50;
		c.weighty = .50;

	
		c.gridy = 0;
		c.gridx = 0;
		
		c.gridwidth = 1;
		
		mn = new JLabel("Model: "+modelInformation.getModelName().getValue());
		md = new JLabel("Data: "+modelInformation.getModelData().getValue());
		
		mn.setFont(new Font("Arial", Font.BOLD,12));
		md.setFont(new Font("Arial", Font.BOLD,12));
		
		add(mn, c);
		c.gridx++;
		add(md, c);
		
		c.gridy = 1;
		c.gridx = 0;
		
		add(new ModelControlModelInformationModelInfoPanel(gui, modelInformationRaw), c);
		c.gridx++;
		add(new ModelControlModelInformationStructureInfoPanel(gui, modelInformationRaw), c);

	}
	
	public void setSelectectModel(String s) {
		remove(mn);
		mn = new JLabel("Model: "+s);
		mn.setFont(new Font("Arial", Font.BOLD,12));
		c.gridy = 0;
		c.gridx = 0;
		add(mn, c);
		
	}

}
