package gov.anl.gss.sdm.server.model.analysis.leea.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

public class ModelControlModelInformationStructureInfoPanel extends JPanel{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private ModelInformationRaw modelInformationRaw;
	private ModelInformation modelInformation;
	private StandaloneGUI gui;
	
	public ModelControlModelInformationStructureInfoPanel(StandaloneGUI gui, 
			ModelInformationRaw modelInformationRaw) {
		super();
		this.modelInformationRaw = modelInformationRaw;
		modelInformation = new ModelInformation(this.modelInformationRaw);
		
		setBorder(BorderFactory.createTitledBorder(null, "", TitledBorder.LEFT , 
				TitledBorder.TOP,  new Font("Arial", Font.BOLD,12) , Color.black));
		
		GridBagLayout grid = new GridBagLayout();
		setLayout(grid);
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		
		c.insets = new Insets(3,10,3,10); // top padding
//		c.fill = GridBagConstraints.CENTER;
		c.weightx = .50;
		c.weighty = .50;

	
		c.gridy = 0;
		c.gridx = 0;
		
		c.gridwidth = 1;


		
		c.gridy = 1;
		c.gridx = 0;
		
		JLabel si = new JLabel("Structural Info");
		
		si.setFont(new Font("Arial", Font.BOLD,12));
		
		
		add(si, c);
		
		c.gridy = 2;
		c.gridx = 0;
		

		
		add(new JLabel(modelInformation.getnLevels().getLabel()+":"), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getnEdges().getLabel()+":"), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getnStrongComp().getLabel()+":"), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getnEdgesStrongComp().getLabel()+":"), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getnNodes().getLabel()+":"), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getnLoops().getLabel()+":"), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getnGeodeticLoops().getLabel()+":"), c);
		c.gridy++;
		
		c.gridy = 2;
		c.gridx = 1;
		
		add(new JLabel(modelInformation.getnLevels().getValue()), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getnEdges().getValue()), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getnStrongComp().getValue()), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getnEdgesStrongComp().getValue()), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getnNodes().getValue()), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getnLoops().getValue()), c);
		c.gridy++;
		
		add(new JLabel(modelInformation.getnGeodeticLoops().getValue()), c);
	}

}
