package gov.anl.gss.sdm.server.model.analysis.leea.gui;

import gov.anl.gss.sdm.server.model.tools.MDLProcessor;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

public class ModelControlPanel extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String title = "Model Control";
	private StandaloneGUI gui;
	
	private ModelControlButtonsPanel mcbp;
	private ModelControlModelInformationPanel mcmip;
	private GridBagConstraints c;

	public ModelControlPanel(StandaloneGUI gui) {
		super();
		this.gui = gui;
		setPreferredSize(new Dimension(StandaloneGUI.MODEL_CONTROL_WIDTH, StandaloneGUI.MODEL_CONTROL_HEIGHT));
		setMinimumSize(new Dimension(StandaloneGUI.MODEL_CONTROL_WIDTH, StandaloneGUI.MODEL_CONTROL_HEIGHT));

		setBorder(BorderFactory.createTitledBorder(null, title, TitledBorder.LEFT , 
				TitledBorder.TOP,  new Font("Arial", Font.BOLD,12) , Color.black));

		GridBagLayout grid = new GridBagLayout();
		setLayout(grid);
		c = new GridBagConstraints();
//		c.fill = GridBagConstraints.HORIZONTAL;
		
		mcbp = new ModelControlButtonsPanel(gui);
		mcmip = new ModelControlModelInformationPanel(gui, null);
		
		c.insets = new Insets(0, 0, 0, 0); // top padding
		c.fill = GridBagConstraints.HORIZONTAL;
		c.weightx = .50;
		c.weighty = .0;

		c.gridwidth = 1;
		c.gridy = 0;
		c.gridx = 0;
		
		add(mcbp, c);
		c.gridy++;
		add(mcmip, c);
	}
	
	public void updateWithModelRun(MDLProcessor sdmDoc) {
		remove(mcmip);
		mcmip = new ModelControlModelInformationPanel(gui, new ModelInformationRaw(sdmDoc));
		
		c.gridy = 1;
		add(mcmip, c);
	}
	
	public void setSelectecdModel(String s) {
		mcmip.setSelectectModel(s);
	}

}
