package gov.anl.gss.sdm.server.model.analysis.leea.gui;

public class ModelInformation {

	private LabelValuePair modelName;
	private LabelValuePair modelData;

	private LabelValuePair levels;
	private LabelValuePair variables;
	private LabelValuePair constants;
	private LabelValuePair tableFunctions;
	private LabelValuePair data;
	private LabelValuePair initialTime;
	private LabelValuePair finalTime;
	private LabelValuePair nLevels;
	private LabelValuePair nEdges;
	private LabelValuePair nStrongComp;
	private LabelValuePair nEdgesStrongComp;
	private LabelValuePair nNodes;
	private LabelValuePair nLoops;
	private LabelValuePair nGeodeticLoops;

	public ModelInformation(ModelInformationRaw mir) {
		if (mir == null) {
			setModelName("");
			setModelData("");

			setLevels("");
			setVariables("");
			setConstants("");
			setTableFunctions("");
			setData("");
			setInitialTime("");
			setFinalTime("");
			setnLevels("");
			setnEdges("");
			setnStrongComp("");
			setnEdgesStrongComp("");
			setnNodes("");
			setnLoops("");
			setnGeodeticLoops("");
		} else {
			setModelName( mir.getModelName());
			setModelData( mir.getModelData());

			setLevels(Integer.toString(mir.getLevels()));
			setVariables(Integer.toString(mir.getVariables()));
			setConstants(Integer.toString(mir.getConstants()));
			setTableFunctions(Integer.toString(mir.getTableFunctions()));
			setData(Integer.toString(mir.getData()));
			setInitialTime(mir.getInitialTime());
			setFinalTime(mir.getFinalTime());
			setnLevels(Integer.toString(mir.getnLevels()));
			setnEdges(Integer.toString(mir.getnEdges()));
			setnStrongComp(Integer.toString(mir.getnStrongComp()));
			setnEdgesStrongComp(Integer.toString(mir.getnEdgesStrongComp()));
			setnNodes(Integer.toString(mir.getnNodes()));
			setnLoops(Long.toString(mir.getnLoops()));
			setnGeodeticLoops(Integer.toString(mir.getnGeodeticLoops()));
		}
	}

	public void setModelName(String modelName) {
		this.modelName = new LabelValuePair("Model",modelName);
	}

	public void setModelData(String modelData) {
		this.modelData = new LabelValuePair("Data",modelData);
	}

	public void setLevels(String levels) {
		this.levels = new LabelValuePair("Levels",levels);
	}

	public void setVariables(String variables) {
		this.variables = new LabelValuePair("Variables",variables);
	}

	public void setConstants(String constants) {
		this.constants = new LabelValuePair("Constants",constants);
	}

	public void setTableFunctions(String tableFunctions) {
		this.tableFunctions = new LabelValuePair("Table Functions",tableFunctions);
	}

	public void setData(String data) {
		this.data = new LabelValuePair("Data",data);
	}

	public void setInitialTime(String initialTime) {
		this.initialTime = new LabelValuePair("Initial Time",initialTime);
	}

	public void setFinalTime(String finalTime) {
		this.finalTime = new LabelValuePair("Final Time",finalTime);
	}

	public void setnLevels(String nLevels) {
		this.nLevels = new LabelValuePair("No. of Levels",nLevels);
	}

	public void setnEdges(String nEdges) {
		this.nEdges = new LabelValuePair("No. of Edges",nEdges);
	}

	public void setnStrongComp(String nStrongComp) {
		this.nStrongComp = new LabelValuePair("No. of Strong Comp.",nStrongComp);
	}

	public void setnEdgesStrongComp(String nEdgesStrongComp) {
		this.nEdgesStrongComp = new LabelValuePair("No. of Edges in Str. C.",nEdgesStrongComp);
	}

	public void setnNodes(String nNodes) {
		this.nNodes = new LabelValuePair("No. of Nodes",nNodes);
	}

	public void setnLoops(String nLoops) {
		this.nLoops = new LabelValuePair("No. of Loops",nLoops);
	}

	public void setnGeodeticLoops(String nGeodeticLoops) {
		this.nGeodeticLoops = new LabelValuePair("No. of Geodetic Loops",nGeodeticLoops);
	}

	public LabelValuePair getModelName() {
		return modelName;
	}

	public LabelValuePair getModelData() {
		return modelData;
	}

	public LabelValuePair getLevels() {
		return levels;
	}

	public LabelValuePair getVariables() {
		return variables;
	}

	public LabelValuePair getConstants() {
		return constants;
	}

	public LabelValuePair getTableFunctions() {
		return tableFunctions;
	}

	public LabelValuePair getData() {
		return data;
	}

	public LabelValuePair getInitialTime() {
		return initialTime;
	}

	public LabelValuePair getFinalTime() {
		return finalTime;
	}

	public LabelValuePair getnLevels() {
		return nLevels;
	}

	public LabelValuePair getnEdges() {
		return nEdges;
	}

	public LabelValuePair getnStrongComp() {
		return nStrongComp;
	}

	public LabelValuePair getnEdgesStrongComp() {
		return nEdgesStrongComp;
	}

	public LabelValuePair getnNodes() {
		return nNodes;
	}

	public LabelValuePair getnLoops() {
		return nLoops;
	}

	public LabelValuePair getnGeodeticLoops() {
		return nGeodeticLoops;
	}



}
