package gov.anl.gss.sdm.server.model.analysis.leea.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

public class SDAControDDWAButtonsPanel extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String title = "SDA Control";
	
	
	private JButton ddwa = new JButton("DDWA");
	private JButton decomposition = new JButton("Decomposition");
	private JButton elasticity = new JButton("Elasticity");
	
	private JButton resetCurrent = new JButton("Reset Current");
	private JButton resetAll = new JButton("Reset All");
	private JButton export = new JButton("Export as PDF");
	
	private StandaloneGUI gui;


	public SDAControDDWAButtonsPanel(StandaloneGUI gui) {
		super();
		this.gui = gui;
		setBorder(BorderFactory.createTitledBorder(null, "", TitledBorder.LEFT , 
				TitledBorder.TOP,  new Font("Arial", Font.BOLD,12) , Color.black));
		
		setPreferredSize(new Dimension(StandaloneGUI.SDA_CONTROL_DDWA_BUTTONS_WIDTH, StandaloneGUI.SDA_CONTROL_DDWA_BUTTONS_HEIGHT));
		setMinimumSize(new Dimension(StandaloneGUI.SDA_CONTROL_DDWA_BUTTONS_WIDTH, StandaloneGUI.SDA_CONTROL_DDWA_BUTTONS_HEIGHT));
		
		
		ddwa.setMinimumSize(new Dimension(150, 25));
		
		
		ddwa.setPreferredSize(new Dimension(150, 25));

		GridBagLayout grid = new GridBagLayout();
		setLayout(grid);
		GridBagConstraints c = new GridBagConstraints();
		
		
		ddwa.setFont(new Font("Arial", Font.PLAIN,14));
		
		
		decomposition.setFont(new Font("Arial", Font.ITALIC,12));
		elasticity.setFont(new Font("Arial", Font.ITALIC,12));

		c.insets = new Insets(0,10,0,10); // top padding
		c.fill = GridBagConstraints.CENTER;
		c.weightx = .50;
		c.weighty = .50;

		c.gridwidth = 1;
		c.gridy = 0;
		c.gridx = 0;
		
		c.insets = new Insets(5,10,0,10);

		add(ddwa, c);
		c.gridy++;
		c.insets = new Insets(5,10,0,10);
		add(decomposition, c);
		c.gridy++;
		add(elasticity, c);
		c.gridy++;
		
		c.insets = new Insets(40,10,0,10);
		add(resetCurrent, c);
		c.gridy++;
		c.insets = new Insets(5,10,0,10);
		add(resetAll, c);
		c.gridy++;
		add(export, c);
		c.gridy++;
		
		disablePanel();
		setListeners();
		
	}
	
	private void setListeners() {
		
		ddwa.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				
			}
		});
		
		decomposition.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				
			}
		});
		
		elasticity.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				
			}
		});
		
		resetCurrent.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				
			}
		});
		
		resetAll.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				
			}
		});
		
		export.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				
			}
		});
	}
	
	public void enablePanel() {
		ddwa.setEnabled(true);
		decomposition.setEnabled(true);
		elasticity.setEnabled(true);
		resetCurrent.setEnabled(true);
		resetAll.setEnabled(true);
		export.setEnabled(true);
	}
	
	public void disablePanel() {
		ddwa.setEnabled(false);
		decomposition.setEnabled(false);
		elasticity.setEnabled(false);
		resetCurrent.setEnabled(false);
		resetAll.setEnabled(false);
		export.setEnabled(false);
	}


}
