package gov.anl.gss.sdm.server.model.analysis.leea.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

public class SDAControlLEEAButtonsPanel extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String title = "SDA Control";
	
	private JButton leea = new JButton("LEEA");
	private JButton eigenvalues = new JButton("Eigenvalues");
	private JButton loops = new JButton("Loops");
	
	private StandaloneGUI gui;
	

	public SDAControlLEEAButtonsPanel(StandaloneGUI gui) {
		super();
		this.gui = gui;
		setBorder(BorderFactory.createTitledBorder(null, "", TitledBorder.LEFT , 
				TitledBorder.TOP,  new Font("Arial", Font.BOLD,12) , Color.black));

		setPreferredSize(new Dimension(StandaloneGUI.SDA_CONTROL_LEEA_BUTTONS_WIDTH, StandaloneGUI.SDA_CONTROL_LEEA_BUTTONS_HEIGHT));
		setMinimumSize(new Dimension(StandaloneGUI.SDA_CONTROL_LEEA_BUTTONS_WIDTH, StandaloneGUI.SDA_CONTROL_LEEA_BUTTONS_HEIGHT));
		
		leea.setMinimumSize(new Dimension(150, 25));
		
		
		leea.setPreferredSize(new Dimension(150, 25));
		

		GridBagLayout grid = new GridBagLayout();
		setLayout(grid);
		GridBagConstraints c = new GridBagConstraints();
		
		leea.setFont(new Font("Arial", Font.PLAIN,14));
		
		eigenvalues.setFont(new Font("Arial", Font.ITALIC,12));
		loops.setFont(new Font("Arial", Font.ITALIC,12));
		
		c.insets = new Insets(0,10,0,10); // top padding
		c.fill = GridBagConstraints.CENTER;
		c.weightx = .50;
		c.weighty = .0;

		c.gridwidth = 1;
		c.gridy = 0;
		c.gridx = 0;
		
		c.insets = new Insets(5,10,0,10);
		add(leea, c);
		c.gridy++;
		add(eigenvalues, c);
		c.gridy++;
		add(loops, c);
		c.gridy++;
		disablePanel();
		setListeners();
	}
	
	private void setListeners() {
		

		leea.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				
			}
		});
		
		eigenvalues.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				
			}
		});
		
		loops.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				
			}
		});
		

	}
	
	public void enablePanel() {
		leea.setEnabled(true);
		eigenvalues.setEnabled(true);
		loops.setEnabled(true);
	}
	
	public void disablePanel() {
		leea.setEnabled(false);
		eigenvalues.setEnabled(false);
		loops.setEnabled(false);
	}


}
