package gov.anl.gss.sdm.server.model.analysis.leea.gui;

import gov.anl.gss.sdm.server.model.tools.MDLProcessor;
import gov.anl.gss.sdm.server.model.tools.SDModel;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

public class SDAControlPanel extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String title = "SDA Control";
	
	private StandaloneGUI gui;
	private SDAControlTimePointsPanel sdactp;
	private SDAControlLEEAButtonsPanel sdaclb;
	private SDAControlTimeButtonsPanel sdactb;
	private SDAControDDWAButtonsPanel sdacdb;
	
	GridBagConstraints c;

	public SDAControlPanel(StandaloneGUI gui) {
		super();
		this.gui = gui;
		setBorder(BorderFactory.createTitledBorder(null, title, TitledBorder.LEFT , 
				TitledBorder.TOP,  new Font("Arial", Font.BOLD,12) , Color.black));

		setPreferredSize(new Dimension(StandaloneGUI.SDA_CONTROL_WIDTH, StandaloneGUI.SDA_CONTROL_HEIGHT));
		setMinimumSize(new Dimension(StandaloneGUI.SDA_CONTROL_WIDTH, StandaloneGUI.SDA_CONTROL_HEIGHT));

		GridBagLayout grid = new GridBagLayout();
		setLayout(grid);
		c = new GridBagConstraints();

		c.insets = new Insets(3,0,3,0); // top padding
		c.fill = GridBagConstraints.HORIZONTAL;
		c.weightx = .50;
		c.weighty = 1.0;

		c.gridwidth = 1;
		c.gridy = 0;
		
		c.gridx = 0;
		sdactp = new SDAControlTimePointsPanel(gui);
		add(sdactp, c);
		
		c.gridx = 1;
		
		sdaclb = new SDAControlLEEAButtonsPanel(gui);
		add(sdaclb, c);
		
		c.gridy = 1;
		c.gridx = 0;
		
		sdactb = new SDAControlTimeButtonsPanel(gui);
		add(sdactb, c);
		
		c.gridx = 1;
		sdacdb = new SDAControDDWAButtonsPanel(gui);
		add(sdacdb, c);
		
	}
	
	public void updateWithModelRun(MDLProcessor sdmDoc) {
		
		remove(sdactp);
		SDModel m = sdmDoc.getSDModel();
		sdactp = new SDAControlTimePointsPanel(gui, m.getStartTime(), m.getEndTime(), m.getDt());
		c.gridy = 0;
		c.gridx = 0;
		add(sdactp, c);
		sdactp.enablePanel();
		sdaclb.enablePanel();
		sdactb.enablePanel();
		sdacdb.enablePanel();
	}


}
