package gov.anl.gss.sdm.server.model.analysis.leea.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.border.TitledBorder;

public class SDAControlTimeButtonsPanel extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private static final int TEXT_FIELD_SIZE = 8;
	
	
	private JLabel header = new JLabel("LEEA Time DDWA Time t0");
	
	JRadioButton[] timeButtons = new JRadioButton[11];
    
	private StandaloneGUI gui;
    
    ButtonGroup group = new ButtonGroup();
//    group.add(option1);
//    group.add(option2);
//    group.add(option3);

	public SDAControlTimeButtonsPanel(StandaloneGUI gui) {
		super();
		this.gui = gui;
		setBorder(BorderFactory.createTitledBorder(null, "", TitledBorder.LEFT , 
				TitledBorder.TOP,  new Font("Arial", Font.BOLD,12) , Color.black));
		header.setFont(new Font("Arial", Font.BOLD,12));
		
		for (int i = 0; i < timeButtons.length; i++) {
			final int myTime = i;
			timeButtons[i] = new JRadioButton(Integer.toString(i));
			group.add(timeButtons[i]);
			timeButtons[i].addActionListener(new ActionListener() {
	            @Override
	            public void actionPerformed(ActionEvent e) {
	                System.out.println("Radio "+myTime);

	            }
	        });
		}

		setPreferredSize(new Dimension(StandaloneGUI.SDA_CONTROL_TIME_BUTTONS_WIDTH, StandaloneGUI.SDA_CONTROL_TIME_BUTTONS_HEIGHT));
		setMinimumSize(new Dimension(StandaloneGUI.SDA_CONTROL_TIME_BUTTONS_WIDTH, StandaloneGUI.SDA_CONTROL_TIME_BUTTONS_HEIGHT));

		GridBagLayout grid = new GridBagLayout();
		setLayout(grid);
		GridBagConstraints c = new GridBagConstraints();
		
		c.insets = new Insets(0,10,0,10); // top padding
		c.fill = GridBagConstraints.CENTER;
		c.weightx = .50;
		c.weighty = .50;

		c.gridwidth = 1;
		c.gridy = 0;
		c.gridx = 0;
	
		add(header, c);
		
		c.gridy = 1;
		for (JRadioButton button : timeButtons) {
			add(button, c);
			c.gridy++;
		}
		
		disablePanel();

	}
	
	public void enablePanel() {
		for (JRadioButton button : timeButtons) {
			button.setEnabled(true);
		}
	}
	
	public void disablePanel() {
		for (JRadioButton button : timeButtons) {
			button.setEnabled(false);
		}
	}


}
