package gov.anl.gss.sdm.server.model.analysis.leea.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

public class SDAControlTimePointsPanel extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private static final int TEXT_FIELD_SIZE = 8;
	
	private final JLabel timePointsLabel = new JLabel("Time Points");
	
	private final JTextField startTimeTF = new JTextField(TEXT_FIELD_SIZE);
	private final JTextField endTimeTF = new JTextField(TEXT_FIELD_SIZE);
	private final JTextField intervalTF = new JTextField(TEXT_FIELD_SIZE);
	
	private final JLabel startLabel = new JLabel("Start Time");
	private final JLabel endLabel = new JLabel("End Time");
	private final JLabel intervalLabel = new JLabel("Interval");

	private StandaloneGUI gui;
	
	public SDAControlTimePointsPanel(StandaloneGUI gui) {
		super();
		this.gui = gui;
		create();
		disablePanel();
	}
	
	public SDAControlTimePointsPanel(StandaloneGUI gui, String startTime, String endTime, String interval) {
		super();
		this.gui = gui;
		startTimeTF.setText(startTime);
		endTimeTF.setText(endTime);
		intervalTF.setText(interval);
		create();
		disablePanel();
	}
	
	public void enablePanel() {
		startTimeTF.setEnabled(true);
		endTimeTF.setEnabled(true);
		intervalTF.setEnabled(true);
	}
	
	public void disablePanel() {
		startTimeTF.setEnabled(false);
		endTimeTF.setEnabled(false);
		intervalTF.setEnabled(false);
	}
	
	private void create() {
		setBorder(BorderFactory.createTitledBorder(null, "", TitledBorder.LEFT , 
				TitledBorder.TOP,  new Font("Arial", Font.BOLD,12) , Color.black));
		
		timePointsLabel.setFont(new Font("Arial", Font.BOLD,12));
		
		setPreferredSize(new Dimension(StandaloneGUI.SDA_CONTROL_TIME_POINTS_WIDTH, StandaloneGUI.SDA_CONTROL_TIME_POINTS_HEIGHT));
		setMinimumSize(new Dimension(StandaloneGUI.SDA_CONTROL_TIME_POINTS_WIDTH, StandaloneGUI.SDA_CONTROL_TIME_POINTS_HEIGHT));

		GridBagLayout grid = new GridBagLayout();
		setLayout(grid);
		GridBagConstraints c = new GridBagConstraints();
		
		c.insets = new Insets(3,10,3,10); // top padding
		c.fill = GridBagConstraints.CENTER;
		c.weightx = .50;
		c.weighty = .0;

		c.gridwidth = 2;
		c.gridy = 0;
		c.gridx = 0;
		
		
		c.gridwidth = 2;
		add(timePointsLabel, c);
		c.gridy++;
		
		c.gridwidth = 1;
		
		c.gridx = 0;
		add(startLabel, c);
		c.gridx = 1;
		add(startTimeTF, c);
		c.gridy++;
		
		c.gridx = 0;
		add(endLabel, c);
		c.gridx = 1;
		add(endTimeTF, c);
		c.gridy++;
		
		c.gridx = 0;
		add(intervalLabel, c);
		c.gridx = 1;
		add(intervalTF, c);
		c.gridy++;
	}


}
