package gov.anl.gss.sdm.server.model.analysis.leea.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

public class VariablesBehaviorGraphPanel   extends JPanel{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private StandaloneGUI gui;
	private GridBagConstraints c;
	private JPanel graphPanel;

	public VariablesBehaviorGraphPanel(StandaloneGUI gui, VariablesBehaviorPanel parent) {
		super();
		this.gui = gui;
		setBorder(BorderFactory.createTitledBorder(null, "", TitledBorder.LEFT , 
				TitledBorder.TOP,  new Font("Arial", Font.BOLD,12) , Color.black));

		setPreferredSize(new Dimension(StandaloneGUI.BEHAVIOR_GRAPH_WIDTH, StandaloneGUI.BEHAVIOR_GRAPH_HEIGHT-50));
		setMinimumSize(new Dimension(StandaloneGUI.BEHAVIOR_GRAPH_WIDTH, StandaloneGUI.BEHAVIOR_GRAPH_HEIGHT-50));

		GridBagLayout grid = new GridBagLayout();
		setLayout(grid);
		c = new GridBagConstraints();

		c.insets = new Insets(3,10,3,10); // top padding
		c.fill = GridBagConstraints.HORIZONTAL;
		c.weightx = .50;
		c.weighty = .0;

		c.gridwidth = 1;
		c.gridy = 0;
		c.gridx = 0;
		
		graphPanel = new JPanel();
		add(graphPanel);
	}

	public void addGraph(File thumb) {

		remove(graphPanel);
		
		ImageIcon image = new ImageIcon(thumb.getAbsolutePath());
		JLabel label = new JLabel("", image, JLabel.CENTER);
		graphPanel = new JPanel(new BorderLayout());
		graphPanel.add( label, BorderLayout.CENTER );
		add(graphPanel, c);

	}
}
