package gov.anl.gss.sdm.server.model.analysis.leea.gui;

import gov.anl.gss.sdm.server.model.support.Utilities;
import gov.anl.gss.sdm.server.model.tools.MDLProcessor;
import gov.anl.gss.sdm.server.model.translator.InformationManagers;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

public class VariablesBehaviorPanel   extends JPanel{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private String title = "Behavior of Model Variables";
	
	private StandaloneGUI gui;
	private VariablesBehaviorButtonsPanel vbbp;
	private VariablesBehaviorGraphPanel vbgp;
	
	private GridBagConstraints c;
	
	public VariablesBehaviorPanel(StandaloneGUI gui) {
		super();
		this.gui = gui;
		setBorder(BorderFactory.createTitledBorder(null, title, TitledBorder.LEFT , 
				TitledBorder.TOP,  new Font("Arial", Font.BOLD,12) , Color.black));

		setPreferredSize(new Dimension(StandaloneGUI.BEHAVIOR_WIDTH, StandaloneGUI.BEHAVIOR_HEIGHT));
		setMinimumSize(new Dimension(StandaloneGUI.BEHAVIOR_WIDTH, StandaloneGUI.BEHAVIOR_HEIGHT));
		
		GridBagLayout grid = new GridBagLayout();
		setLayout(grid);
		c = new GridBagConstraints();
		
		c.insets = new Insets(3,10,3,10); // top padding
		c.fill = GridBagConstraints.NORTH;
		
		c.weightx = .50;
		c.weighty = .0;
		
		c.gridwidth = 1;
		c.gridy = 0;
		c.gridx = 0;
		
		vbbp = new VariablesBehaviorButtonsPanel(gui, this, null);
		add(vbbp, c);
		
		c.gridx++;
		vbgp = new VariablesBehaviorGraphPanel(gui, this);
		add(vbgp, c);
		
	}
	
	public void updateWithModelRun(MDLProcessor sdmDoc) {
		remove(vbbp);
		vbbp = new VariablesBehaviorButtonsPanel(gui, this, sdmDoc);
		
		c.gridx = 0;
		add(vbbp, c);
		vbbp.enablePanel();
	}
	
	public void setBehaviorImage(String variable) {
		if (gui == null)
			return;
		if (!gui.isModelRun() || variable == null)
			return;
		File existing = new File(InformationManagers.getInstance().getFileOrganizer().getDocGraphDirectory()+
				"/"+ Utilities.makeLegalJavaName(variable) + ".png");
		vbgp.addGraph(existing);
		gui.updateWithChange();
	}
	

}
