package gov.anl.gss.sdm.server.model.analysis.loops;

import gov.anl.gss.sdm.server.model.support.MutableInteger;
import gov.anl.gss.sdm.server.model.support.Utilities;
import gov.anl.gss.sdm.server.model.translator.Parser;

import java.util.ArrayList;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;

import org.apache.log4j.Logger;

public class OlivaLoops {
static Logger log = Logger.getLogger(OlivaLoops.class.getSimpleName());
	
	private final static String OPEN = "{";
	private final static String CLOSE = "}";
	
	private Set<Loop> allLoops = new LinkedHashSet<Loop>();
	
	public OlivaLoops() {
		parse(load("OlivaLoops.txt"));
	}
	
	private String load(String file) {
		List<String> al = Utilities.getAsList(file);
		StringBuilder sb = new StringBuilder();
		for (String s : al) {
			sb.append(s);
		}
		
		return sb.toString();
	}
	
	private void parse(String all) {
		MutableInteger pos = new MutableInteger(1);
		while (Parser.inRange(pos, all)) {
			Parser.skipToDelimiter(pos, all, "{");
			String aLoop = Parser.getToMatchingDelimiter(all, pos, OPEN, CLOSE);
			MutableInteger pos2 = new MutableInteger(1);
			Parser.skipToDelimiter(pos2, aLoop, "{");
			String vars = Parser.getToMatchingDelimiter(aLoop, pos2, OPEN, CLOSE);
			List<String> allVars = new ArrayList<String>();
			for (String s : vars.split(",")) {
				allVars.add(s.trim());
			}
			log.debug("Oliva Loop: "+allVars);
			if (allVars.size() > 1)
				allLoops.add(new Loop(allVars));
		}
	}

	public Set<Loop> getAllLoops() {
		return allLoops;
	}

}
