package gov.anl.gss.sdm.server.model.analysis.micmac;

import gov.anl.gss.sdm.server.model.documentor.xmlwriter.NumberFormatter;
import gov.anl.gss.visualization.BoundingBox;

import org.jfree.ui.TextAnchor;

public class Annotation {
	
	String text;
	double x;
	double y;
	double angle;
	TextAnchor anchor;
	double distanceFromXY;
	int ptr;
	
	BoundingBox boundingBox = null;
	int slot = -1;
	
	public Annotation(int ptr, String text, double x, double y, double angle, TextAnchor anchor,
	    		double distanceFromXY, int slot) {
		this.ptr = ptr;
		this.text = text;
		this.x = x;
		this.y = y;
		this.angle = angle;
		this.anchor = anchor;
		this.distanceFromXY = distanceFromXY;
		this.slot = slot;
		
	}
	
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("<");
		sb.append(ptr); sb.append("><");
		sb.append(text); sb.append("><");
		sb.append(slot); sb.append("><");
		sb.append(NumberFormatter.formatForRatio(x)); sb.append("><");
		sb.append(NumberFormatter.formatForRatio(y)); sb.append("><");
		sb.append(NumberFormatter.formatForRatio(angle)); sb.append("><");
		sb.append(NumberFormatter.formatForRatio(distanceFromXY)); sb.append("><");
		sb.append(anchor);sb.append("><");
		sb.append(boundingBox == null ? "null" : boundingBox);sb.append(">");
		
		
		return sb.toString();
	}

	public String getText() {
		return text;
	}

	public void setText(String text) {
		this.text = text;
	}

	public double getX() {
		return x;
	}

	public void setX(double x) {
		this.x = x;
	}

	public int getSlot() {
		return slot;
	}

	public void setSlot(int slot) {
		this.slot = slot;
	}

	public double getY() {
		return y;
	}

	public void setY(double y) {
		this.y = y;
	}

	public double getAngle() {
		return angle;
	}

	public void setAngle(double angle) {
		this.angle = angle;
	}

	public TextAnchor getAnchor() {
		return anchor;
	}

	public void setAnchor(TextAnchor anchor) {
		this.anchor = anchor;
	}

	public double getDistanceFromXY() {
		return distanceFromXY;
	}

	public void setDistanceFromXY(double distanceFromXY) {
		this.distanceFromXY = distanceFromXY;
	}

	public BoundingBox getBoundingBox() {
		return boundingBox;
	}

	public void setBoundingBox(BoundingBox boundingBox) {
		this.boundingBox = boundingBox;
	}

	public int getPtr() {
		return ptr;
	}

	public void setPtr(int ptr) {
		this.ptr = ptr;
	}

}
