package gov.anl.gss.sdm.server.model.analysis.micmac;

import gov.anl.gss.visualization.SFEXYPointerAnnotationMetaData;

public class CandidateEvaluation implements Comparable<CandidateEvaluation> {
	
	
	private CandidateLocation candidateLocation;
	private SFEXYPointerAnnotationMetaData meta;
	private double score;
	
	private double topToBottomDensity;
	private double leftToRightDensity;
	
	public CandidateLocation getCandidateLocation() {
		return candidateLocation;
	}
	
	public String toString() {
		return
				candidateLocation+", eval score: "+score;
	}

	public void setCandidateLocation(CandidateLocation candidateLocation) {
		this.candidateLocation = candidateLocation;
	}

	public SFEXYPointerAnnotationMetaData getMeta() {
		return meta;
	}

	public void setMeta(SFEXYPointerAnnotationMetaData meta) {
		this.meta = meta;
	}

	public double getScore() {
		return score;
	}

	public void setScore(double score) {
		this.score = score;
	}

	public CandidateEvaluation(CandidateLocation candidateLocation,
			SFEXYPointerAnnotationMetaData meta) {
		this.candidateLocation = candidateLocation;
		this.meta = meta;
	}
	
	public double evaluate() {
		score = 100.;
		return score;
	}


	public double getTopToBottomDensity() {
		return topToBottomDensity;
	}

	public void setTopToBottomDensity(double topToBottomDensity) {
		this.topToBottomDensity = topToBottomDensity;
	}

	public double getLeftToRightDensity() {
		return leftToRightDensity;
	}

	public void setLeftToRightDensity(double leftToRightDensity) {
		this.leftToRightDensity = leftToRightDensity;
	}

	@Override
	public int compareTo(CandidateEvaluation arg0) {
		return Double.compare(arg0.getScore(), score);
	}

}
