package gov.anl.gss.sdm.server.model.analysis.micmac;

import gov.anl.gss.sdm.server.model.documentor.xmlwriter.NumberFormatter;

public class CandidateLocation {
	
	/**
	 * x,y are coordinates of point
	 * location of annotation based on distance and angle
	 */

	int ptr;
	double x;
	double y;
	int slot;
	double distance;
	double angle;
	double score;

	public CandidateLocation(int ptr,
			double x,
			double y,
			int slot,
			double distance,
			double angle) {
		this.ptr = ptr;
		this.x = x;
		this.y = y;
		this.slot = slot;
		this.distance = distance;
		this.angle = angle;
	}
	
	public String toString() {
		return
				"x: "+
				NumberFormatter.formatForSmall(x)+", y: "+
				NumberFormatter.formatForSmall(y)+", slot: "+
				slot+", dist: "+
				distance+", angle:"+angle+
				"loc score: "+score;
				
	}
	
	public DataPoint getLocationPoint(double distanceAdjustment) {
		double adjustedDistance = (distance /  distanceAdjustment); //  * (MicMacScatterPlot.PLOT_SIZE_SCALE_FACTOR);
		double x2 = x + Math.cos(angle) * adjustedDistance;
		double y2 = y - Math.sin(angle) * adjustedDistance;
		return new DataPoint(-10*ptr, x2, y2);
	}

	public int getPtr() {
		return ptr;
	}

	public int getSlot() {
		return slot;
	}

	public double getDistance() {
		return distance;
	}

	public double getX() {
		return x;
	}

	public double getY() {
		return y;
	}

	public double getAngle() {
		return angle;
	}

	public void setDistance(double distance) {
		this.distance = distance;
	}

	public void setSlot(int slot) {
		this.slot = slot;
	}

	public double getScore() {
		return score;
	}

	public void setScore(double score) {
		this.score = score;
	}
	
}
