package gov.anl.gss.sdm.server.model.analysis.micmac;

import gov.anl.gss.sdm.server.model.documentor.xmlwriter.NumberFormatter;

public class DataPoint implements Comparable<DataPoint> {
	
	private double x;
	private double y;
	private int ptr;
	
	public DataPoint(int ptr, double x, double y) {
		this.ptr = ptr;
		this.x = x;
		this.y = y;
	}
	
	public String toString() {
		return "ptr: "+ptr+" x: "+NumberFormatter.formatForSmall(x)+" y: "+NumberFormatter.formatForSmall(y);
	}

	@Override
	public int compareTo(DataPoint arg0) {
		if (y < arg0.y)
			return 1;
		if (y > arg0.y)
			return -1;
		if (x < arg0.x)
			return 1;
		if (x > arg0.x)
			return -1;
		return 0;
	}

	public double getX() {
		return x;
	}

	public double getY() {
		return y;
	}

	public int getPtr() {
		return ptr;
	}

}
