package gov.anl.gss.sdm.server.model.analysis.micmac;



public class DataPointProximity implements Comparable<DataPointProximity>{
	
	private static final double SLICE = Math.PI/8;
	private int slot;
	private int ptr1;
	private int ptr2;
	private double angle;
	private double distance;
	

	
	public DataPointProximity(int ptr1, int ptr2, double dist, double angle) {
		this.ptr1 = ptr1;
		this.ptr2 = ptr2;
		addDataPoint(dist, angle);
	}
	
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("ptr1: "+ptr1);
		sb.append(" -> ptr2: "+ptr2);
		
		sb.append(" angle: "+angle);
		sb.append(" slot: "+slot);
		sb.append(" distance: "+distance);
		
		return sb.toString();
	}
	
	public void addDataPoint(double dist, double angle) {
		slot = angleToSlot(angle);
		distance = dist;
		this.angle = angle;
//		if (angle > 0.0) {
//			slot += 8;
//		}
	}

	private int angleToSlot(double angle) {
		
		// 0,8 1,9, 2,10 3,11 4,12 5,13 6,14 7,15 
		int slot = Math.abs((int) (angle / SLICE));
		if (angle < 0.0) {
			slot = slot+8;
		}

		if (slot > 15)
			slot = 7;

		return slot;
	}
	
	@Override
	public int compareTo(DataPointProximity arg0) {
		
		if (this.distance < arg0.getDistance()) {
			return -1;
		} else if (this.distance > arg0.getDistance()) {
			return 1;
		} else 
			return 0;
	}

	public static double getSlice() {
		return SLICE;
	}

	public int getPtr1() {
		return ptr1;
	}

	public int getPtr2() {
		return ptr2;
	}

	public int getSlot() {
		return slot;
	}

	public double getAngle() {
		return angle;
	}

	public double getDistance() {
		return distance;
	}



}
