package gov.anl.gss.sdm.server.model.analysis.polarity;

import gov.anl.gss.sdm.server.model.dynamic.DynaComp;

import java.lang.reflect.Method;

import org.apache.log4j.Logger;


public class DynaCompTest {
static Logger log = Logger.getLogger(DynaCompTest.class.getSimpleName());
	public static void main(String[] args) throws Exception {
        // Full name of the class that will be compiled.
        // If class should be in some package,
        // fullName should contain it too
        // (ex. "testpackage.DynaClass")
        String fullName = "SamplePolarityCalculator";

        // Here we specify the source code of the class to be compiled
        StringBuilder src = new StringBuilder();
        
        src.append("public class SamplePolarityCalculator {\n");
        src.append("public double compute(double[] rhs) {\n");
        src.append("double lhs = rhs[0]+rhs[1];\n");
        src.append("return lhs;\n");
        src.append("}\n");
        src.append("}\n");

        log.debug(src);
        
        DynaComp dyna = new DynaComp(fullName, src);
        
        double[] rhs = {1.0, 7.0};
        
        for (int i = 0; i < 5; i++) {
        	rhs[0] = i;
        	Class[] cArg = new Class[1];
            cArg[0] = double[].class;
            Object o = dyna.getInstance();
            Method m = o.getClass().getMethod("compute",cArg);
        	log.debug("Results: "+m.invoke(o,rhs));
        }

 
    }
}
