package gov.anl.gss.sdm.server.model.analysis.polarity;

import gov.anl.gss.sdm.server.model.translator.Node;
import gov.anl.gss.sdm.server.model.translator.TreeTraversal;

public class IfThenElseExpression {

	private IfThenElseVariableRelationship relationships;
	
	private Node transformedEquation = null;
	private Node equationRootCopy = null;
	
	public IfThenElseExpression(Node root) {
		if (root == null)
			return;
		this.equationRootCopy = root;
		process();
	}
	
	
	private void process() {
		relationships = new IfThenElseVariableRelationship(equationRootCopy);
		transformedEquation = transformEquation();
		Node.printTree(transformedEquation);
	}
	
	private Node transformEquation() {
		Node root = new Node(/* Node.getCopyOfTree( */ equationRootCopy /*)*/ );
		
		// traverse the tree looking for ITE expressions
		// we will be replacing the ITE expression with arg2 + arg3
		
//		Map<Node, Node> replacements = new LinkedHashMap<Node, Node>();
//		
//		for (Node node : TreeTraversal.getTreeAsList(root)) {
//			if (Parser.isFunctionInvocation(node) && Parser.getFunctionName(node).equalsIgnoreCase("IFTHENELSE")) {
//				replacements.put(node, transformExpression(node));
//			}
//		}
//		
//		for (Node original : replacements.keySet()) {
//			Node.replaceNode(original, replacements.get(original));
//		}
		
		
		return root;
	}
	
	private Node transformExpression(Node node) {
		// node is ITE invocation
		// turn it into arg2 + arg3
		Node arg2 = TreeTraversal.getFunctionArgument(node, 2);
		Node arg3 = TreeTraversal.getFunctionArgument(node, 3);
		Node root = new Node("+");
		
		root.setChild(arg2);
		arg2.setParent(root);
		arg3.setParent(root);
		
		arg2.setPrevious(null);
		arg3.setPrevious(arg2);
		
		arg2.setNext(arg3);
		arg3.setNext(null);
		
		
		return root;
	}
	
	public void setConditionVariablePolarity(PolarityResults polarityResults) {
		relationships.setConditionVariablePolarity(polarityResults);
	}

	public IfThenElseVariableRelationship getRelationships() {
		return relationships;
	}

	public Node getTransformedEquation() {
		return transformedEquation;
	}
}
