package gov.anl.gss.sdm.server.model.analysis.polarity;

public class PolarityCalculationResult {
	
	private int seqNo;
	private double lhs;
	double[] inputs;
	
	public PolarityCalculationResult(double lhs, int seqNo, double[] inputs) {
		this.lhs = lhs;
		this.seqNo = seqNo;
		this.inputs = inputs;
	}

	public int getSeqNo() {
		return seqNo;
	}

	public double getLhs() {
		return lhs;
	}

	public double[] getInputs() {
		return inputs;
	}
	
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("lhs="+lhs);
		sb.append(" seq="+seqNo);
		sb.append(" inputs: ");
		for (int i = 0; i < inputs.length; i++)
			sb.append(" "+inputs[i]);
		
		return sb.toString();
	}
	
	public int getNumInputs() {
		return inputs.length;
	}

}
