package gov.anl.gss.sdm.server.model.analysis.polarity;

public class VariableComplexityData {
	
	private String variable;
	private int in = 0;
	private int out = 0;
	
	private int inPos = 0;
	private int inNeg = 0;
	private int inUnk = 0;
	
	private int outPos = 0;
	private int outNeg = 0;
	private int outUnk = 0;
	
	private float inOutRation;
	
	public VariableComplexityData(String variable) {
		this.variable = variable;
	}
	
	public void processArrowPolarity(ArrowPolarity ap) {
		if (ap.getHead().equals(variable)) {
			in++;
			if (ap.isPositivePolarity())
				inPos++;
			else if (ap.isNegativePolarity())
				inNeg++;
			else
				inUnk++;
		} else {
			out++;
			if (ap.isPositivePolarity())
				outPos++;
			else if (ap.isNegativePolarity())
				outNeg++;
			else
				outUnk++;
		}
	}

	public String getVariable() {
		return variable;
	}

	public int getIn() {
		return in;
	}

	public int getOut() {
		return out;
	}

	public int getInPos() {
		return inPos;
	}

	public int getInNeg() {
		return inNeg;
	}

	public int getInUnk() {
		return inUnk;
	}

	public int getOutPos() {
		return outPos;
	}

	public int getOutNeg() {
		return outNeg;
	}

	public int getOutUnk() {
		return outUnk;
	}
	
	public double getInOutRatio() {
		return (double) in / (double) out;
	}
	
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(in+"|"+out);
		sb.append(" ");
		sb.append(inPos+"|"+inNeg+"|"+inUnk);
		sb.append(" ");
		sb.append(outPos+"|"+outNeg+"|"+outUnk);
		
		return sb.toString();
	}

}
