package gov.anl.gss.sdm.server.model.bridge;

import java.util.ArrayList;
import java.util.List;

public class BridgeNode {

        String variable;
        int level=0;
        boolean leaf=true;
        boolean visited = false; 
        List<BridgeNode> vertices = new ArrayList<BridgeNode>();
        List<String> polarities = new ArrayList<String>();

        public BridgeNode(String variable, int level) {
                        super();
                        this.variable = variable;
                        this.level = level;
        }

        public void addVertex(BridgeNode n, String polarity) {
                        vertices.add(n);
                        polarities.add(polarity);
                        leaf = false;
        }

		/**
		 * @return the variable
		 */
		public String getVariable() {
			return variable;
		}
		
		public String getVariableAndLevel() {
			return variable+"{"+level+"}";
		}

		/**
		 * @return the level
		 */
		public int getLevel() {
			return level;
		}

		/**
		 * @return the leaf
		 */
		public boolean isLeaf() {
			return leaf;
		}

		/**
		 * @return the visited
		 */
		public boolean isVisited() {
			return visited;
		}

		/**
		 * @return the vertices
		 */
		public List<BridgeNode> getVertices() {
			return vertices;
		}

		/**
		 * @param variable the variable to set
		 */
		public void setVariable(String variable) {
			this.variable = variable;
		}

		/**
		 * @param level the level to set
		 */
		public void setLevel(int level) {
			this.level = level;
		}

		/**
		 * @param leaf the leaf to set
		 */
		public void setLeaf(boolean leaf) {
			this.leaf = leaf;
		}

		/**
		 * @param visited the visited to set
		 */
		public void setVisited(boolean visited) {
			this.visited = visited;
		}

		/**
		 * @param vertices the vertices to set
		 */
		public void setVertices(List<BridgeNode> vertices) {
			this.vertices = vertices;
		}
		
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append(getVariableAndLevel()+" -> ");
			
			int index = 0;
			for (BridgeNode bn : getVertices()) {
				sb.append(" [ "+bn.getVariableAndLevel()+"{"+getPolarities().get(index)+"} ]");
				index++;
			}
			for (BridgeNode bn : getVertices()) {
				sb.append("\n"+bn.toString());
			}
			
			return sb.toString(); 
		}

		/**
		 * @return the polarities
		 */
		public List<String> getPolarities() {
			return polarities;
		}

		/**
		 * @param polarities the polarities to set
		 */
		public void setPolarities(List<String> polarities) {
			this.polarities = polarities;
		}

        
}

