package gov.anl.gss.sdm.server.model.bridge;

import java.io.Serializable;

/**
* @author Mary Ann Bitz
* Argonne National Laboratory
* Global Security Sciences Division 
*/
/**
 * Class to hold one of the variables used in a simulation model
 */
@SuppressWarnings("serial")
public abstract class Variable implements Serializable{
	private int position;
	private String name;
	private String description;
	private String units;
	private String displayName;
	private boolean included;

	public Variable() {
	}
	public Variable(int position,String name, String description,String units,String displayName, boolean included) {
		this.position=position;
		this.name = name;
		this.description=description;
		this.units=units;
		this.displayName=displayName;
		this.included=included;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getUnits() {
		return units;
	}
	public void setUnits(String units) {
		this.units = units;
	}
	
	public String getDisplayName() {
		return displayName;
	}
	public void setDisplayName(String displayName) {
		this.displayName = displayName;
	}
	public boolean isIncluded() {
		return included;
	}
	public void setIncluded(boolean included) {
		this.included = included;
	}

	public String toString(){
		return name;
	}
	public int getPosition() {
		return position;
	}
	public void setPosition(int position) {
		this.position = position;
	}
	public boolean canBeEdited(){
		return false;
	}
}
