package gov.anl.gss.sdm.server.model.documentor;

import gov.anl.gss.sdm.server.model.translator.Parser;

import java.util.List;

public class MultiValuePattern {
	
	private int numberCount;
	private int pctCount;
	private int lParenCount;
	private int rParenCount;
	private int lBrackCount;
	private int rBrackCount;
	private int barCount;
	private List<String> tokens;
	
	public MultiValuePattern(List<String> tokens) {
		this.tokens = tokens;
		parse(this.tokens);
		
	}
	
	public void parse(List<String> tokens) {
		for (String token : tokens) {
			if (Parser.isNumber(token))
				numberCount++;
			else if (Parser.isLeftParen(token))
				lParenCount++;
	
		else if (Parser.isPercent(token))
			pctCount++;
		else if (Parser.isRightParen(token))
			rParenCount++;
		else if (Parser.isLeftSquareBracket(token))
			lBrackCount++;
		else if (Parser.isRightSquareBracket(token))
			rBrackCount++;
		else if (Parser.isVerticalBar(token))
			barCount++;
		}
	}
	
	public int getNumMatched() {
		return numberCount + 
				pctCount +
				lParenCount +
				rParenCount +
				lBrackCount +
				rBrackCount +
				barCount;
	}

	public int getNumberCount() {
		return numberCount;
	}

	public int getPctCount() {
		return pctCount;
	}

	public int getlParenCount() {
		return lParenCount;
	}

	public int getrParenCount() {
		return rParenCount;
	}

	public int getlBrackCount() {
		return lBrackCount;
	}

	public int getrBrackCount() {
		return rBrackCount;
	}

	public int getBarCount() {
		return barCount;
	}

}
