package gov.anl.gss.sdm.server.model.documentor;

import gov.anl.gss.sdm.server.model.analysis.AnalysisManager;

import java.util.LinkedHashMap;
import java.util.Map;

public class VariableInformationFactory {
	
	private Map<String, VariableInformation> variablesInstantiated;

	public VariableInformationFactory() {
		variablesInstantiated = new LinkedHashMap<String, VariableInformation>();
	}
	
	public VariableInformation getVariableInformation(Documentor documentor, AnalysisManager am, String variableName) {
		if (!variablesInstantiated.containsKey(variableName)) {
			variablesInstantiated.put(variableName, new VariableInformation(documentor, am, variableName));
		}
		return variablesInstantiated.get(variableName);
	}
}
