package gov.anl.gss.sdm.server.model.documentor;

import gov.anl.gss.sdm.server.model.support.Utilities;
import gov.anl.gss.sdm.server.model.translator.Equation;
import gov.anl.gss.sdm.server.model.translator.InformationManagers;
import gov.anl.gss.sdm.server.model.translator.Parser;

import org.apache.log4j.Logger;

public class VariableNumberGenerator {
	
	static Logger log = Logger.getLogger(Parser.class.getSimpleName());
	
	public VariableNumberGenerator() {
		assignEquationNumbers();
		assignVariableNumbers();
	}
	
	private void assignEquationNumbers() {

		int num = 0; // 1
		for (String var : Utilities.ordered(InformationManagers.getInstance().getEquationManager().getLhsVariables())) {
			Equation eqn = InformationManagers.getInstance().getEquationManager().getEquationFor(var);
			if (eqn != null) {
				eqn.setEquationNumber(num++);

			} else {
				log.debug("No equation in EquationLookup for: "+var);
				System.out.println("No equation in EquationLookup for: "+var);
			}
		}
	}
	
	private void assignVariableNumbers() {
		
		// assign numbers to assignments only
		int num = 0;
		int nonAssignmentNum = -1;

		for (String variable : Utilities.ordered(InformationManagers.getInstance().getEquationManager().getVariables())) {
			boolean varNumSet = false;
			for (Equation eqn : InformationManagers.getInstance().getEquationManager().getAllEquationsFor(variable)) {
				if (eqn != null) {
					if (eqn.isAssignment() || eqn.isDefinesLookup() || InformationManagers.getInstance().getModelManager().isMap()) {
						if (num > InformationManagers.getInstance().getEquationManager().getNumberOfVariables()) {
							System.out.println("HOW?");
						}
						eqn.setVariableNumber(num);
//						System.out.println("variable "+variable+" eqn# "+eqn.getEquationNumber()+" var# "+num);
						varNumSet = true;
					} else {
						eqn.setVariableNumber(nonAssignmentNum--);
					}
				} else {
					log.debug("No equation in EquationManager for: "+variable);
					System.out.println("No equation in EquationLookup for: "+variable);
				}
			}
			if (varNumSet) {
				num++;
			}
		}
	}

}
