package gov.anl.gss.sdm.server.model.documentor.docx;


import gov.anl.gss.sdm.server.model.documentor.docx.writer.Reportable;

import java.util.List;

public class Table implements Reportable {
	
	private final String title;
	private final String[] columnHeaders;
	private final List<List<String>> tableData;
	
	public Table(String title, String[] columnHeaders, List<List<String>> tableData) {
		this.title = title;
		this.columnHeaders = columnHeaders;
		this.tableData = tableData;
	}

	public String getTitle() {
		return title;
	}

	public String[] getColumnHeaders() {
		return columnHeaders;
	}

	public List<List<String>> getTableData() {
		return tableData;
	}

	@Override
	public boolean isTable() {
		return true;
	}

	@Override
	public boolean isGraph() {
		return false;
	}

	@Override
	public Table getTable() {
		return this;
	}

	@Override
	public Graph getGraph() {
		return null;
	}

}
