package gov.anl.gss.sdm.server.model.documentor.gui;

import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class AboutFrame extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JFrame masterFrame;
	private JButtonLanguage yes;
	private static final String LICENSE_FILE = "./data/license.rtf";
	
	public AboutFrame() {
		create();
	}
	
	private void create() {
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		
		//Create and set up the window.
		final JFrame frame = new JFrame(language.getText(StringConstants.ABOUT));
		masterFrame = frame;
		frame.setPreferredSize(new SdmDimension(800, 800));
		frame.setLocation (0, 200) ;
		

		RTFViewer licensePanel = new RTFViewer();
		licensePanel.setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));
		licensePanel.loadRTF(LICENSE_FILE);
		frame.getContentPane().add(licensePanel, "Center");
		JPanel panel = new JPanel();
		yes = new JButtonLanguage(StringConstants.CLOSE);
		panel.add(yes);
		frame.getContentPane().add(panel, "South");
		
		yes.addActionListener(new ActionListener() {
        	@Override
        	public void actionPerformed(ActionEvent event) {
        		hidePanel();
        	}
        });
		
		
		frame.pack();
	}
	
	public void changeLanguage() {
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		masterFrame.setTitle(language.getText(StringConstants.ABOUT));
		yes.setText(language.getText(StringConstants.CLOSE));
	}
	
	public void showPanel() {
		masterFrame.setVisible(true);
	}
	
	public void hidePanel() {
		masterFrame.setVisible(false);
	}

}
