package gov.anl.gss.sdm.server.model.documentor.gui;

import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.UserSelectedOptions;

import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class CheckboxAssociatedTextField extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	// setText(SDMDocLanguageSpecific.getInstance().getText(t));

	private static final int TEXT_FIELD_SIZE = 5;

	private JLabelLanguage tfLabel = null;
	private JTextField tf = new JTextField(TEXT_FIELD_SIZE);
	private JCheckBoxLanguage cb = null;
	private String tfLabelText;

	public CheckboxAssociatedTextField(JCheckBoxLanguage cb, String tfLabelText) {
		this.cb = cb;
		tf = new JTextField(TEXT_FIELD_SIZE);
		tfLabel = new JLabelLanguage(tfLabelText);
		this.tfLabelText = tfLabelText;
		create();
	}
	
	public void setFonts(Font font) {
		tfLabel.setFont(font);
		tf.setFont(font);
		cb.setFont(font);
	}

	private void create() {

		GridBagConstraints c = new GridBagConstraints();

		int row = 0;
		c.fill = GridBagConstraints.NONE;
		c.anchor = GridBagConstraints.WEST;
		c.weightx = 1.0;
		c.weighty = 1.0;

		c.gridwidth = 1;
		c.gridy = row++;
		c.gridx = 0;
		c.insets = new Insets(0,20,0,0);
		add(tf, c);
		c.gridx = 1;
		add(tfLabel, c);
	}

	public void setDependencies() {
		if (cb.isSelected()) {
			tf.setEnabled(true);
		} else {
			tf.setEnabled(false);
		}

	}

	public void changeLanguage() {
		tfLabel.setText(tfLabelText);
	}

	public void setValues(UserSelectedOptions options) {
		tf.setText(options.getOptionValue(tfLabelText));
		setDependencies();
	}

	public boolean saveValues(UserSelectedOptions options) {
		
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		
		try {
			int max = Integer.parseInt(tf.getText().trim());
			if (max <= 1) {
				JOptionPane.showMessageDialog(null,
						language.getText(StringConstants.MAXIMUM_PATH_LENGTH_MUST_BE_AN_INTEGER)+" > 1."
						+ "\n"+language.getText(StringConstants.SPECIFIED_VALUE)+" <"+tf.getText()+">",
						language.getText(StringConstants.MAXIMUM_ENDOGENOUS_PATH_LENGTH), 
						JOptionPane.ERROR_MESSAGE);
				return false;
			}
			tf.setText(tf.getText().trim());
			options.setValue(tfLabelText, options.getOptionType(tfLabelText), tf.getText());
			return true;
		} catch (NumberFormatException e) {
			JOptionPane.showMessageDialog(null,
					language.getText(StringConstants.MAXIMUM_PATH_LENGTH_MUST_BE_AN_INTEGER)+" > 1."
							+ "\n"+language.getText(StringConstants.SPECIFIED_VALUE)+" <"+tf.getText()+">",
							language.getText(StringConstants.MAXIMUM_ENDOGENOUS_PATH_LENGTH), 
							JOptionPane.ERROR_MESSAGE);
			return false;
		}
		
		

	}
}
