package gov.anl.gss.sdm.server.model.documentor.gui;

import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.UserSelectedOptions;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class CodeGenerationOptionsFrame extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7587076607715192733L;

	private UserSelectedOptions userSelectedOptions;

	private UserSelectedOptions savedUserSelectedOptions;

	private JFrame frame;

	private CodeGenerationOptionsPanel cgop;

	public CodeGenerationOptionsFrame(UserSelectedOptions userSelectedOptions) {
		this.userSelectedOptions = userSelectedOptions;
		create();
	}
	private void create() {

		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		frame = new JFrame(language.getText(StringConstants.CODE_GENERATION_OPTIONS));
		frame.setPreferredSize(new SdmDimension(550, 250));
		frame.setLocation (50, 200) ;

		frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		frame.addWindowListener( new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent we) {
				quitButton();
			}
		} );

		
		
		JPanel panel = new JPanel();

		GridBagLayout grid = new GridBagLayout();
		panel.setLayout(grid);
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		
		cgop = new CodeGenerationOptionsPanel(this, StringConstants.CODE_GENERATION_OPTIONS);
		c.anchor = GridBagConstraints.FIRST_LINE_START;
		c.weightx = 1.0;
		c.weighty = 1.0;

		c.gridheight = 3;
		c.gridwidth = 1;
		c.gridx = 0;
		c.gridy = 0;
		panel.add(cgop, c);
		frame.add(panel);
		frame.pack();

	}

	public void changeLanguage() {
		frame.setTitle(SDMDocLanguageSpecific.getInstance().getText(StringConstants.CODE_GENERATION_OPTIONS));
		cgop.changeLanguage();
	}

	public void showPanel() {

		savedUserSelectedOptions = new UserSelectedOptions(userSelectedOptions);
		cgop.setValues();
		frame.setVisible(true);
	}

	public void saveButton() {
		savedUserSelectedOptions.copyFrom(userSelectedOptions);
		userSelectedOptions.save();
		cgop.setValues();

		//	hidePanel();
	}

	public void quitButton() {
		// on quit, restore to previous value
		userSelectedOptions.copyFrom(savedUserSelectedOptions);

		// need to restore to saved values
		cgop.setValues();


		hidePanel();
	}

	public void hidePanel() {

		cgop.setVisible(false);

		frame.setVisible(false);
	}

	public UserSelectedOptions getUserSelectedOptions() {
		return userSelectedOptions;
	}
}
