package gov.anl.gss.sdm.server.model.documentor.gui;

import java.util.Locale;
import java.util.ResourceBundle;

public class GUILanguageSpecific {

	
	private GUILanguageSpecific instance;
	private String language;
	private String country;
	private Locale locale;
	private ResourceBundle guiFileStrings;
	
	public GUILanguageSpecific(String language, String country) {
		this.language = language;
		this.country = country;
		this.locale = new Locale(language, country);
		this.guiFileStrings = ResourceBundle.getBundle("XmlFileStrings", locale);
	}
	
	public GUILanguageSpecific() {
		this("en", "US");
	}
	
	
	
	public GUILanguageSpecific getInstance() {
		if (instance == null) {
			instance = new GUILanguageSpecific();
		}
		return instance;
	}
	
	public String getText(String t) {
		return guiFileStrings.getString(t);
	}

	public String getLanguage() {
		return language;
	}

	public String getCountry() {
		return country;
	}

	public Locale getLocale() {
		return locale;
	}


}
