package gov.anl.gss.sdm.server.model.documentor.gui;

import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;
import gov.anl.gss.sdm.server.model.translator.Parser;

import javax.swing.InputVerifier;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

public class IntegerVerifier extends InputVerifier {
	
	String field = "No Field Specified";
	int min = -1 * Integer.MIN_VALUE;
	int max = Integer.MAX_VALUE;
	
	public IntegerVerifier(String f, int min, int max) {
		setField(f);
		setMin(min);
		setMax(max);
	}
	
	public void setRange(int minimum, int maximum) {
		setMin(minimum);
		setMax(maximum);
	}
	
         public boolean verify(JComponent input) {
             JTextField tf = (JTextField) input;
             String text = tf.getText();
             if (!Parser.isInteger(text)) {
            	 displayError(text);
            	 return false;
             }
             if (Integer.parseInt(text) >= min && Integer.parseInt(text) <= max) {
            	 return true;
             } else {
            	 displayError(text);
            	 return false;
             }
         }
         
         public void displayError(String text) {
        	 SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
        	 JOptionPane.showMessageDialog(null,
        			    field+" "+language.getText(StringConstants.MUST_BE_AN_INTEGER_IN_THE_RANGE)+": "+
        			    min+" - "+max,
        			    language.getText(StringConstants.INVALID)+" "+field,
        			    JOptionPane.ERROR_MESSAGE);
         }

		public void setField(String field) {
			this.field = field;
		}

		public void setMin(int min) {
			this.min = min;
		}

		public void setMax(int max) {
			this.max = max;
		}
}
