package gov.anl.gss.sdm.server.model.documentor.gui;

import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;

import javax.swing.JCheckBox;

public class JCheckBoxLanguage extends JCheckBox {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private ToolTip toolTip;

	public JCheckBoxLanguage(String l, String tip) {
		super(l);
		setToolTipKey(tip);
	}

	public JCheckBoxLanguage(String label) {
		super(label);
		setToolTipKey(label);
	}
	
	public void setText(String t, String extra) {
		
		if (t.trim().length() == 0)
			return;
		super.setText(SDMDocLanguageSpecific.getInstance().getText(t)+" "+extra);
		if (toolTip != null)
			toolTip.setText(this);
	}
	
	@Override
	public void setText(String t) {
		
		if (t.trim().length() == 0)
			return;
		super.setText(SDMDocLanguageSpecific.getInstance().getText(t));
		if (toolTip != null)
			toolTip.setText(this);
	}
	
	public void setToolTipKey(String key) {
		toolTip = new ToolTip(key);
		toolTip.setText(this);
	}
}
