package gov.anl.gss.sdm.server.model.documentor.gui;

import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;

import javax.swing.JMenuItem;

public class JMenuItemLanguage extends JMenuItem {

	private String language;
	private String displayName;
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private ToolTip toolTip;
	
	public JMenuItemLanguage(String displayName, String tip) {
		super(displayName);
		setToolTipKey(tip);
		this.displayName = displayName;
		language = SDMDocLanguageSpecific.getLanguageForDisplayName(displayName);
	}
	
	public JMenuItemLanguage(String displayName) {
		super(displayName);
		
		this.displayName = displayName;
		setToolTipKey(this.displayName);
		language = SDMDocLanguageSpecific.getLanguageForDisplayName(displayName);
	}
	
	@Override
	public void setText(String l) {
		super.setText(SDMDocLanguageSpecific.getInstance().getText(l));
		if (toolTip != null)
			toolTip.setText(this);
	}

	public String getLanguage() {
		return language;
	}

	public String getDisplayName() {
		return displayName;
	}

	public static long getSerialversionuid() {
		return serialVersionUID;
	}
	
	public void setToolTipKey(String key) {
		toolTip = new ToolTip(key);
		toolTip.setText(this);
	}


}
