package gov.anl.gss.sdm.server.model.documentor.gui;

import gov.anl.gss.sdm.server.model.analysis.loops.LoopDiscovery;
import gov.anl.gss.sdm.server.model.documentor.MessageProcessor;
import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;

import javax.swing.JOptionPane;
import javax.swing.SwingWorker;

public class LoopDiscoverWorker  extends SwingWorker<Void, Void> {
	
	private String arrowPolarityFileName;
	private String start;
	private String end;
	private MessageProcessor mf;
	final SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();

	public LoopDiscoverWorker(String arrowPolarityFileName, String start, String end, MessageProcessor mf) {
		this.arrowPolarityFileName = arrowPolarityFileName;
		this.start = start;
		this.end = end;
		this.mf = mf;
		
	}
	
	@Override
	protected Void doInBackground() throws Exception {
		try {
			
//			MessageFrame mf = new MessageFrame();
//			mf.addTimeStamp();
			
			final LoopDiscovery ld = new LoopDiscovery(
					arrowPolarityFileName, start, end, mf);
			ld.initialize(this);
			ld.doit();
			JOptionPane
					.showMessageDialog(
							null,
							language.getText(StringConstants.PROCESSING_COMPLETE),
							language.getText(StringConstants.PROCESSING_COMPLETE),
							JOptionPane.INFORMATION_MESSAGE);
			mf.disposeMessageFrame();
		} catch (Exception e) {
			String errMsg = e.toString();
			JOptionPane.showMessageDialog(null, errMsg,
					language.getText(StringConstants.INTERNAL_ERROR_DETECTED),
					JOptionPane.ERROR_MESSAGE);
			e.printStackTrace();
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
			
			return null;

	}
	

};
