package gov.anl.gss.sdm.server.model.documentor.gui;

import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;

import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class LoopLengthAnalysisToolDialog  extends SDMDocJDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private LoopLengthAnalysisToolPanel llatp;
	
	public LoopLengthAnalysisToolDialog(JFrame parent, String title, String helpFile) {
		super(parent, ModalityType.MODELESS, helpFile);
		
	doit();
}
	
	public LoopLengthAnalysisToolDialog(JFrame parent, String title) {
			super(parent, ModalityType.MODELESS);
			
		doit();
	}
	
	private void doit() {
		
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		 setTitle(language.getText(StringConstants.SDM_DOC_TOOL)+"/Java "+language.getText(StringConstants.VERSION)+
				 StandaloneGUI.version+" -- "+language.getDisplayName());

		 JPanel panel = new JPanel();
		this.getContentPane().add(panel);
		
		addInformationMenu(this);
		setJMenuBar(myMenubar);
		 
		 
		panel.setPreferredSize(new SdmDimension(600, 250));
		 setLocation (0, 200) ;
	        
		 llatp = new LoopLengthAnalysisToolPanel(this);
		 add(llatp);
		 
		 addWindowListener(new WindowAdapter() 
		 {
		   public void windowClosed(WindowEvent e)
		   {
		     System.out.println("jdialog window closed event received");
		     llatp.removeMessageFrame();
		   }

		   public void windowClosing(WindowEvent e)
		   {
		     System.out.println("jdialog window closing event received");
		     llatp.removeMessageFrame();
		   }
		 });
	        
	      //Display the window.
	      pack();
	      setVisible(true);
	      setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	}

}
