package gov.anl.gss.sdm.server.model.documentor.gui;

import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;

import java.awt.Component;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;

public class MultiLineButtonLanguage extends JButton {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private List<JLabelLanguage> labels;
	private List<String> labelsKey;
	private List<String> tipsKey;
	private ToolTip toolTip;
	
	public MultiLineButtonLanguage() {
		super();
		labels = new ArrayList<JLabelLanguage>();
		labelsKey = new ArrayList<String>();
		tipsKey = new ArrayList<String>();
		
		GridBagLayout grid = new GridBagLayout();
		setLayout(grid);
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.NONE;
	}
	
	public void addLine(String text) {
		
		GridBagConstraints c = new GridBagConstraints();
//		c.fill = GridBagConstraints.BOTH;
//		c.anchor = GridBagConstraints.CENTER;
		
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		JLabelLanguage aLabel = new JLabelLanguage(text);
		aLabel.setAlignmentX(Component.CENTER_ALIGNMENT);
		aLabel.setFont(language.getFont(Font.PLAIN, SDMDocFont.MEDIUM));
		labels.add(aLabel);
		
		final JButton thisButton = this;
		
		aLabel.addMouseListener(new MouseAdapter() {
             @Override
             public void mouseClicked(MouseEvent e) {
                 thisButton.doClick();
             }

         });
		
		c.weighty = 1.0;
		c.weightx = 1.0;
		c.gridx = 0;
		c.gridy = labels.size()-1;
		add(aLabel, c);
		
		labelsKey.add(text);
		tipsKey.add(text);
		addToolTipKey(text);
	}
	
	private void addToolTipKey(String text) {
		if (toolTip == null) {
			toolTip = new ToolTip(text);
		} else {
			toolTip = new ToolTip(toolTip.getToolTipKey()+"+"+text);
		}
		toolTip.setText(this);
	}
	
	@Override
	public void setText(String l) {
		super.setText(SDMDocLanguageSpecific.getInstance().getText(l));
		if (toolTip != null)
			toolTip.setText(this);
	}
	
	public void setToolTipKey(String key) {
		toolTip = new ToolTip(key);
		toolTip.setText(this);
	}
	
	public void changeLanguage() {
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		for (int i = 0; i < labels.size(); i++) {
			JLabelLanguage jll = labels.get(i);
			jll.setFont(language.getFont(Font.PLAIN, SDMDocFont.MEDIUM));
			String key = labelsKey.get(i);
			jll.setText(key);
		}
	}
}
