package gov.anl.gss.sdm.server.model.documentor.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.text.BadLocationException;
import javax.swing.text.rtf.RTFEditorKit;

public class RTFViewer extends JPanel {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	RTFEditorKit rtf = null;
	JEditorPane editor = null;
	
	public RTFViewer() {
	   
	    setLayout(new BorderLayout());

	    // Create an RTF editor window
	    rtf = new RTFEditorKit();
	    editor = new JEditorPane();
	    editor.setEditorKit(rtf);
	    editor.setBackground(Color.white);

	    // This text could be big so add a scroll pane
	    JScrollPane scroller = new JScrollPane();
	    scroller.getViewport().add(editor);
	    add(scroller, BorderLayout.CENTER);
	}

	public boolean loadRTF(String file) {
	    // Load an RTF file into the editor
	    try {
	      FileInputStream fi = new FileInputStream(file);
	      rtf.read(fi, editor.getDocument(), 0);
	      return true;
	    } catch (FileNotFoundException e) {
	      System.out.println("File not found");
	      return false;
	    } catch (IOException e) {
	      System.out.println("I/O error");
	      return false;
	    } catch (BadLocationException e) {
	    	return false;
	    }
	}
}
