package gov.anl.gss.sdm.server.model.documentor.gui;

import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JDialog;
import javax.swing.JMenuBar;

public class SDMDocJDialog extends JDialog {


	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	protected JMenuBar myMenubar = new JMenuBar();
	protected String helpFile;
	protected static String helpFileDirectory = "data/screenImages/";
	
	protected JButtonLanguage information;

	public String getHelpFile() {
		return helpFileDirectory+helpFile;
	}
	
	public SDMDocJDialog(Frame parent, String helpFile) {
		super(parent, ModalityType.MODELESS);
		this.helpFile = helpFile;
	}

	public SDMDocJDialog(Frame parent) {
		super(parent, ModalityType.MODELESS);
	}

	public SDMDocJDialog(Frame parent, ModalityType t) {
		super(parent, t);
	}
	
	public SDMDocJDialog(Frame parent, ModalityType t, String helpFile) {
		super(parent, t);
		this.helpFile = helpFile;
	}
	
	
	public void changeLanguage(String title) {
		setTitle(title);
		if (information != null)
			information.setText(StringConstants.INFORMATION);
	}

	public void addInformationMenu(SDMDocJDialog dialog) {
		if (dialog.getJMenuBar() == null) {
			dialog.setJMenuBar(dialog.myMenubar);
		}
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		myMenubar.add(Box.createHorizontalGlue());
		
		JButtonLanguage information = new JButtonLanguage(StringConstants.INFORMATION);
		information.setFont(language.getFont(Font.PLAIN, SDMDocFont.MEDIUM));
		information.setFocusable(false);
		information.setBackground(Color.white);
		

		final SDMDocJDialog ff = dialog;
		
		information.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				ImageDisplay disp = new ImageDisplay(ff.getHelpFile());
			}
		});
		
		myMenubar.add(information);

	}
}
