package gov.anl.gss.sdm.server.model.documentor.gui;

import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;

public class SDMDocJFrame extends JFrame {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected JMenuBar myMenubar = new JMenuBar();
	protected String helpFile = null;
	protected static String helpFileDirectory = "data/screenImages/";
	protected JButtonLanguage information; 

	public String getHelpFile() {
		return helpFileDirectory+helpFile;
	}

	public SDMDocJFrame(String title, String helpFile) {
		super(title);
		this.helpFile = helpFile;
		setBackground();
	}
	
	public SDMDocJFrame(String title) {
		super(title);
		setBackground();
	}

	public SDMDocJFrame() {
		// TODO Auto-generated constructor stub
		setBackground();
	}

	public SDMDocJFrame(String[] args) {
		// TODO Auto-generated constructor stub
		setBackground();
	}
	
	public void changeLanguage(String title) {
		setTitle(title);
		if (information != null)
			information.setText(StringConstants.INFORMATION);
	}
	
	public void setBackground() {
		myMenubar.setBackground(Color.white);
	}
	
	public void addInformationMenu() {
		if (getJMenuBar() == null) {
			setJMenuBar(myMenubar);
		}
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		myMenubar.add(Box.createHorizontalGlue());
//		final JButtonLanguage information = new JButtonLanguage(StringConstants.INFORMATION);
		information = new JButtonLanguage(StringConstants.INFORMATION);
		information.setBackground(Color.white);
		information.setFocusable(false);
		information.setFont(language.getFont(Font.PLAIN, SDMDocFont.MEDIUM));

		
		final SDMDocJFrame ff = this;
		
		information.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				ImageDisplay disp = new ImageDisplay(ff.getHelpFile());
			}
		});
		
		myMenubar.add(information);
//		myMenubar.add(screen);
	}
	
	public void addInformationMenu(SDMDocJFrame frame) {
		if (frame.getJMenuBar() == null) {
			frame.setJMenuBar(frame.myMenubar);
		}
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		frame.myMenubar.add(Box.createHorizontalGlue());
//		final JButtonLanguage information = new JButtonLanguage(StringConstants.INFORMATION);
		frame.information = new JButtonLanguage(StringConstants.INFORMATION);
		frame.information.setBackground(Color.white);
		frame.information.setFocusable(false);
		frame.information.setFont(language.getFont(Font.PLAIN, SDMDocFont.MEDIUM));

		
		final SDMDocJFrame ff = frame;
		
		frame.information.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent event) {
				ImageDisplay disp = new ImageDisplay(ff.getHelpFile());
			}
		});
		
		frame.myMenubar.add(frame.information);
//		myMenubar.add(screen);
	}
	}