package gov.anl.gss.sdm.server.model.documentor.gui;

import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;

import java.awt.Cursor;
import java.awt.Dimension;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class VariableNameTranslatorDialog  extends SDMDocJDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	public VariableNameTranslatorDialog(JFrame parent, String title, String mode, String helpFile) {
		
		super(parent, ModalityType.DOCUMENT_MODAL, helpFile);
	doit(mode);
}
	
	public VariableNameTranslatorDialog(JFrame parent, String title, String mode) {
		
			super(parent, ModalityType.DOCUMENT_MODAL);
		doit(mode);
	}
	
	private void doit(String mode) {
		
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		 setTitle(language.getText(StringConstants.SDM_DOC_TOOL)+"/Java "+language.getText(StringConstants.VERSION)+
				 StandaloneGUI.version+" -- "+language.getDisplayName());

		 JPanel panel = new JPanel();
			this.getContentPane().add(panel);
			
			addInformationMenu(this);
			setJMenuBar(myMenubar);
		 
		 if (mode.equals(StringConstants.EXTRACT_VARIABLE_NAMES)) {
			 panel.setPreferredSize(new SdmDimension(600, 200));
		 } else {
			 panel.setPreferredSize(new SdmDimension(600, 250));
		 }
		 setLocation (0, 200) ;
	        
		 add(new VariableNameTranslatorPanel(this, StringConstants.VARIABLE_NAMES_TRANSLATOR, mode));
	        
	      //Display the window.
	      pack();
	      setVisible(true);
	      setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	}

}
