package gov.anl.gss.sdm.server.model.documentor.plots;

import gov.anl.gss.sdm.server.model.support.ExcelManager;
import gov.anl.gss.sdm.server.model.support.SDFunctionsWithXLSColt;
import gov.anl.gss.sdm.server.model.support.TimeSeriesInstance;
import gov.anl.gss.sdm.server.model.support.Utilities;
import gov.anl.gss.sdm.server.model.translator.InformationManagers;
import gov.anl.gss.sdm.server.model.translator.Parser;

import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class GetXlsLookups {

	private TimeSeriesInstance tsi;
	private String workbook;
	private String tab;
	private String colOrRow;
	private String startCell;
	
	private boolean xlsReadable;

	private int num;

	private int numCols;
	private int numRows;

	// 3 Attacker Capability = {Low, Medium, High }
	// 3 Attacker Type = {Individual, Group, Network}


	//	Influence of Attackers' Relative Success on Motivation Table[Attacker Capability,Individual]=
	//		GET XLS LOOKUPS( 'Model Definition.xlsx', 'Production Data', 'A', 'B224') ~~|
	//		
	//		Influence of Attackers' Relative Success on Motivation Table[Attacker Capability,Group](
	//			GET XLS LOOKUPS( 'Model Definition.xlsx', 'Production Data', 'A', 'B238')) ~~|
	//		Influence of Attackers' Relative Success on Motivation Table[Attacker Capability,Network](
	//			GET XLS LOOKUPS( 'Model Definition.xlsx', 'Production Data', 'A', 'B252'))
	//			~	Dmnl
	//			~		|

	//	TimeSeriesInstance _ts2 = sdFunctions.GETXLSLOOKUPS(
	//			"Scenario Definition.xlsx", "Production Data", "A", "B183",
	//			numRows, numColumns);

	public GetXlsLookups(String book, String tabName, String timeRowOrCol, String cell, int num) {
		this.workbook = book;
		this.tab = tabName;
		this.colOrRow = timeRowOrCol;
		this.startCell = cell;
		
		// first verify that the workbook has the requested tabName. We know the workbook exists.
//		XSSFWorkbook wb = WorkbookUtils.openWorkbook(book);
//		XSSFSheet sheet = wb.getSheet(tab);
//		if (sheet == null) {
//			tsi = null;
//		} else {
			
		
		// num = number of rows or columns of data to grab
		
		this.num = num;
		boolean byRow = Parser.isInteger(timeRowOrCol);
		if (byRow) {
			this.numRows = num;
			this.numCols = 1;
		} else {
			this.numRows = 1;
			this.numCols = num;
		}

		int effectiveStartCellRow = Utilities.getRowFromCellAddress(startCell);
		int effectiveStartCellCol = Utilities.getColumnFromCellAddress(startCell);
		
		ExcelManager em = InformationManagers.getInstance().getExcelManager();
		XSSFWorkbook wb = em.openWorkbook(workbook);
		
			tsi = SDFunctionsWithXLSColt.GETXLSLOOKUPS(wb, tab, colOrRow, effectiveStartCellRow, effectiveStartCellCol, numRows, numCols);
//		}
		
	}

	public TimeSeriesInstance getLookupData() {
		return tsi;
	}

	/**
	 * @return the xlsReadable
	 */
	public boolean isXlsReadable() {
		return xlsReadable;
	}


}
