package gov.anl.gss.sdm.server.model.documentor.plots;

import gov.anl.gss.sdm.server.model.translator.Equation;

import java.util.LinkedHashMap;
import java.util.Map;

public class PlotManager {

	private static final String LOOKUP = "Lookup";
	private static final String MODEL = "Model";
	private static final String ALL_VIEWS = "Views";
	private static final String VIEW = "View";
	
	private static Map<Equation, String> lookupEquationToFile = new LinkedHashMap<Equation, String>();
	
	private static String viewsBarchartFile = null;
	private static String modelFile = null;
	
	private static Map<String, String> viewToFile = new LinkedHashMap<String, String>();
	
	public static boolean haveLookup(Equation eqn) {
		return lookupEquationToFile.containsKey(eqn);
	}
	
	public static boolean haveAllViews() {
		return viewsBarchartFile != null && viewsBarchartFile.length() > 0;
	}
	
	public static boolean haveView(String view) {
		return viewToFile.containsKey(view);
	}
	
	public static boolean haveModel() {
		return modelFile != null && modelFile.length() > 0;
	}
	
	public static void registerLookup(Equation eqn, String file) {
		lookupEquationToFile.put(eqn, file);
	}
	
	public static void registerAllViews(String file) {
		viewsBarchartFile = new String(file);
	}
	
	public static void registerView(String view, String file) {
		viewToFile.put(view, file);
	}
	
	public static void registerModel(String file) {
		modelFile = new String(file);
	}
	
	public static String getModelFile() {
		return modelFile;
	}
	
	public static String getAllViewsFile() {
		return viewsBarchartFile;
	}
	
	public static String getViewFile(String view) {
		return viewToFile.get(view);
	}
	
	public static String getLookupFile(Equation eqn) {
		return lookupEquationToFile.get(eqn);
	}
}
