package gov.anl.gss.sdm.server.model.documentor.plots;

import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.UserSelectedOptions;

public class PlotOptions {
	
	private int width;
	private int height;
	
	private int leftMargin;
	private int bottomMargin;
	
	private int fontSize;
	
	private int viewWidthPct;
	
	private boolean highlight;
	
	private int highlightx;
	private int highlighty;
	
	public PlotOptions(int width, int height, int leftMargin, int bottomMargin, int fontSize,  int viewWidthPct,
			boolean highlight, int highlightx, int highlighty) {
		
		this.width = width;
		this.height = height;
		this.leftMargin = leftMargin;
		this.bottomMargin = bottomMargin;
		this.fontSize = fontSize;
		this.viewWidthPct = viewWidthPct;
		this.highlight = highlight;
		this.highlightx = highlightx;
		this.highlighty = highlighty;
	}
	
	public PlotOptions(UserSelectedOptions options) {
		this.width = Integer.parseInt(options.getOptionValue(StringConstants.WIDTH));
		this.height = Integer.parseInt(options.getOptionValue(StringConstants.HEIGHT));
		this.leftMargin = Integer.parseInt(options.getOptionValue(StringConstants.LEFT_MARGIN));
		this.bottomMargin = Integer.parseInt(options.getOptionValue(StringConstants.BOTTOM_MARGIN));
		this.fontSize = Integer.parseInt(options.getOptionValue(StringConstants.FONT_SIZE));
		this.viewWidthPct = Integer.parseInt(options.getOptionValue(StringConstants.VIEW_WIDTH_MAX));
		this.highlight = Boolean.parseBoolean(options.getOptionValue(StringConstants.HIGHLIGHT_POINT));
		this.highlightx = Integer.parseInt(options.getOptionValue(StringConstants.HIGHLIGHT_POINT_X));
		this.highlighty = Integer.parseInt(options.getOptionValue(StringConstants.HIGHLIGHT_POINT_Y));
	}
	
	
	
	public int getWidth() {
		return width;
	}
	public int getHeight() {
		return height;
	}
	public int getLeftMargin() {
		return leftMargin;
	}
	public int getBottomMargin() {
		return bottomMargin;
	}
	public int getFontSize() {
		return fontSize;
	}
	public int getViewWidthPct() {
		return viewWidthPct;
	}
	public boolean isHighlight() {
		return highlight;
	}
	public int getHighlightx() {
		return highlightx;
	}
	public int getHighlighty() {
		return highlighty;
	}
}
