package gov.anl.gss.sdm.server.model.documentor.plots;

import java.awt.Color;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStream;

import javax.imageio.ImageIO;

import org.apache.log4j.Logger;
import org.jfree.chart.JFreeChart;
import org.jfree.data.xy.XYSeriesCollection;


public class ThumbnailPlot /* extends ApplicationFrame */ {
static Logger log = Logger.getLogger(ThumbnailPlot.class.getSimpleName());
	
	
	Color[] colors = {Color.black, Color.red, Color.blue, Color.green, Color.magenta, Color.cyan, Color.orange, Color.pink};
	
	private String fileName;
	private String fileNameRelative;
	private XYSeriesCollection dataset;
	
	 boolean addedHighlight = false;
	
	public ThumbnailPlot(XYSeriesCollection dataset, String fileName) {
		
		this.fileName = fileName;
		// make sure directories exist
		new File(fileName).getParentFile().mkdirs();
		this.dataset = dataset;
		
	}
	
	public void generate() {
		
//		SimpleLinePlot slp = new SimpleLinePlot(createDataset());
		SimpleLinePlot slp = new SimpleLinePlot(dataset);

		OutputStream out = null;
		try {
			out = new FileOutputStream(new File(fileName));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		writeAsPNG( slp.getChart(), out, 300,  100 ); // 500,  270 // 200, 100
		}
	

	public Color colorSelector(int i) {
		return colors[i % colors.length];
	}

	/**
	 * Starting point for the demonstration application.
	 *
	 * @param args  ignored.
	 */
	public static void main(final String[] args) {

		final ThumbnailPlot demo = new ThumbnailPlot(null, "thumb.png");
	}

	public void writeAsPNG( JFreeChart chart, OutputStream out, int width, int height )
	{
		try
		{
			BufferedImage chartImage = chart.createBufferedImage( width, height, null);
			ImageIO.write( chartImage, "png", out );
		}
		catch (Exception e)
		{
			log.debug(e);
		}
	}

	public String getFileName() {
		return fileName;
	}

	public String getFileNameRelative() {
		return fileNameRelative;
	} 
}
