package gov.anl.gss.sdm.server.model.documentor.xmlwriter;

import gov.anl.gss.sdm.server.model.analysis.polarity.ArrowPolarity;
import gov.anl.gss.sdm.server.model.documentor.GetRowData;
import gov.anl.gss.sdm.server.model.documentor.GetXML;
import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.TableUtilities;

import java.io.BufferedWriter;
import java.util.List;

public class ArrowListTableRow implements GetXML, GetRowData {
	
	protected static final String HEADER = "<tr>\n";
	protected static final String FOOTER = "</tr>\n";
	
	protected static final String ROW_HEADER = "<td style='text-align:center'>";
	protected static final String ROW_FOOTER = "</td>";
	
	protected static final String VARIABLE_HEADER = "<td>";
	protected static final String VARIABLE_FOOTER = "</td>";
	
	protected ArrowPolarity arrowPolarity;
	
	public ArrowListTableRow(ArrowPolarity arrowPolarity) {
		this.arrowPolarity = arrowPolarity;
	}
	
	public boolean getXML(BufferedWriter sb) {
		return true;
	}
	
	public String getXML() {
		
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		StringBuilder sb = new StringBuilder();
		
			sb.append(HEADER);
			sb.append(ROW_HEADER+"$$$LISTNAME$$$"+Anchors.getAnchorReference(arrowPolarity.getTail())+ROW_FOOTER);
			sb.append(ROW_HEADER+Anchors.getAnchorReference(arrowPolarity.getHead())+ROW_FOOTER);
			sb.append(ROW_HEADER+language.getTextHtmlNoMissingArrowPolarity(arrowPolarity.getPolarity())+ROW_FOOTER);
			sb.append(FOOTER);
		return sb.toString();
	}

	public ArrowPolarity getArrowPolarity() {
		return arrowPolarity;
	}

	@Override
	public List<List<String>> getRowData() {
		List<List<String>> row = TableUtilities.createRow();
		TableUtilities.addColumn(row, TableUtilities.createColumn(arrowPolarity.getTail()));
		TableUtilities.addColumn(row, TableUtilities.createColumn(arrowPolarity.getHead()));
		TableUtilities.addColumn(row, TableUtilities.createColumn(arrowPolarity.getPolarity()));
		return row;
	}

	@Override
	public List<List<List<String>>> getTableData() {
		// TODO Auto-generated method stub
		return null;
	}

}
