package gov.anl.gss.sdm.server.model.documentor.xmlwriter;

import gov.anl.gss.sdm.server.model.support.MutableInteger;

public class ColumnSizing {

	private long loopCountMax;
	private double percentageMax;
	private long posCountMax;
	private long posRangeMin;
	private long posRangeMax;

	private long negCountMax;
	private long negRangeMin;
	private long negRangeMax;

	private long prbCountMax;
	private long prbRangeMin;
	private long prbRangeMax;

	private MutableInteger loopCountMaxSize = new MutableInteger();
	private MutableInteger percentageMaxSize = new MutableInteger();
	private MutableInteger posCountMaxSize = new MutableInteger();
	private MutableInteger posRangeMinSize = new MutableInteger();
	private MutableInteger posRangeMaxSize = new MutableInteger();

	private MutableInteger negCountMaxSize = new MutableInteger();
	private MutableInteger negRangeMinSize = new MutableInteger();
	private MutableInteger negRangeMaxSize = new MutableInteger();

	private MutableInteger prbCountMaxSize = new MutableInteger();
	private MutableInteger prbRangeMinSize = new MutableInteger();
	private MutableInteger prbRangeMaxSize = new MutableInteger();

	public ColumnSizing(long loopCountMax2, double percentageMax, long posCountMax, long posRangeMin, long posRangeMax,
			long negCountMax,long negRangeMin, long negRangeMax, long prbCountMax, long prbRangeMin, long prbRangeMax) {
		this.loopCountMax = loopCountMax2;
		this.percentageMax = percentageMax;
		this.posCountMax = posCountMax;
		this.posRangeMin = posRangeMin;
		this.posRangeMax = posRangeMax;

		this.negCountMax = negCountMax;
		this.negRangeMin = negRangeMin;
		this.negRangeMax = negRangeMax;

		this.prbCountMax = prbCountMax;
		this.prbRangeMin = prbRangeMin;
		this.prbRangeMax = prbRangeMax;
		
		computeSizes();
	}
	
	private void computeSizes() {
		computeSize(loopCountMax,loopCountMaxSize);
		computeSize(percentageMax,percentageMaxSize);
		computeSize(posCountMax,posCountMaxSize);
		computeSize(posRangeMin,posRangeMinSize);
		computeSize(posRangeMax,posRangeMaxSize);

		computeSize(negCountMax,negCountMaxSize);
		computeSize(negRangeMin,negRangeMinSize);
		computeSize(negRangeMax,negRangeMaxSize);

		computeSize(prbCountMax,prbCountMaxSize);
		computeSize(prbRangeMin,prbRangeMinSize);
		computeSize(prbRangeMax,prbRangeMaxSize);
	}


	private void computeSize(int value, MutableInteger size) {
		int s = 1;
		if (value >= 10) s=2;
		if (value >= 100) s=3;
		if (value >= 1000) s=5;
		if (value >= 10000) s=6;
		if (value >= 100000) s=7;
		if (value >= 1000000) s=8;
		size.setValue(s);

	}

	private void computeSize(double value, MutableInteger size) {
		int s = 3;
		if (value >= 10.0) s = 4;
		if (value >= 100.0) s = 5;
		size.setValue(s);
	}


	public int getLoopCountMaxSize() {
		return loopCountMaxSize.value();
	}


	public int getPercentageMaxSize() {
		return percentageMaxSize.value();
	}


	public int getPosCountMaxSize() {
		return posCountMaxSize.value();
	}


	public int getPosRangeMinSize() {
		return posRangeMinSize.value();
	}


	public int getPosRangeMaxSize() {
		return posRangeMaxSize.value();
	}


	public int getNegCountMaxSize() {
		return negCountMaxSize.value();
	}


	public int getNegRangeMinSize() {
		return negRangeMinSize.value();
	}


	public int getNegRangeMaxSize() {
		return negRangeMaxSize.value();
	}


	public int getPrbCountMaxSize() {
		return prbCountMaxSize.value();
	}


	public int getPrbRangeMinSize() {
		return prbRangeMinSize.value();
	}


	public int getPrbRangeMaxSize() {
		return prbRangeMaxSize.value();
	}

}
