package gov.anl.gss.sdm.server.model.documentor.xmlwriter;

import gov.anl.gss.sdm.server.model.documentor.GetXML;
import gov.anl.gss.sdm.server.model.documentor.HTMLConstants;
import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;

import java.io.BufferedWriter;
import java.util.List;


public class DocumentHeader implements GetXML {

	public static String HEADER = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n"+
			"$$$HTML$$$\n" +
			"<head>\n" +
			"<meta http-equiv='Content-Type' content='Type=text/html; charset=$$$HTMLCHARSET$$$'>\n";
	public static String STYLE = "<style type='text/css'>\n" +
			"table.nolines {\n" +
			"border-width: 3px;\n" +
			"border-spacing: 0px;\n" +
			"border-collapse: collapse;\n" +
			"border-style: none;\n" +
			"border-color: red;\n" +
			"background-color: White;\n" +
			"}\n" +
			"table.nolines th        {\n" +
			"font-size: smaller;\n" +
			"background-color:blue;\n" +
			"color:White;\n" +
			"border-style: none;\n" +
			"border-width: 0px;\n" +
			"}\n" +
			"table.nolines td {\n" +
			"border-style: none;\n" +
			"vertical-align:top;\n" +
			"font-size:smaller;\n" +
			"border-width: 3px;\n" +
			"padding: 0px 0px 0px 0px;\n" +
			"border-color: green;\n" +
			"background-color: green;\n" +
			"text-align:left;\n" +
			"}\n" +
			"table.results {\n" +
			"border-width: 1px;\n" +
			"border-spacing: 0px;\n" +
			"border-collapse: collapse;\n" +
			"border-style: solid;\n" +
			"border-color: gray;\n" +
			"background-color: White;\n" +
			"}\n" +
			"table.results th        {\n" +
			"font-size: smaller;\n" +
			"background-color:blue;\n" +
			"color:White;\n" +
			"border-style: solid;\n" +
			"border-width: 1px;\n" +
			"}\n" +
			"table.results td {\n" +
			"border-style: solid;\n" +
			"vertical-align:top;\n" +
			"font-size:smaller;\n" +
			"border-width: 1px;\n" +
			"padding: 0px 5px 0px 5px;\n" +
			"border-color: gray;\n" +
			"background-color: White;\n" +
			"text-align:left;\n" +
			"}\n" +
			"table.sample {\n" +
			"min-width: 400px;\n" +
			"border-width: 1px;\n" +
			"border-spacing: 0;\n" +
			"border-style: outset;\n" +
			"border-color: gray;\n" +
			"border-collapse: collapse;\n" +
			"}\n" +
			"table.sample td {\n" +
			"font-size:smaller;\n" +
			"border-width: 1px;\n" +
			"padding: 0px 5px 0px 5px;\n" +
			"border-style: solid;\n" +
			"border-color: gray;\n" +
			"text-align:left;\n" +
			"vertical-align:text-top;\n" +
			"}\n" +
			"table.sampleborder {\n" +
			"min-width: 400px;\n" +
			"border-width: 1px;\n" +
			"border-spacing: 0;\n" +
			"border-style: outset;\n" +
			"border-color: gray;\n" +
			"border-collapse: collapse;\n" +
			"}\n" +
			"table.sampleborder tr td:nth-child(4) { font-family:Consolas; }\n"+
			"table.sampleborder tr td:nth-child(5) { font-family:Consolas; }\n"+
			"table.sampleborder tr td:nth-child(6) { font-family:Consolas; }\n"+
			"table.sampleborder tr td:nth-child(7) { font-family:Consolas; }\n"+
			"table.sampleborder tr td:nth-child(8) { font-family:Consolas; }\n"+
			"table.sampleborder tr td:nth-child(9) { font-family:Consolas; }\n"+
			"table.sampleborder tr td:nth-child(10) { font-family:Consolas; }\n"+
			"table.sampleborder tr td:nth-child(11) { font-family:Consolas; }\n"+
			"table.sampleborder tr td:nth-child(12) { font-family:Consolas; }\n"+
			"table.sampleborder tr td:nth-child(13) { font-family:Consolas; }\n"+
			"table.sampleborder td {\n" +
			"font-size:smaller;\n" +
			"border-width: 1px;\n" +
			"padding: 0px 5px 0px 5px;\n" +
			"border-style: solid;\n" +
			"border-color: gray;\n" +
			"text-align:left;\n" +
			"vertical-align:text-top;\n" +
			"}\n" +
			"table.typeLegend {\n" +
			"border-width: 1px;\n" +
			"border-spacing: 0;\n" +
			"border-style: outset;\n" +
			"border-color: gray;\n" +
			"border-collapse: collapse;\n" +
			"background-color: white;\n" +
			"}\n" +
			"table.typeLegend td {\n" +
			"font-size:smaller;\n" +
			"border-width: 1px;\n" +
			"padding: 0px 5px 0px 5px;\n" +
			"border-style: solid;\n" +
			"padding: 0px 5px 0px 5px;\n" +
			"border-style: solid;\n" +
			"border-color: gray;\n" +
			"background-color: #f8f8ff;\n" +
			"text-align:left;\n" +
			"}\n" +
			"ul.specials li {\n" +
			"color:white;\n" +
			"}\n" +
			"ul.specials li span {\n" +
			"color:navy;\n" +
			"}\n" +
			"ul.footnote li {\n" +
			"font-size: normal;\n" +
			"}\n" +
			".verticaltext {\n" +
			"writing-mode: tb-rl;\n" +
			"filter: flipv fliph;\n" +
			"}\n" +
			"ul\n" +
			"{\n" +
			"list-style: disc;\n" +
			"margin-top: 0;\n" +
			"}\n" +
			"</style>\n" +
			"</head>\n";
	
	private static String TITLE_START = "<title>Documentation of ";
	private static String TITLE_END = "</title>\n";
	
	private static String MODEL_NAME_TAG = "$$$MODEL_NAME$$$";
	private static String TITLE_TAG = "$$$DOCOF$$$";
	
	private static String TITLE_MAIN = "<center>$$$ADEF$$$<h2 style='color:Blue'><br/>$$$DOCOF$$$ " +HTMLConstants.UNDERLINE_START
			+ "$$$MODEL_NAME$$$"+HTMLConstants.UNDERLINE_END+"</span></h2></center>";


	private String modelName;

	public DocumentHeader(String modelName) {
		this.modelName = modelName;
	}
	
	public boolean getXML(BufferedWriter sb) {
		return true;
	}

	public String getXML() {
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		StringBuilder sb = new StringBuilder();
		// "+SDMDocLanguageSpecific.getInstance().getHtmlCharSet()+"
		sb.append(HEADER.replace("$$$HTMLCHARSET$$$", 
				SDMDocLanguageSpecific.getInstance().getHtmlCharSet()).replace("$$$HTML$$$", 
						SDMDocLanguageSpecific.getInstance().getHtmlHeader()));
		sb.append(TITLE_START+modelName+TITLE_END);
		sb.append(STYLE);
		sb.append(TITLE_MAIN.replace(MODEL_NAME_TAG, modelName).replace(TITLE_TAG, language.getTextHtml(StringConstants.DOCUMENTATION_OF)));


		return sb.toString();
	}

	@Override
	public List<List<List<String>>> getTableData() {
		// TODO Auto-generated method stub
		return null;
	}
}
