package gov.anl.gss.sdm.server.model.documentor.xmlwriter;

import gov.anl.gss.sdm.server.model.support.Utilities;

import java.io.BufferedWriter;
import java.io.IOException;
import java.util.List;

public class FlatFileWriter {

	public FlatFileWriter() {
		
	}
	
	public static boolean writeFile(String filename, List<List<List<String>>> table, String delimitor) {
		
		if (table == null || table.size() < 2) {
			System.out.println("Insufficient data to write to file "+filename);
			return false;
		}

		BufferedWriter bw = Utilities.openFileForWritingUTF8(filename);

		try {
			// title
			bw.append(table.get(0).get(0).get(0));
			bw.append("\n");
			// column headers
			int col = 0;
			for (List<String> columnHeaders : table.get(1)) {
				for (String h : columnHeaders) {
				if (col++ > 0)
					bw.append(delimitor);
				bw.append(h);
				}
			}
			bw.append("\n");

			int row = 2;

			while (row < table.size()) {
				col = 0;
				for (List<String> dataRow : table.get(row)) {
					for (String d : dataRow) {
					if (col++ > 0)
						bw.append(delimitor);
					bw.append(d);
				}
				}
				bw.append("\n");
				row++;
			}
			bw.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


		return true;

	}
}
