package gov.anl.gss.sdm.server.model.documentor.xmlwriter;

import gov.anl.gss.sdm.server.model.documentor.GetXML;
import gov.anl.gss.sdm.server.model.documentor.TableRow;
import gov.anl.gss.sdm.server.model.documentor.ViewsCounter;

import java.io.BufferedWriter;
import java.util.List;

public class GroupingTable implements GetXML {
	
	private static final String HEADER = "<br/><br/><b><center>$$$NAME$$$<span style='font-size: larger'>$$$TITLE$$$</span></center></b><br/>\n";
	private static final String TABLE_START = "<table class='typeLegend' width='100%'>\n";
	private static final String TABLE_START_NO_WIDTH = "<table class='typeLegend' align='center'>\n";
	private static final String ROW_START = "<tr>\n";
	private static final String ROW_END = "</tr>\n";
	private static final String TABLE_END = "</table>\n";
	private static final String BREAK = "</br>\n";

	private static final String NEWROW = "</tr><tr>\n";


	private String title;
	private String name;

	private TableRow viewsCounter;
	
	public GroupingTable(String title, TableRow modelVariablesInformation, String name) {
		this.viewsCounter = modelVariablesInformation;
		this.title = title;
		this.name = name;
	}
	
	@Override
	public boolean getXML(BufferedWriter sb) {
		return true;
	}
	
	
	public String getXML() {
		StringBuilder sb = new StringBuilder();
		
//		if (viewsCounter instanceof ViewsCounter) {
//			sb.append(HEADER.replace("$$$TITLE$$$", title).replace("$$$NAME$$$", Anchors.getAnchorDefinition(name)));
//		} else {
//			
//		}
		
		sb.append(HEADER.replace("$$$TITLE$$$", title).replace("$$$NAME$$$", Anchors.getAnchorDefinition(name)));
		if (viewsCounter instanceof ViewsCounter) {
		sb.append(TABLE_START_NO_WIDTH);
		} else {
		sb.append(TABLE_START);
		}
		sb.append(ROW_START);
		int i = 0;
		for (List<List<String>> row : viewsCounter.getRows()) {
			if (i++ > 0)
				sb.append(NEWROW);
			for (List<String> column : row) {
				sb.append(column.get(0));
			}
		}
		sb.append(ROW_END);
		sb.append(TABLE_END);
		sb.append(BREAK);
		
		// insert view diagram
		return sb.toString();
	}

	@Override
	public List<List<List<String>>> getTableData() {
		// TODO Auto-generated method stub
		return null;
	}

}
