package gov.anl.gss.sdm.server.model.documentor.xmlwriter;

import gov.anl.gss.sdm.server.model.documentor.GetXML;
import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.TableRow;

import java.io.BufferedWriter;
import java.util.List;

public class MultiSectionTable implements GetXML {
	
	private TableRow tableRow;
	
	private String columnHeader;
	
	private final static String HEADER1 =  "<br />\n" +
        "<table align='center' class='results' width='50%'>\n" +
                "<tr>\n<th>";
	
	private final static String HEADER2 =  "</th>\n" +
	                "<th style='text-align:center;' width='20%'>##Result##</th>\n" +
	                "</tr>\n";
	private final static String FOOTER = "</table>";
	
	
	public MultiSectionTable(String columnHeader, TableRow tableRow) {
		this.columnHeader = columnHeader;
		this.tableRow = tableRow;
	}
	
	@Override
	public boolean getXML(BufferedWriter sb) {
		return true;
	}
	
	
	
	public String getXML() {
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		StringBuilder sb = new StringBuilder();
		sb.append(HEADER1);
		sb.append(columnHeader);
		sb.append(HEADER2.replace("##Result##", language.getTextHtml(StringConstants.RESULT)));
		
		for (List<List<String>> row : tableRow.getRows()) {
			String referenceIt = row.get(0).get(0);
			sb.append("<tr>");
			sb.append("<td><div title='");
			sb.append(row.get(1).get(0).replace(" ", "").replace(":", ""));
			sb.append("'>");
//			if (referenceIt.equals("Name"))
			if (referenceIt.length() > 0)
				sb.append(Anchors.getAnchorReference(referenceIt, row.get(1).get(0)));
			else
				sb.append(row.get(1).get(0));
			sb.append("</div></td>");

			sb.append("<td><center>");
			sb.append(row.get(2).get(0));
			sb.append("</center></td>");

			sb.append("</tr>\n");
		}
		
		sb.append(FOOTER);
		return sb.toString();
	}

	@Override
	public List<List<List<String>>> getTableData() {
		// TODO Auto-generated method stub
		return null;
	}

}
