package gov.anl.gss.sdm.server.model.documentor.xmlwriter;

import java.text.DecimalFormat;

public class NumberFormatter {
	
	public static boolean map = true;

//	DecimalFormat form = new DecimalFormat("###.#");
//	String pct = form.format(viewVariablesPercent.get(view));
	
	public static String formatForPercent(double v) {
		DecimalFormat form = new DecimalFormat("##0.0");
		String pct = form.format(v);
		return pct;
	}
	
	public static String formatForRatio(double v) {
		if (Double.isNaN(v))
			return "NA";
		if (Double.isInfinite(v))
			return "Infinite";
		DecimalFormat form = new DecimalFormat("##0.00");
		String pct = form.format(v);
		return pct;
	}
	
	public static String formatForSmall(double v) {
		DecimalFormat form = new DecimalFormat("##0.0000");
		String pct = form.format(v);
		return pct;
	}
	
	public static String formatForIntComma(int v) {
		DecimalFormat form = new DecimalFormat("#,###");
		String pct = form.format(v);
		return pct;
	}
	
	public static String formatForCountNotConditional(long v) {
		DecimalFormat form = new DecimalFormat("#,###");
		String pct = form.format(v);
		return pct;
	}
	
	public static String formatForCountConditional(long v) {
		if (map && v == 0)
			return "NA";
		DecimalFormat form = new DecimalFormat("#,###");
		String pct = form.format(v);
		return pct;
	}
	
	public static String getAsCountAndPercentTotalNoHTML(long v1, long total) {
		return (NumberFormatter.formatForCountNotConditional(v1)+" ("+
				getAsPercentOfTotal(v1, total)+"%)");
	}
	
	public static String getAsCountAndPercentTotal(long v1, long total) {
		return (NumberFormatter.formatForCountNotConditional(v1)+"&nbsp;("+
				getAsPercentOfTotal(v1, total)+"%)");
	}
	
	public static String getAsPercentOfTotal(long v1, long total) {
		double dPct = 100.0 * (double) v1 / (double) total;
		return NumberFormatter.formatForPercent(dPct);
	}
	
	public static String formatForCountNotConditional(int v) {
		DecimalFormat form = new DecimalFormat("#,###");
		String pct = form.format(v);
		return pct;
	}
	
	public static String formatForCountConditional(int v) {
		if (map && v == 0)
			return "NA";
		DecimalFormat form = new DecimalFormat("#,###");
		String pct = form.format(v);
		return pct;
	}
	
	public static String getAsCountAndPercentTotalNoHTML(int v1, int total) {
		return (NumberFormatter.formatForCountNotConditional(v1)+" ("+
				getAsPercentOfTotal(v1, total)+"%)");
	}
	
	
	public static String getAsCountAndPercentTotal(int v1, int total) {
		return (NumberFormatter.formatForCountNotConditional(v1)+"&nbsp;("+
				getAsPercentOfTotal(v1, total)+"%)");
	}
	
	public static String getAsPercentOfTotal(int v1, int total) {
		double dPct = 100.0 * (double) v1 / (double) total;
		return NumberFormatter.formatForPercent(dPct);
	}
}
