package gov.anl.gss.sdm.server.model.documentor.xmlwriter;

import gov.anl.gss.sdm.server.model.documentor.GetXML;
import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.TableRow;

import java.io.BufferedWriter;
import java.util.List;

public class TypesTable  implements GetXML {
	//<b><center><a name='top'><span style='font-size: larger'>Model Assessment Results</span></center></b>
	private static final String HEADER = "<br/><b><center>$$$NAME$$$<span style='font-size: larger'>$$$TITLE$$$</span></center></b><br/>" +
//			"<table align='center' width='100%'>\n" +
//			"<tr>\n" +
//			"<td style='text-align:right'><span style='font-size: smaller;'><b>$$$TITLE$$$:</b></span></td>\n" +
//			"<td>\n" +
			"<table class='typeLegend' width='100%'>\n" +
			"<tr>\n";
	private static final String FOOTER = "</tr></table>\n"+
			"</td>\n" + "</tr>\n" +
			"<tr><td></td><td style='font-size:smaller;' colspan='5'>* (##state variables / total stocks##)</td></tr>\n" +
			"<tr><td></td><td style='font-size:smaller;' colspan='5'>&dagger; ##Total stocks do not include fixed delay variables##.</td></tr>\n" +
			"<tr><td></td><td style='font-size:smaller;' colspan='5'>&dagger;&dagger; (##lookup variables / lookup tables##).</td></tr>\n" +
			"<tr><td>&nbsp;</td></tr>\n";
	private static final String NEWROW = "</tr><tr>\n";

// StateVariablesTotalStocks
	//TotalStocksDoNotIncludeFixedDelayVariables
	
	private String title;
	private boolean displayModule;

	private TableRow typesCounter;
	
	public TypesTable(String title, TableRow modelVariablesInformation, boolean displayModule) {
		this.typesCounter = modelVariablesInformation;
		this.title = title;
		this.displayModule = displayModule;
	}
	
	@Override
	public boolean getXML(BufferedWriter sb) {
		return true;
	}
	
	
	public String getXML() {
		
		SDMDocLanguageSpecific language = SDMDocLanguageSpecific.getInstance();
		
		StringBuilder sb = new StringBuilder();
		sb.append(HEADER.replace("$$$TITLE$$$", title).replace("$$$NAME$$$", Anchors.getAnchorDefinition(StringConstants.QUICK_LINK_NAME_VARIABLE_TYPE)));
		int i = 0;
		for (List<List<String>> row : typesCounter.getRows()) {
			if (i++ > 0)
				sb.append(NEWROW);
			for (List<String> column : row) {
				sb.append(column.get(0));
			}
		}
		sb.append(FOOTER
				.replace("##state variables / total stocks##",  language.getTextHtml(StringConstants.STATE_VARIABLES_TOTAL_STOCKS))
				.replace("##Total stocks do not include fixed delay variables##",  language.getTextHtml(StringConstants.TOTAL_STOCKS_DO_NOT_INCLUDE_FIXED_DELAY_VARIABLES))
				.replace("##lookup variables / lookup tables##",  language.getTextHtml(StringConstants.LOOKUP_TABLES))
				);
		return sb.toString();
	}

	@Override
	public List<List<List<String>>> getTableData() {
		// TODO Auto-generated method stub
		return null;
	}

}
