package gov.anl.gss.sdm.server.model.documentor.xmlwriter;

import gov.anl.gss.sdm.server.model.analysis.graphtheory.ExogenousVariableManager;
import gov.anl.gss.sdm.server.model.documentor.Documentor;
import gov.anl.gss.sdm.server.model.documentor.GetXML;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector.VariableSelector;
import gov.anl.gss.sdm.server.model.translator.Equation;
import gov.anl.gss.sdm.server.model.translator.InformationManagers;

import java.util.ArrayList;
import java.util.Map;

public class VariableListTableEndogenous extends VariableListTableExtraColumns implements GetXML {


	public VariableListTableEndogenous(Map<String, Equation> equations,
			VariableSelector variableSelector, String type,
			Documentor documentor) {
		super(equations, variableSelector, type, documentor);
		// TODO Auto-generated constructor stub
	}

	
	@Override
	public void selectVariables() {
		variables = new ArrayList<VariableListTableRow>();
		
		for (String var : InformationManagers.getInstance().getEquationLookup().orderedLHS()) {
			boolean ignoreVar = ExogenousVariableManager.isIgnoreVar(var);
			boolean endogenousVar = ExogenousVariableManager.isEndogenousVar(var);
				if (ignoreVar)
					continue;
				if (endogenousVar) {
					variables.add(new VariableListTableRow(InformationManagers.getInstance().getEquationManager().getAnEquationFor(var), 
							displayModule));
				} 
		}
	}
	
	public boolean ignore(Equation equation) {

		if (equation.isDefinesSubscript())
			return true;
		if (equation.isControlGroup() || isNAorTime(equation.getLhsAsInMdl()))
			return true;
		return false;
	}
	
	public boolean isNAorTime(String s) {
		if (s == null)
			return false;
		return s.toUpperCase().equals("TIME") || s.toUpperCase().equals("NAREPLACEMENT");
	}


}
