package gov.anl.gss.sdm.server.model.documentor.xmlwriter;

import gov.anl.gss.sdm.server.model.documentor.GetXML;
import gov.anl.gss.sdm.server.model.translator.Equation;
import gov.anl.gss.sdm.server.model.translator.Parser;

import java.util.ArrayList;
import java.util.List;

public class VariableListTableRowMultiValueColumn extends VariableListTableRow implements GetXML {
	
	
	// NOT USED!
	
	private List<String> multiValueInformation;

	public VariableListTableRowMultiValueColumn(Equation equation) {
		super(equation, false);
		multiValueInformation = new ArrayList<String>();
	}
	
	public String getXML() {
		StringBuilder sb = new StringBuilder();
		sb.append(HEADER);
		sb.append(ROW_HEADER+module+ROW_FOOTER);
		sb.append(ROW_HEADER+group+ROW_FOOTER);
		sb.append(ROW_HEADER+type+ROW_FOOTER);
		sb.append(VARIABLE_HEADER);
		
		sb.append(variable);
		// rhs
		sb.append("<br/> = "+equation.getRhs());
		
//		List<String> errors = equation.getSemanticMessages();
//		if (errors.size() > 0) {
//			for (String msg : errors) {
//			sb.append("<br/><b>ERROR: "+msg+"</b>");
//			}
//		}
		sb.append("<br/><b>Present in "+equation.getViews().size()+" view(s):</b>");
		sb.append("<ul>");
		for (String s : equation.getViews()) {
			sb.append("<li>"+s+"</li");
		}
		sb.append("</ul>");
		
		sb.append("<b>Used by:</b>");
		sb.append("<ul>");
		for (String s : equation.getUsedBy()) {
			sb.append("<li>"+Parser.removeQuotes(s)+"</li");
		}
		sb.append("</ul>");
		
		sb.append("<b>Feedback Loops: ");
		
		sb.append(VARIABLE_FOOTER);
		sb.append(FOOTER);
		return sb.toString();
	}

}
