package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.translator.Equation;

import java.util.LinkedHashSet;
import java.util.Set;

public class MultiVariableSelector {
	
	private Set<VariableSelector> allSelectors;
	private String connector;
	
	public MultiVariableSelector(String connector) {
		this.connector = connector;
		allSelectors = new LinkedHashSet<VariableSelector>();
	}
	
	public void addSelector(VariableSelector selector) {
		allSelectors.add(selector);
	}
	
	public boolean isSelect(Equation eqn) {
		Set<Boolean> singleSelectResults = computeSingleSelectResults(eqn);
		if (connector.equals("&&"))
			return and(singleSelectResults);
		else
			return or(singleSelectResults);
	}
	
	private Set<Boolean> computeSingleSelectResults(Equation eqn) {
		Set<Boolean> results = new LinkedHashSet<Boolean>();
		for (VariableSelector selector : allSelectors) {
			results.add(selector.isSelectSingleEquation(eqn));
		}
		
		return results;
	}
	
	private boolean or(Set<Boolean> singleSelectResults) {
		boolean result = false;
		for (Boolean single : singleSelectResults) {
			if (single.booleanValue())
				result = true;
		}
		
		return result;
	}
	
	private boolean and(Set<Boolean> singleSelectResults) {
		boolean result = true;
		for (Boolean single : singleSelectResults) {
			if (!single.booleanValue())
				result = false;
		}
		
		return result;
	}

}
