package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.translator.Equation;

public class VariableSelectorAuxiliary extends VariableSelector {

	public VariableSelectorAuxiliary(String selectionCriteria, String internalName) {
		super(selectionCriteria, internalName);
	}
	
	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		
		if (ignore(equation))
			return false;
		if (equation.isAuxiliary())
			return isUnique(equation.getVariableName());
		else
			return false;
	}
	
	@Override
	public boolean isSelectMultipleEquation(Equation equation) {
		
		if (ignore(equation))
			return false;
		return equation.isAuxiliary();
	}
	
	@Override
	public boolean ignore(Equation equation) {
		if (equation.isDefinesLookup())
			return true;
		if (isDefinesSubscript(equation))
			return true;
		if (/*isControlGroup(equation) || */
				isAutogenerated(equation))
			return true;
		return false;
	}
}