package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.translator.Equation;

public class VariableSelectorCascadingLookup extends VariableSelector {

	public VariableSelectorCascadingLookup(String selectionCriteria, String internalName) {
		super(selectionCriteria, internalName);
	}
	
	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		if (equation.isCascadingLookup()) {
			return isUnique(equation.getVariableName());	
		}
		return false;
	}
	
	@Override
	public boolean isSelectMultipleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		return equation.isCascadingLookup();
	}

}
