package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;
import gov.anl.gss.sdm.server.model.translator.Equation;
import gov.anl.gss.sdm.server.model.translator.InformationManagers;

public class VariableSelectorComplexity extends VariableSelector {

	public VariableSelectorComplexity(String selectionCriteria, String internalName) {
		super(selectionCriteria, internalName);
	}
	
	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		if (equation.getComplexity() > Integer.parseInt(
				InformationManagers.getInstance().getUserSelectedOptions().getOptionValue(StringConstants.RULE_THRESHOLD)))
			return isUnique(equation.getVariableName());
		else
			return false;
	}
	
	@Override
	public boolean isSelectMultipleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		return equation.getComplexity() > Integer.parseInt(
				InformationManagers.getInstance().getUserSelectedOptions().getOptionValue(StringConstants.RULE_THRESHOLD));
	}

}
