package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.translator.Equation;

public class VariableSelectorDataLookup extends VariableSelector {

	public VariableSelectorDataLookup(String selectionCriteria, String internalName) {
		super(selectionCriteria, internalName);
	}

	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		if (ignore(equation))
			return false;

		if (equation.getComment() != null) {
			if (equation.getComment().toLowerCase().contains(VariableSelector.LOOKUP.toLowerCase()))
				return isUnique(equation.getVariableName());
		}
		return false;
	}

	@Override
	public boolean isSelectMultipleEquation(Equation equation) {
		if (ignore(equation))
			return false;

		if (equation.getComment() != null) {
			return equation.getComment().toLowerCase().contains(VariableSelector.LOOKUP.toLowerCase());
		} else {
			return false;
		}
	}

}