package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.translator.Equation;
import gov.anl.gss.sdm.server.model.translator.SimplifiedUnit;

public class VariableSelectorDmnlUnits extends VariableSelector {

	public VariableSelectorDmnlUnits(String selectionCriteria, String internalName) {
		super(selectionCriteria, internalName);
	}

	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		if (ignore(equation))
			return false;

		SimplifiedUnit su = new SimplifiedUnit(equation.getUnits().split("\\[")[0]);
		if (su.isContainsDmnl())
			return isUnique(equation.getVariableName());

		else
			return false;
	}


	@Override
	public boolean isSelectMultipleEquation(Equation equation) {

		if (ignore(equation))
			return false;

		SimplifiedUnit su = new SimplifiedUnit(equation.getUnits().split("\\[")[0]);

		return su.isContainsDmnl();
	}
}
