package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.UserSelectedOptions;
import gov.anl.gss.sdm.server.model.translator.Equation;
import gov.anl.gss.sdm.server.model.translator.InformationManagers;

public class VariableSelectorEmbeddedData extends VariableSelector {

	public VariableSelectorEmbeddedData(String selectionCriteria, String internalName) {
		super(selectionCriteria, internalName);
	}
	
	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		UserSelectedOptions options = InformationManagers.getInstance().getUserSelectedOptions();
		boolean select = equation.isEmbeddedDataNot01() || 
				(equation.isEmbeddedData01() && !options.isSelected(StringConstants.IGNORE_EMBEDDED_CONSTANTS_OF_0_OR_1));
		if (select)
			return isUnique(equation.getVariableName());
		else
			return false;
	}
	
	@Override
	public boolean isSelectMultipleEquation(Equation equation) {
		UserSelectedOptions options = InformationManagers.getInstance().getUserSelectedOptions();
		boolean select = equation.isEmbeddedDataNot01() || 
				(equation.isEmbeddedData01() && !options.isSelected(StringConstants.IGNORE_EMBEDDED_CONSTANTS_OF_0_OR_1));
		return select;
	}

}
