package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.analysis.graphtheory.ExogenousVariableManager;
import gov.anl.gss.sdm.server.model.translator.Equation;
import gov.anl.gss.sdm.server.model.translator.InformationManagers;

public class VariableSelectorEndogenous extends VariableSelector {

	public VariableSelectorEndogenous(String selectionCriteria, String internalName) {
		super(selectionCriteria, internalName);
	}

	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		if (isEndogenousVar(equation.getVariableName()))
				return isUnique(equation.getVariableName());
		else
			return false;
	}

	@Override
	public boolean isSelectMultipleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		return isEndogenousVar(equation.getVariableName());
	}

	@Override
	public boolean ignore(Equation equation) {
		if (isWithLookup(equation))
			return true;
		if (equation.isDefinesSubscript())
			return true;
		if (/* equation.isControlGroup() || */ ExogenousVariableManager.isNAorTime(equation.getLhsAsInMdl()))
			return true;
		return false;
	}

	private boolean isEndogenousVar(String var) {
		for (Equation eqn : InformationManagers.getInstance().getEquationManager().getAllEquationsFor(var)) {
			if (eqn.isExogenous())
				return false;
		}
		return true;
	}
}