package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.analysis.graphtheory.ExogenousVariableManager;
import gov.anl.gss.sdm.server.model.translator.Equation;

public class VariableSelectorExogenous extends VariableSelector {

	public VariableSelectorExogenous(String selectionCriteria, String internalName) {
		super(selectionCriteria, internalName);
	}
	
	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		
		if (ignore(equation))
			return false;
		if (equation.isExogenous()) {
			return isUnique(equation.getVariableName());
		} else {
			return false;
		}
	}
	
	@Override
	public boolean isSelectMultipleEquation(Equation equation) {
		
		if (ignore(equation))
			return false;

		return equation.isExogenous();
	}
	
	@Override
	public boolean ignore(Equation equation) {
		
		if (isWithLookup(equation))
			return true;
		if (equation.isDefinesSubscript())
			return true;
		if (/* equation.isControlGroup() || */ ExogenousVariableManager.isNAorTime(equation.getLhsAsInMdl()))
			return true;
		return false;
	}
	
}