package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.support.MutableBoolean;
import gov.anl.gss.sdm.server.model.translator.Equation;

import org.apache.log4j.Logger;

public class VariableSelectorNonZeroEnd extends VariableSelector {
	static Logger log = Logger.getLogger(VariableSelectorNonZeroEnd.class.getSimpleName());

	public VariableSelectorNonZeroEnd(String selectionCriteria, String internalName) {
		super(selectionCriteria, internalName);
	}

	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		if (equation.getEquationCharacteristics() == null)
			return  false;
		MutableBoolean left = new MutableBoolean(false);
		MutableBoolean right = new MutableBoolean(false);
		boolean nonZero = equation.isNonzeroEndSlopeLookup(left, right);
		if (nonZero)
			return isUnique(equation.getVariableName());
		else
			return false;
	}

	@Override
	public boolean isSelectMultipleEquation(Equation equation) {
		if (equation.getEquationCharacteristics() == null)
			return  false;
		MutableBoolean left = new MutableBoolean(false);
		MutableBoolean right = new MutableBoolean(false);
		boolean nonZero = equation.isNonzeroEndSlopeLookup(left, right);
		return nonZero;
	}
}
