package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.analysis.graphtheory.ExogenousVariableManager;
import gov.anl.gss.sdm.server.model.translator.Equation;

public class VariableSelectorNotControl extends VariableSelector {

	public VariableSelectorNotControl(String selectionCriteria, String internalName) {
		super(selectionCriteria, internalName);
	}
	
	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		return true;
	}
	
	@Override
	public boolean ignore(Equation equation) {
		
		if (equation.isDefinesSubscript())
			return true;
		if (equation.isControlGroup() || ExogenousVariableManager.isNAorTime(equation.getLhsAsInMdl()))
			return true;
		return false;
	}
}