package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.translator.Equation;

public class VariableSelectorSpecificGroup extends VariableSelector {
	
	private String specific;

	public VariableSelectorSpecificGroup(String selectionCriteria, String internalName, String specific) {
		super(selectionCriteria, internalName);
		this.specific = specific;
	}
	
	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		if (equation.getGroup().equals(specific))
			return isUnique(equation.getVariableName());
		else
			return false;
	}
	
	@Override
	public boolean isSelectMultipleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		return equation.getGroup().equals(specific);
	}
	

}
