package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.translator.Equation;

public class VariableSelectorSpecificView extends VariableSelector {
	
	private String specific;

	public VariableSelectorSpecificView(String selectionCriteria, String internalName, String specific) {
		super(selectionCriteria, internalName);
		this.specific = specific;
	}
	
	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		if (equation.getViews().contains(specific))
			return isUnique(equation.getVariableName());
		else
			return false;
	}
	
	@Override
	public boolean isSelectMultipleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		return equation.getViews().contains(specific);
	}
}
