package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.translator.Equation;

public class VariableSelectorUnused extends VariableSelector {

	public VariableSelectorUnused(String selectionCriteria, String internalName) {
		super(selectionCriteria, internalName);
	}
	
	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		if (equation.isSupplementary())
			return false;
		if (equation.isUnused())
			return isUnique(equation.getVariableName());
		else
			return false;
	}
	
	@Override
	public boolean isSelectMultipleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		if (equation.isSupplementary())
			return false;
		return equation.isUnused();
	}
	
	@Override
	public boolean ignore(Equation equation) {
		
//		if (isDefinesSubscript(equation))
//			return true;
		if (isControlGroup(equation) || 
				isAutogenerated(equation))
			return true;
		return false;
	}

}
