package gov.anl.gss.sdm.server.model.documentor.xmlwriter.variableselector;

import gov.anl.gss.sdm.server.model.translator.Equation;

public class VariableSelectorValueRangeSpecified extends VariableSelector {

	
	public VariableSelectorValueRangeSpecified(String selectionCriteria, String internalName) {
		super(selectionCriteria, internalName);
	}
	
	@Override
	public boolean isSelectSingleEquation(Equation equation) {
		if (ignore(equation))
			return false;
		
		// we actually want eqn without range specified so return inverse
		if (equation.isValueRangeSpecified())
			return false;
		else
			return isUnique(equation.getVariableName());
	}
	
	
	@Override
	public boolean isSelectMultipleEquation(Equation equation) {

		if (ignore(equation))
			return false;

		// we actually want eqn without range specified so return inverse
			return !equation.isValueRangeSpecified();
	}

}
