package gov.anl.gss.sdm.server.model.dynamic;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.tools.JavaCompiler;
import javax.tools.JavaFileManager;
import javax.tools.JavaFileObject;

public class DynaComp {
	
	private String fullName;
	private StringBuilder src; 
	
	public DynaComp(String fullName, StringBuilder src) {
		this.fullName = fullName;
		this.src = src;
	}
	
	public Object getInstance()  {

        // We get an instance of JavaCompiler. Then
        // we create a file manager
        // (our custom implementation of it)
//        JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
        JavaCompiler compiler = new com.sun.tools.javac.api.JavacTool();
//        System.out.println(" >>> "+ToolProvider.getSystemJavaCompiler());
        JavaFileManager fileManager = new
            ClassFileManager(compiler
                .getStandardFileManager(null, null, null));

        // Dynamic compiling requires specifying
        // a list of "files" to compile. In our case
        // this is a list containing one "file" which is in our case
        // our own implementation (see details below)
        List<JavaFileObject> jfiles = new ArrayList<JavaFileObject>();
        jfiles.add(new CharSequenceJavaFileObject(fullName, src));
        
        String[] compileOptions = new String[]{"-cp", "./SDM-Doc.jar"} ;  // -classpath path
        Iterable<String> compilationOptions = Arrays.asList(compileOptions);
        
        // We specify a task to the compiler. Compiler should use our file
        // manager and our list of "files".
        // Then we run the compilation with call()
        compiler.getTask(null, fileManager, null, compilationOptions,
            null, jfiles).call();

        // Creating an instance of our compiled class and
        // running its toString() method
        Object instance = null;
		try {
			instance = fileManager.getClassLoader(null).loadClass(fullName).newInstance();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        
        return instance;
       
    }
}
