package gov.anl.gss.sdm.server.model.powersim;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class PowersimConstruct {

	private String type;
	private String name;
	private Map<String, List<String>> attributes;
	
	public PowersimConstruct(String type) {
		this.type = type;
		this.attributes = new LinkedHashMap<String, List<String>>();
	}
	
	public void addAttribute(String attribute, String value) {
		if (!attributes.containsKey(attribute))
			attributes.put(attribute, new ArrayList<String>());
		attributes.get(attribute).add(value);
	}

	/**
	 * @return the type
	 */
	public String getType() {
		return type;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @return the attributes
	 */
	public Map<String, List<String>> getAttributes() {
		return attributes;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}
	
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("<T:"+type+">");
		sb.append("<N:"+name+">");
		for (String attrib : attributes.keySet()) {
			sb.append("\n\t\t<A:"+attrib+">");
			sb.append("\t\t<V:"+attributes.get(attrib)+">");
		}
		
		return sb.toString();
	}
}
