package gov.anl.gss.sdm.server.model.powersim;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PowersimModelDescription {
	
	List<List<String>> source;
	Map<String, Integer> nameNumberMap;
	
	public PowersimModelDescription(List<List<String>> source) {
		this.source = source;
		nameNumberMap = new HashMap<String, Integer>();
		initialize();
	}
	
	private void initialize() {
		for (int i = 0; i < source.get(0).size(); i++) {
			nameNumberMap.put(source.get(0).get(i).toLowerCase(), i);
		}
	}
	
	public String getRowColumn(int row, String colName) {
		List<String> aRow = source.get(row);
		if (nameNumberMap.containsKey(colName.toLowerCase())) {
			int col = nameNumberMap.get(colName.toLowerCase());
			if (col < aRow.size()) {
				return aRow.get(col);
			}  else
				return null;
		} else {
			return null;
		}
	}
	
	public List<String> getRow(int row) {
		if (row < source.size())
			return source.get(row);
		else
			return null;
	}

}
