package gov.anl.gss.sdm.server.model.powersim;

import gov.anl.gss.sdm.server.model.support.WorkbookUtils;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class PowersimXlsxReader {
	
	private String inputFile;
	XSSFWorkbook wb;
	private List<List<String>> data;
	
	public PowersimXlsxReader(String inputFile) {
		this.inputFile = inputFile;
	}
	
	public boolean loadSheet(String sheet) {
		wb = WorkbookUtils.openWorkbook(inputFile);
		XSSFSheet aSheet = wb.getSheet(sheet);
		
		data = new ArrayList<List<String>>();
		
		// if a cell is null, then we need to save blanks
		// our iterator will skip those!
		
		Iterator<Row> rowIt = aSheet.rowIterator();
		while (rowIt.hasNext()) {
			int col = 0;
			List<String> cols = new ArrayList<String>();
			data.add(cols);
			Row aRow = rowIt.next();
			Iterator<Cell> cellIt = aRow.cellIterator();
			while (cellIt.hasNext()) {
				Cell aCell = cellIt.next();
				int ci = aCell.getColumnIndex();
				while (col < ci) {
					cols.add("");
					col++;
				}
				String dq = "";
				if (col == 0) {
					dq = "\"";
				}
				if (aCell.getCellType() == CellType.STRING ) {
					cols.add(aCell.getRichStringCellValue().toString().replace("'", "\""));
				} else {
					double val = aCell.getNumericCellValue();
					cols.add(Double.toString(val));
				}
				col++;
			}
			try {
				wb.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
			
		
		return true;
	}

	/**
	 * @return the inputFile
	 */
	public String getInputFile() {
		return inputFile;
	}

	/**
	 * @return the originalText
	 */
	public List<List<String>> getData() {
		return data;
	}
}
