package gov.anl.gss.sdm.server.model.structure;

import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class SDEquation extends SDObject {
	
	private String raw;
	private String screenName;
	private String equationString;
	private String lhs;
	private String rhs;
	private String units;
	private String comment;
	
	private Set<String> equationType;
	
	private Set<String> views;
	private Map<String, List<String>> rawView;
	private Group group;
	private Module module;
	
	public SDEquation() {
		super();
		rawView = new LinkedHashMap<String, List<String>>();
		views = new LinkedHashSet<String>();
	}
	
	public SDEquation(String raw) {
		this.raw = raw;
	}
	public String getRaw() {
		return raw;
	}
	public void setRaw(String raw) {
		this.raw = raw;
	}
	public String getScreenName() {
		return screenName;
	}
	public void setScreenName(String screenName) {
		this.screenName = screenName;
	}
	public String getEquationString() {
		return equationString;
	}
	public void setEquationString(String equationString) {
		this.equationString = equationString;
	}
	public String getLhs() {
		return lhs;
	}
	public void setLhs(String lhs) {
		this.lhs = lhs;
	}
	public String getRhs() {
		return rhs;
	}
	public void setRhs(String rhs) {
		this.rhs = rhs;
	}
	public String getUnits() {
		return units;
	}
	public void setUnits(String units) {
		this.units = units;
	}
	public String getComment() {
		return comment;
	}
	public void setComment(String comment) {
		this.comment = comment;
	}
	public Set<String> getViews() {
		return views;
	}
	public void setViews(Set<String> views) {
		this.views = views;
	}
	public Map<String, List<String>> getRawView() {
		return rawView;
	}
	public void setRawView(Map<String, List<String>> rawView) {
		this.rawView = rawView;
	}
	public Group getGroup() {
		return group;
	}
	public void setGroup(Group group) {
		this.group = group;
	}
	public Module getModule() {
		return module;
	}
	public void setModule(Module module) {
		this.module = module;
	}

	public Set<String> getEquationType() {
		return equationType;
	}

}
