package gov.anl.gss.sdm.server.model.support;

public class Delay1 extends DelayFunction {
    public Delay1(SDFunctions sdFunctions, String name, double timeStep) {
	super(sdFunctions, name, timeStep);
	// TODO Auto-generated constructor stub
    }

    @Override
    public double getValue(double time, double timeStep, double... args) {
    	
//    	DELAY1I=LV/delay time
//    	LV=INTEG(input-DELAY1I,initial value*delay time)
	
	double input = args[0];
	double delayDuration = args[1];
	double initial = input;
	if (args.length > 2)
	    initial = args[2];
	
	if (stock.size() == 0) {
	    stock.add(initial * delayDuration);
	    inflow.add(input);
	    outFlow.add(stock.get(stock.size()-1)/delayDuration);
	} else {
		// here's where things are different. We are passed in values from the previous time step.
		// in a normal stock implemented delay, the rates are computed based on the previous time steps
		// with a self contained situation, we need to make some of these calculations here
		
		// 1. set our inflow. this is from the previous time period
		inflow.add(input);
		// 2. compute what would have been new value of the stock
		stock.add(stock.get(stock.size()-1) +timeStep*(inflow.get(inflow.size()-1) - outFlow.get(outFlow.size()-1)));
		// 3. now compute the out flow which is actually our "delay" value
		outFlow.add(stock.get(stock.size()-1)/delayDuration);
//		inflow.add(input);
//		outFlow.add(stock.get(stock.size()-1)/delayDuration);	    	   
	}

	
	return outFlow.get(outFlow.size()-1);
    }
}
