package gov.anl.gss.sdm.server.model.support;

import java.util.ArrayList;

abstract public class DelayFunction {
	
	ArrayList<Double> inflow;
	ArrayList<Double> stock;
	ArrayList<Double> outFlow;
	protected String name;
	
	protected SDFunctions sdFunctions;
	
	
	public DelayFunction(SDFunctions sdFunctions, String name, double timeStep) {
		this.sdFunctions = sdFunctions;
	    this.name = name;
		inflow = new ArrayList<Double>();
		stock = new ArrayList<Double>();
		outFlow = new ArrayList<Double>();
		
	}
	
	public abstract double getValue(double time, double timeStep, double... arg1);
	
	public void backstep() {
		if (inflow.size() > 0) {
			inflow.remove(inflow.size()-1);
		} else {
			System.out.println("Delay inflow backstep overrun: "+name);
		}
		if (stock.size() > 0) {
			stock.remove(stock.size()-1);
		} else {
			System.out.println("Delay stock backstep overrun: "+name);
		}
		if (outFlow.size() > 0) {
			outFlow.remove(outFlow.size()-1);
		} else {
			System.out.println("Delay delayedInput backstep overrun: "+name);
		}
	}

}
