package gov.anl.gss.sdm.server.model.support;

import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.Map;

import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class ExcelManager {
	

	private  Map<String, XSSFWorkbook> openWorkbooks = new LinkedHashMap<String, XSSFWorkbook>();
	private  Map<XSSFWorkbook, String> workbookFiles = new LinkedHashMap<XSSFWorkbook, String>();
	
	public ExcelManager() {
	}
	
	
	public  XSSFWorkbook openWorkbook(String book) {
		if (openWorkbooks.containsKey(book)) {
			return openWorkbooks.get(book);
		} else {
			XSSFWorkbook wb = WorkbookUtils.openWorkbook(book); 
			registerWorkbook(book, wb);
			return wb;
		}
	}
	
	private  void registerWorkbook(String book, XSSFWorkbook wb) {
		openWorkbooks.put(book,  wb);
		workbookFiles.put(wb,  book);
	}
	
	private  void removeWorkbook(XSSFWorkbook wb) {
		String file = workbookFiles.get(wb);
		openWorkbooks.remove(file);
		workbookFiles.remove(wb);
	}
	
	public  boolean closeAllWorkbooks() {
		
		boolean status = true;
		
		for (XSSFWorkbook wb : workbookFiles.keySet()) {
			status = status && closeWorkbook(wb);
		}
		
		return status;
	}
	
	public  boolean closeWorkbook(XSSFWorkbook wb) {
		try {
			wb.close();
			
			removeWorkbook(wb);
			
			return true;
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return false;
		}
	}

	
	
	
	
}
