package gov.anl.gss.sdm.server.model.support;

import java.io.File;
import java.util.List;

public class ExtendedMemoryLogProcessor {
	

	private ExtendedMemoryDatabase em;
	private MemoryMapperInterface mm;
	
	public ExtendedMemoryLogProcessor(String mapFile, String extendedMemoryFile) {
		em = new ExtendedMemoryDatabase(mapFile, extendedMemoryFile);
		em.loadRunParameters();
		mm = em.getMapper();
		em.loadDBValues();
		File f = new File(extendedMemoryFile);
		em.writeTabFile(f.getParent()+"/../Excel/"+f.getName()+".tab");
		em.writeTabFileVarRow(f.getParent()+"/../Excel/"+f.getName()+"_VarRow.tab");
		em.shutdownDatabase();
	}
	
	public List<Double> getValuesForVariable(String var) {
		return em.getRssdValues().get(var);
	}
	
	public List<String> getVariables() {
		return mm.getVariableExecutionOrder();
	}
	
	public static void main(String[] args) {

		ExtendedMemoryLogProcessor stj = new ExtendedMemoryLogProcessor(args[0], args[1]);
		List<String> vars = stj.getVariables();
	}


}
