package gov.anl.gss.sdm.server.model.support;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class HeadTailMap {
	
	private Map<String, List<String>> headTailMap = new LinkedHashMap<String, List<String>>();
	private String file;
	
	public HeadTailMap(String file) {
		this.file = file;
		load();
	}
	
	private void load() {
		for (String line : Utilities.getAsList(file)) {
			String[] parts = line.split("\t");
			List<String> list = new ArrayList<String>();
			for (int i = 1; i < parts.length; i++) {
				list.add(parts[i]);
			}
			headTailMap.put(parts[0], list);
		}
	}
	
	public List<String> getRHSVars(String lhs) {
		return headTailMap.get(lhs);
	}

}
