package gov.anl.gss.sdm.server.model.support;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class LanguageTranslationResourceBundle {
	
	Map<String, String> map;
	
	public LanguageTranslationResourceBundle() {
		map = new LinkedHashMap<String, String>();
	}

	
	public static LanguageTranslationResourceBundle getBundle(String dir, String name, String lang) {
		List<String> translations = Utilities.getAsListUTF8(getFilename(dir, name, lang));
		
		LanguageTranslationResourceBundle rb = new LanguageTranslationResourceBundle();
		
		for (String translation : translations) {
			rb.addTranslation(translation);
		}
		
		return rb;
		
	}
	
	private void addTranslation(String translation) {
		if (!translation.contains("="))
			return;
		String[] parts = translation.split("=");
		String key = parts[0].trim();
		String language = parts[1].trim();
		map.put(key, language);
	}
	
	public boolean containsKey(String key) {
		return map.containsKey(key);
	}
	
	public String getString(String key) {
		if (containsKey(key))
			return map.get(key);
		else
			return null;
	}
	
	public static String getFilename(String dir, String name, String lang) {
		return dir + "/" + name+convertToFilename(lang)+".properties";
	}
	
	private static String convertToFilename(String lang) {
		return lang.replace(",","_");
	}
}
