package gov.anl.gss.sdm.server.model.support;

import gov.anl.gss.sdm.server.model.translator.Equation;
import gov.anl.gss.sdm.server.model.translator.NativeDataTypeManager;

import java.util.List;
import java.util.Map;

public interface MemoryMapperInterface {

	public Map<String, Map<String, Integer>> getVariableStorageMap();
	public List<String> getVariables();
	public List<String> getStocks();
	public List<String> getVariablesOrderedByType();
	public List<String> getVariableMemoryOrder();
	public List<String> getVariableExecutionOrder();
	public void writeMapper(boolean badEvalOrder);
	public List<List<String>> getVariableMapRecords();
	public List<List<String>> getVariableMapRecords(String type);
	public List<String> getMapperRecords();
	public void determineMemoryRequirements();
	public String getOffset(String lhs);
	public String getVarType(String lhs);
	public String getEqnType(String lhs);
	public String getDataStoreAndOffset(String lhs);
	public String getDataStore(String lhs);
	public int getIndex(String lhs);
	public String getNumElements(String lhs);
	public String getSizeRequirement();
	public int getNumElements();
	public void report();
	public List<String> getEvaluationOrderOneTime();
	public void setEvaluationOrderOneTime(List<String> evaluationOrderOneTime);
	public List<String> getEvaluationOrderRepeated();
	public void setEvaluationOrderRepeated(List<String> evaluationOrderRepeated);
	public String getMapperFile();
	public Map<String, MutableInteger> getSizeByType();
	public Map<String, Equation> getEquations();
	public Map<String, String> getEqnLHS();
	public int getNumElementsForType(String type);
	public Map<String, String> getVarType();
	public List<String> getSortedLHS();
	
	public List<String> getLookups(); // names of lookups

	public Map<String, Map<String, Integer>> getOffset();

	public Map<String, Map<Integer, String>> getReverseIndex();

	public Map<String, MutableInteger> getCurrentOffset();

	public Map<String, MutableInteger> getCurrentNumElements();

	public Map<String, Map<String, Integer>> getExpandedIndex();
	public List<String> getExpandedSortedLHS();

	public NativeDataTypeManager getNdtm();

	public NamedSubscriptManager getNsm();
	
	public String common(String var);
	public List<List<String>> getLookupMapRecords();
	public List<List<String>> getLookupMapRecords(String type);
	
	public boolean isValidVariable(String var);
}
