package gov.anl.gss.sdm.server.model.support;

import java.util.ArrayList;

abstract public class SmoothFunction {
	
	ArrayList<Double> rawValues;
	ArrayList<Double> changeInSmooth;
	ArrayList<Double> smoothedValues;
	protected String name;
	
	protected SDFunctions sdFunctions;
	
	public SmoothFunction(SDFunctions sdFunctions, String name, double timeStep) {

	    this.sdFunctions = sdFunctions;
	    this.name = name;
	    rawValues = new ArrayList<Double>();
	    changeInSmooth = new ArrayList<Double>();
	    smoothedValues = new ArrayList<Double>();
	    
	}
	
	public void backstep() {
		if (rawValues.size() > 0) {
			rawValues.remove(rawValues.size()-1);
		} else {
			System.out.println("Smooth rawValues backstep overrun: "+name);
		}
		if (changeInSmooth.size() > 0) {
			changeInSmooth.remove(changeInSmooth.size()-1);
		} else {
			System.out.println("Smooth changeInSmooth backstep overrun: "+name);
		}
		if (smoothedValues.size() > 0) {
			smoothedValues.remove(smoothedValues.size()-1);
		} else {
			System.out.println("Smooth smoothedValues backstep overrun: "+name);
		}
	}

	
	public abstract double getValue(double time, double timeStep, double... arg2);

}
