package gov.anl.gss.sdm.server.model.support;

import java.util.ArrayList;
import java.util.List;

public class SmoothN extends SmoothFunction {

    protected List<Smooth> cascadedSmooths = new ArrayList<Smooth>();

	public SmoothN(SDFunctions sdFunctions, String name, double timeStep) {
		super(sdFunctions, name, timeStep);
		// TODO Auto-generated constructor stub
	}
	
	@Override
	public void backstep() {
		if (rawValues.size() > 0) {
			rawValues.remove(rawValues.size()-1);
		} else {
			System.out.println("Smooth rawValues backstep overrun: "+name);
		}
		if (changeInSmooth.size() > 0) {
			changeInSmooth.remove(changeInSmooth.size()-1);
		} else {
//			System.out.println("Smooth changeInSmooth backstep overrun: "+name);
		}
		if (smoothedValues.size() > 0) {
			smoothedValues.remove(smoothedValues.size()-1);
		} else {
			System.out.println("Smooth smoothedValues backstep overrun: "+name);
		}
		
		for (Smooth func : cascadedSmooths) {
			func.backstep();
		}
	}

	@Override
	public double getValue(double time, double timeStep, double... args) {
	    // if this is the first time this is called, must initialized the cascaded
	    // delay1s
	    
	    double input = args[0];
	    double delayTime = args[1];
	    double initial = args[2];
	    double n = args[3];
	    
	    rawValues.add(input);
	    
	    if (cascadedSmooths.size() == 0) {
		for (int i = 0; i < args[3]; i++) {
		    cascadedSmooths.add(new Smooth(sdFunctions, "", timeStep));
		}
	    }
	    
	    double delayedValue = input;
	    
	    for (Smooth d1 : cascadedSmooths) {
		delayedValue = d1.getValue(time, timeStep, delayedValue, delayTime/n, initial);
	    }
	    
	    smoothedValues.add(delayedValue);
	    
	    return delayedValue;
	}

}
