package gov.anl.gss.sdm.server.model.support;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class StreamlinedMemoryMapperSubscriptDefinition {
	
	private NamedSubscriptDefinition definition;
	private Map<String, Integer> valueToIndex;
	
	public StreamlinedMemoryMapperSubscriptDefinition(String mapperLine) {
		String[] parts = mapperLine.split("\t");
		String name = parts[0].replace(":", "");
		List<String> values = new ArrayList<String>();
		valueToIndex = new HashMap<String, Integer>();
		for (int i = 1; i < parts.length; i++) {
			values.add(parts[i]);
			valueToIndex.put(parts[i], i-1);
		}
		definition = new NamedSubscriptDefinition(name, values);
	}
	
	public int getIndex(String subscript) {
		return valueToIndex.get(subscript);
	}

	public NamedSubscriptDefinition getDefinition() {
		return definition;
	}
	
	public String getName() {
		return definition.getName();
	}
	
	public int getNumberOfElements() {
		return definition.getNumValues();
	}

}
