package gov.anl.gss.sdm.server.model.support;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.security.GeneralSecurityException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.poi.openxml4j.exceptions.InvalidFormatException;
import org.apache.poi.openxml4j.opc.OPCPackage;
import org.apache.poi.poifs.crypt.Decryptor;
import org.apache.poi.poifs.crypt.EncryptionInfo;
import org.apache.poi.poifs.filesystem.POIFSFileSystem;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class WorkbookUtils {
	
	public static XSSFWorkbook openWorkbook(String workbookName) {
		XSSFWorkbook wb = null;
		try {
			OPCPackage pkg;
			try {
				pkg = OPCPackage.open(new FileInputStream(new File(workbookName)));
				 wb = new XSSFWorkbook(pkg);
			} catch (InvalidFormatException e) {
				// TODO Auto-generated catch block
				System.out.println("InvalidFormatException");
				e.printStackTrace();
			}
		      
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println("IOException");
			e.printStackTrace();
		}
		return wb;
	}
	
	public static XSSFWorkbook openEncryptedWorkbook(String workbookName) {
		XSSFWorkbook wb = null;
		try {
			POIFSFileSystem fs = new POIFSFileSystem(new FileInputStream(workbookName));
			EncryptionInfo info = new EncryptionInfo(fs);
			Decryptor d = Decryptor.getInstance(info);
			try {
				d.verifyPassword("Sms4$sms"); // Decryptor.DEFAULT_PASSWORD
				wb = new XSSFWorkbook(d.getDataStream(fs));
			} catch (GeneralSecurityException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return wb;
	}
	
	public static List<List<String>> getSheetAsTable(XSSFSheet sheet) {

		List<List<String>> table = new ArrayList<List<String>>();

		Iterator<Row> rowIt = sheet.rowIterator();
		int currentRow = 0;
		int currentColumn = 0;
		int expectedRow = 0;
		int expectedColumn = 0;
		Row aRow = null;
		Cell aCell = null;
		List<String> row = new ArrayList<String>();
		while (rowIt.hasNext()) {
			expectedRow++;
			aRow = rowIt.next();
			currentRow = aRow.getRowNum()+1;
			if (currentRow > expectedRow) {
				while(expectedRow < currentRow) {
					row = new ArrayList<String>();
					table.add(row);
					expectedRow++;
				}
			}
			row = new ArrayList<String>();
			table.add(row);
			expectedColumn = 0;
			Iterator<Cell> cellIt = aRow.cellIterator();
			while (cellIt.hasNext()) {
				expectedColumn++;
				aCell = cellIt.next();
				currentColumn = aCell.getColumnIndex()+1;
				while (expectedColumn < currentColumn) {
					row.add("");
					expectedColumn++;
				}

				try {
					if (aCell.getCellType() == CellType.STRING) {
						String s = aCell.getStringCellValue();
						row.add(s);
						
					} else {
						double val = aCell.getNumericCellValue();
						if (val == 0.0)
							row.add("");
						else
							row.add(Double.toString(val));

					}
				} catch (Exception e) {
					// TODO Auto-generated catch block
					return table;
				}
			}
		}
		return table;

	}

}
