package gov.anl.gss.sdm.server.model.support.database;


import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;

public class DBUtilities {
	
	public static void exec(DBConnection dbConn, String sql) {
		try {
//			if (sql.startsWith("insert into Variables"))
//						 System.out.println("DB: "+sql);
			dbConn.update(sql);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static double getSingleDoubleValue(DBConnection dbConn, String sql, double time) {

		Statement st = null;
		ResultSet rs = null;
		
		double tv = 0.0;

		st = dbConn.createStatement();
		try {
			rs = st.executeQuery(sql);
			int i = 0;
			for (; rs.next(); ) {
				tv = rs.getDouble(1);
			}
			st.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	
		return tv;
	}
	
	public static double getSingleDoubleValue(DBConnection dbConn, String sql) {

		Statement st = null;
		ResultSet rs = null;
		
		double tv = 0.0;

		st = dbConn.createStatement();
		try {
			rs = st.executeQuery(sql);
			int i = 0;
			for (; rs.next(); ) {
				tv = rs.getDouble(1);
			}
			st.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	
		return tv;
	}
	
	public static int getSingleIntegerValue(DBConnection dbConn, String sql) {

		Statement st = null;
		ResultSet rs = null;
		
		int tv = -1;

		st = dbConn.createStatement();
		try {
			rs = st.executeQuery(sql);
			int i = 0;
			for (; rs.next(); ) {
				tv = rs.getInt(1);
			}
			st.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	
		return tv;
	}
	
	public static String[] getStringValues(DBConnection dbConn, String sql) {

		Statement st = null;
		ResultSet rs = null;
		String[] tv = null;

		st = dbConn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
		try {
			rs = st.executeQuery(sql);
			tv = new String[numRows(rs)];
			int i = 0;
			for (; rs.next(); ) {
				String t = rs.getString(1);
				tv[i++] = t;
			}
			st.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	
		return tv;
	}
	
	public static double[][] getTableDoubles(DBConnection dbConn, String sql) {

		Statement st = null;
		ResultSet rs = null;
		double[][] tv = null;

		st = dbConn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
		try {
			rs = st.executeQuery(sql);
			int numRow = numRows(rs);
			tv = new double[numCols(sql)][numRow];
			
			
			
//			for (; rs.next(); ) {
			for (int time = 0; time < numRow; time++) {
				int var = 0;
				rs.next();
				for (int c = 1; c <= numCols(sql); c++) {
					tv[var++][time] = rs.getDouble(c);
				}
			}
			st.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	
		return tv;
	}
	
	public static double[] getConstantDoubles(DBConnection dbConn, String sql, double forTime) {

		Statement st = null;
		ResultSet rs = null;
		double[] tv = null;

		// first column retrieved is modelTime, this is used to extend

		st = dbConn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
		try {
			rs = st.executeQuery(sql);
			tv = new double[numCols(sql)-1];

			for (; rs.next(); ) {
				double time = rs.getDouble(1);
				if (time <= forTime) {
					for (int c = 2; c <= numCols(sql); c++) {
						tv[c-2] = rs.getDouble(c);
					}
				}
			}
			st.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


		return tv;
	}
	
	public static double[][] getExpandedConstantsDoubles(DBConnection dbConn, String sql, double[] timeVector) {

		Statement st = null;
		ResultSet rs = null;
		double[][] tv = null;
		
		int numTimeValues = timeVector.length;
		double dt = timeVector[1] - timeVector[0];
		
		// first column retrieved is modelTime, this is used to extend

		st = dbConn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
		try {
			rs = st.executeQuery(sql);
			tv = new double[numCols(sql)-1][timeVector.length];

			for (; rs.next(); ) {

				double time = rs.getDouble(1);
				int indexForTime = (int) ((time-timeVector[0])/dt);
				for (int c = 2; c <= numCols(sql); c++) {
					for (int t = indexForTime; t < numTimeValues; t++) {
						tv[c-2][t] = rs.getDouble(c);
					}
				}
			}
			st.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	
		return tv;
	}
	
	public static double[] getDoubles(DBConnection dbConn, String sql) {

		Statement st = null;
		ResultSet rs = null;
		double[] tv = null;

		st = dbConn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
		try {
			rs = st.executeQuery(sql);
			tv = new double[numCols(sql)];
			int i = 0;
			for (; rs.next(); ) {
				for (int c = 1; c <= numCols(sql); c++) {
				tv[i++] = rs.getDouble(c);
				}
			}
			st.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	
		return tv;
	}
	
	public static int numRows(ResultSet rs) {
		int i = 0;
		try {
			
			for (; rs.next(); ) {
				i++;
			}
				rs.beforeFirst();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return i;
	}
	
	public static int numCols(String sql) {
		if (sql.contains(","))
			return sql.split(",").length;
		else
			return 1;
	}
	
    public static void printQuery(DBConnection conn, String expression) throws SQLException {

        Statement st = null;
        ResultSet rs = null;

        st = conn.createStatement();         // statement objects can be reused with

        // repeated calls to execute but we
        // choose to make a new one each time
        rs = st.executeQuery(expression);    // run the query

        // do something with the result set.
        dump(rs);
        st.close();    // NOTE!! if you close a statement the associated ResultSet is

        // closed too
        // so you should copy the contents to some other object.
        // the result set is invalidated also  if you recycle an Statement
        // and try to execute some other query before the result set has been
        // completely examined.
    }

//use for SQL commands CREATE, DROP, INSERT and UPDATE

    public static void dump(ResultSet rs) throws SQLException {

        // the order of the rows in a cursor
        // are implementation dependent unless you use the SQL ORDER statement
        ResultSetMetaData meta   = rs.getMetaData();
        int               colmax = meta.getColumnCount();
        int               i;
        Object            o = null;

        // the result set is a cursor into the data.  You can only
        // point to one row at a time
        // assume we are pointing to BEFORE the first row
        // rs.next() points to next row and returns true
        // or false if there is no next row, which breaks the loop
        for (; rs.next(); ) {
            for (i = 0; i < colmax; ++i) {
                o = rs.getObject(i + 1);    // Is SQL the first column is indexed

                // with 1 not 0
                System.out.print(o.toString() + " ");
            }

            System.out.println(" ");
        }
    }                                       //void dump( ResultSet rs )
    
    public static boolean tableExists(DBConnection conn, String tableName) {
    	
			String sql = "select * from "+tableName; 
			
//			System.out.println("Table Exist: "+sql);
    	
		Statement st = null;
		ResultSet rs = null;
		double[] tv = null;

		st = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
		try {
			rs = st.executeQuery(sql);
			st.close();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
//			e.printStackTrace();
			return false;
		}

		return true;
    }


}
