package gov.anl.gss.sdm.server.model.tools;

import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.support.Utilities;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.Map;

public class HeadlessRunner {
	
	private String modelFileToProcess;
	
	public HeadlessRunner(String modelFileToProcess) {
		this.modelFileToProcess = modelFileToProcess;
		
		SDMDocLanguageSpecific.initialize();
	}
	
	private void execute() {

		String mdl = modelFileToProcess;
		
		 String object = Utilities.makeLegalJavaName(new File(modelFileToProcess).getName().replace(".MDL", "").replace(".mdl", "").toUpperCase());

		try {
			MDLProcessor mdlProc = new MDLProcessor(mdl, mdl, object, new File(mdl).getParent());
			mdlProc.getSdmProc().setBatchExecution(true);
			mdlProc.process(false);
		} catch (Exception e) {
			writeErrorToFile(mdl, e);
			// TODO Auto-generated catch block
			System.out.println("ERROR! "+mdl);
			e.printStackTrace();
		}
	}
	
	public void writeErrorToFile(String mdl, Exception e) {
		try {
			FileWriter fw = new FileWriter("batchErrors.txt",true); //the true will append the new data
		    fw.write("\n*** ERROR! "+mdl+"\n");
			for (StackTraceElement ste : e.getStackTrace()) {
				fw.write(ste.toString()+"\n");
			}
			fw.close();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
	}
	
    public static void main(String[] args) {
    	
    	// args[0] = model file
    	// args[1] = java object name (optional)
    	HeadlessRunner runner = new HeadlessRunner(args[0]);
    	runner.execute();
    }

}
