package gov.anl.gss.sdm.server.model.tools;

import gov.anl.gss.sdm.server.model.bridge.SDMBridge;
import gov.anl.gss.sdm.server.model.documentor.MessageProcessor;
import gov.anl.gss.sdm.server.model.documentor.SDMDocLanguageSpecific;
import gov.anl.gss.sdm.server.model.documentor.plots.ThumbnailPlots;
import gov.anl.gss.sdm.server.model.documentor.xmlwriter.StringConstants;

import java.util.ArrayList;
import java.util.List;

public class SDModelRunner extends SDModelTool {
	
	public SDModelRunner() {
		
	}
	
//	public static void main(String[] args) {
//		SDModelRunner runner = new SDModelRunner();
//		runner.run(args[0], "c:/sdmData/Models", "baseline", false, true);
//	}
	
	public boolean run(String modelName, String systemRoot, String runName, /*boolean newMemoryDefinition,*/ boolean generateThumbnails,
			FileOrganizer fileOrganizer, MessageProcessor info) {
		
		try {
			SDMBridge bridge = new SDMBridge(fileOrganizer);
			bridge.selectModel(modelName);
			if (bridge.createNewRun(runName)) {
				bridge.startExecution();
				bridge.runTo(bridge.getEndTime());
				bridge.done();
				List<String> runs = new ArrayList<String>();
				runs.add(bridge.buildRunOutputFileName(runName));				
				if (generateThumbnails) {
					info.addMessage(SDMDocLanguageSpecific.getInstance().getText(StringConstants.CREATING_THUMBNAILS));
						ThumbnailPlots tp = new ThumbnailPlots(modelName, runs, fileOrganizer );
				}
				return true;
			} else {
				return false;
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return false;
		}
	}

}
