package gov.anl.gss.sdm.server.model.translator;

import gov.anl.gss.sdm.server.model.support.Utilities;

public class EquationVariable {
	
	private Equation equation;
	private String originalLhs;
	private String originalVariableNameQuoted;
	private String originalVariableNameNoQuote;
	private String commonNameQuoted;
	private String commonNameNoQuote;
	private String javaName;
	private int variableNumber;
	private boolean nonAscii;
	
	public EquationVariable(Equation equation) {
		this.equation = equation;
		initialize();
	}
	
	private void initialize() {
		originalLhs = equation.getLhsAsInMdl();
		originalVariableNameNoQuote = equation.getVariableName();
		originalVariableNameQuoted = "\""+originalVariableNameNoQuote+"\"";
		commonNameQuoted =  VariableNameEquivalence.getCommonName(originalVariableNameQuoted);
		commonNameNoQuote = VariableNameEquivalence.getCommonName(originalVariableNameNoQuote);
		javaName = Utilities.makeLegalJavaName(originalVariableNameNoQuote);
		
		nonAscii = Utilities.nonAscii(originalVariableNameNoQuote);
	}

	public int getVariableNumber() {
		return variableNumber;
	}

	public void setVariableNumber(int variableNumber) {
		this.variableNumber = variableNumber;
	}

	public Equation getEquation() {
		return equation;
	}

	public String getOriginalLhs() {
		return originalLhs;
	}

	public String getOriginalVariableNameQuoted() {
		return originalVariableNameQuoted;
	}

	public String getOriginalVariableNameNoQuote() {
		return originalVariableNameNoQuote;
	}

	public String getCommonNameQuoted() {
		return commonNameQuoted;
	}

	public String getCommonNameNoQuote() {
		return commonNameNoQuote;
	}

	public String getJavaName() {
		return javaName;
	}

	public boolean isNonAscii() {
		return nonAscii;
	}

	public void setEquation(Equation equation) {
		this.equation = equation;
	}

	public void setOriginalLhs(String originalLhs) {
		this.originalLhs = originalLhs;
	}

	public void setOriginalVariableNameQuoted(String originalVariableNameQuoted) {
		this.originalVariableNameQuoted = originalVariableNameQuoted;
	}

	public void setOriginalVariableNameNoQuote(String originalVariableNameNoQuote) {
		this.originalVariableNameNoQuote = originalVariableNameNoQuote;
	}

	public void setCommonNameQuoted(String commonNameQuoted) {
		this.commonNameQuoted = commonNameQuoted;
	}

	public void setCommonNameNoQuote(String commonNameNoQuote) {
		this.commonNameNoQuote = commonNameNoQuote;
	}

	public void setJavaName(String javaName) {
		this.javaName = javaName;
	}

	public void setNonAscii(boolean nonAscii) {
		this.nonAscii = nonAscii;
	}
	
	

}
