package gov.anl.gss.sdm.server.model.translator;

public class StaticSwitches {
	
	public static boolean WRITE_DEBUG_FILES = false;
	public static boolean WRITE_BRIDGE_FILES = false;
	public static boolean LIMIT_LHS_EXPANSION = false;
	public static boolean USE_NEW_FAST_LOAD = false; 
	public static boolean WRITE_RESULTS = false;
	public static int TOO_MANY_POINTS = 20;
	
	
	public static void initialize() {


		String value = System.getProperty("DEBUG");
		if (value != null) {
			WRITE_DEBUG_FILES = value.equalsIgnoreCase("true");
			System.out.println("setting WRITE_DEBUG_FILES = "+WRITE_DEBUG_FILES);
		}
		value = System.getProperty("BRIDGE");
		if (value != null) {
			WRITE_BRIDGE_FILES = value.equalsIgnoreCase("true");
			System.out.println("setting WRITE_BRIDGE_FILES = "+WRITE_BRIDGE_FILES);
		}
		
		value = System.getProperty("LIMIT_LHS_EXPANSION");
		if (value != null) {
			LIMIT_LHS_EXPANSION = value.equalsIgnoreCase("true");
			System.out.println("setting LIMIT_LHS_EXPANSION = "+LIMIT_LHS_EXPANSION);
		}
		
		value = System.getProperty("USE_NEW_FAST_LOAD");
		if (value != null) {
			USE_NEW_FAST_LOAD = value.equalsIgnoreCase("true");
			System.out.println("setting USE_NEW_FAST_LOAD = "+USE_NEW_FAST_LOAD);
		}

		value = System.getProperty("WRITE_RESULTS");
		if (value != null) {
			WRITE_RESULTS = value.equalsIgnoreCase("true");
			System.out.println("setting WRITE_RESULTS = "+WRITE_RESULTS);
		}
		
		value = System.getProperty("TOO_MANY_POINTS");
		if (value != null) {
			try {
				TOO_MANY_POINTS = Integer.parseInt(value);
			} catch (NumberFormatException e) {
				// TODO Auto-generated catch block
				System.out.println("Error setting TOO_MANY_POINTS = "+TOO_MANY_POINTS);
//				e.printStackTrace();
			}
			System.out.println("setting TOO_MANY_POINTS = "+TOO_MANY_POINTS);
		}
		
	}
	

}
