package gov.anl.gss.sdm.server.model.visualization3d;


public class Location {

	private String view;
	private String x;
	private String y;
	private String z;
	
	private double adjustedX;
	private double adjustedY;
	private double adjustedZ;
	
	public Location(String view, String x, String y) {
		this.view = view;
		this.x = x;
		this.y = y;
	}
	
	public Location(String view, String x, String y, String z) {
		this.view = view;
		
		this.x = x;
		this.y = y;
		this.z = z;
	}
	
	public Location(String view, double x, double y, double z) {
		this.view = view;
		adjustedX = x;
		adjustedY = y;
		adjustedZ = z;
		this.x = Double.toString(x);
		this.y = Double.toString(y);
		this.z = Double.toString(z);
	}
	
	public void adjustCoordinates(double xAdjust, double yAdjust, double zAdjust, double yMax) {
		adjustedX = getXd()*Visualization3DData.SPREAD_XY - xAdjust;
		// the ymax flips the y space
		adjustedY = (yMax - (getYd()*Visualization3DData.SPREAD_XY)) - yAdjust;
		adjustedZ = getZd()*Visualization3DData.SPREAD_Z - zAdjust;
		
	}

	public String getView() {
		return view;
	}

	public String getX() {
		return x;
	}
	
	public double getXd() {
		return Double.parseDouble(x);
	}

	public String getY() {
		return y;
	}
	
	public double getYd() {
		return Double.parseDouble(y);
	}
	
	public double getZd() {
		return Double.parseDouble(z);
	}
	
	public boolean inView(String aView) {
		return view.equals(aView);
	}

	public void setView(String view) {
		this.view = view;
	}

	public void setX(String x) {
		this.x = x;
	}

	public void setY(String y) {
		this.y = y;
	}
	
	public String toString() {
		return "view: "+view+" x: "+x+" y: "+y;
	}

	public String getZ() {
		return z;
	}

	public void setZ(String z) {
		this.z = z;
	}

	public double getAdjustedX() {
		return adjustedX;
	}

	public void setAdjustedX(double adjustedX) {
		this.adjustedX = adjustedX;
	}

	public double getAdjustedY() {
		return adjustedY;
	}

	public void setAdjustedY(double adjustedY) {
		this.adjustedY = adjustedY;
	}

	public double getAdjustedZ() {
		return adjustedZ;
	}

	public void setAdjustedZ(double adjustedZ) {
		this.adjustedZ = adjustedZ;
	}
}
