package gov.anl.gss.sdm.server.model.visualization3d;

import gov.anl.gss.sdm.server.model.support.Utilities;

import java.io.BufferedWriter;
import java.io.IOException;


public class RotationCalculator {
	
	double rx, ry, rz;
	double rotx, roty, rotz;
	
	public RotationCalculator() {
		
	
		
	}
	
	public  void calc2(double x, double y, double z) {

		rotx = Math.atan2( y, z );
		 if (z >= 0) {
		    roty = -Math.atan2( x * Math.cos(rotx), z );
		 }else{
		    roty = Math.atan2( x * Math.cos(rotx), -z );
		 }
		 rotz = Math.atan2( Math.cos(rotx), Math.sin(rotx) * Math.sin(roty) );
	}
	
	public  void calc(double x, double y, double z) {

		// This is from brian's code

	      rx = Math.atan2(z, y) * 180.0/Math.PI;
	      ry = Math.atan2(z, x) * 180.0/Math.PI;
	      rz = Math.atan2(x, y) * 180.0/Math.PI;
	
		rotx = 180.0 - rx;
		roty = 180.0 - ry;
		rotz = Math.abs(rz);
	}
	
	public  void calc3(double x, double y, double z) {
		
	      rx = Math.atan2(z, y);
	      ry = Math.atan2(z, x);
	      rz = Math.atan2(x, y);
	
		rotx =  rx * 180.0/Math.PI;
		roty =  ry * 180.0/Math.PI;
		rotz =  rz * 180.0/Math.PI;
	}
	
	public static void main(String[] args) {
		RotationCalculator rc = new RotationCalculator();
		rc.doit();
	}
	
	
	private void doit() {
		
		BufferedWriter bw = Utilities.openFileForWriting("Rotate.tab");
		double x, y, z;
		
		try {
			bw.append("x\ty\tz\trx\try\trz\trotx\troty\trotz\n");
			for (x = -10.0; x <= 10.0; x += 1.0) {
				for (y = -10.0; y <= 10.0; y += 1.0) {
					for (z = 0.0; z <= 0.0; z += 1.0) {
//						calc(x,y,z);
//						bw.append(x+"\t"+y+"\t"+z+"\t"+rx+"\t"+ry+"\t"+rz+"\t"+rotx+"\t"+roty+"\t"+rotz+"\n");
						calc3(x,y,z);
						bw.append(x+"\t"+y+"\t"+z+"\t"+rx+"\t"+ry+"\t"+rz+"\t"+rotx+"\t"+roty+"\t"+rotz+"\n");
					}
				}
			}
			bw.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public double getRx() {
		return rx;
	}

	public double getRy() {
		return ry;
	}

	public double getRz() {
		return rz;
	}

	public double getRotx() {
		return rotx;
	}

	public double getRoty() {
		return roty;
	}

	public double getRotz() {
		return rotz;
	}

}
