package gov.anl.gss.sdm.server.model.visualization3d;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class VarToVar {
	
	/*
	 * data structure that holds min distance to another variable
	 */
	
	private Variable variable;
	private Map<String, List<Variable>> dist;
	
	public VarToVar(Variable variable) {
		this.variable = variable;
		dist = new LinkedHashMap<String, List<Variable>>();
	}
	
	public void add(Variable variable, String distance) {
		if (!dist.containsKey(distance)) {
			dist.put(distance, new ArrayList<Variable>());
		}
		List<Variable> set = dist.get(distance);
		set.add(variable);
	}
	
	public List<Variable> getVarsOfTypeAtDistance(String type, String distance) {
		List<Variable> set = new ArrayList<Variable>();
		if (dist.containsKey(distance)) {
			set.addAll(varsOfType(type, dist.get(distance)));
		}
		return set;
	}
	
	public List<Variable> varsOfType(String type, List<Variable> someSet) {
		List<Variable> set = new ArrayList<Variable>();
		
		for (Variable var : someSet) {
			if (var.isOfType(type))
				set.add(var);
		}
		return set;
	}
	
	public Variable dist1() {
		// find variable of any type for which there is only 1 connection of length 1
		if (dist.containsKey("1")) {
			if (dist.get("1").size() == 1) {
				return dist.get("1").get(0);
			} else {
				return null;
			}
		}
		return null;
	}

	public Variable getVariable() {
		return variable;
	}

	public Map<String, List<Variable>> getDist() {
		return dist;
	}

}
