package gov.anl.gss.sdm.server.model.xmile;

import org.w3c.dom.Element;

public class Alias extends XmileObject {

	private String uid;
	private String x;
	private String y;
	
	private Name of;

	public Alias(Element aliasElement) {

		if (XMLUtilities.hasAttribute(aliasElement, "x"))
			x = XMLUtilities.getAttribute(aliasElement, "x");
		else
			wellFormed = false;
		if (XMLUtilities.hasAttribute(aliasElement, "y"))
			y = XMLUtilities.getAttribute(aliasElement, "y");
		else
			wellFormed = false;

		if (XMLUtilities.hasAttribute(aliasElement, "uid"))
			uid = XMLUtilities.getAttribute(aliasElement, "uid");
		else
			wellFormed = false;
		
		if (XMLUtilities.hasElementWithTag(aliasElement, "of")) {
			of = new Name(XMLUtilities.getNodeValue(aliasElement));
		} else {
			wellFormed = false;
		}

	}

	@Override
	protected void print() {
		System.out.println("Alias: x: "+x+" y: "+y+" uid: "+uid+" of: "+of.getAsAppears());

	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}

	/**
	 * @return the uid
	 */
	public String getUid() {
		return uid;
	}

	/**
	 * @return the x
	 */
	public String getX() {
		return x;
	}

	/**
	 * @return the y
	 */
	public String getY() {
		return y;
	}

	/**
	 * @return the of
	 */
	public Name getOf() {
		return of;
	}

}
