package gov.anl.gss.sdm.server.model.xmile;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class Auxiliary extends BuildingBlock {

	public Auxiliary(String modelName, Node auxNode) {
		super(modelName, auxNode);
		type = BuildingBlock.AUX;
		
		if (XMLUtilities.hasElementWithTag(auxNode, "gf")) {
			Element element = XMLUtilities.getElementWithTag(auxNode, "gf");
				GraphicalFunction r = new GraphicalFunction(element);
				if (r.isWellFormed())
					graphicalFunction = r;
				else
					error("grahical function");
			
		} 
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}

	@Override
	public String getEquation() {
		
		String lookupName = "";
		StringBuilder sb = new StringBuilder(getComment());

		sb.append(name.getNormalizedNameQuoted()+getLhsArrayReference());
		sb.append(" = ");
		if (isGraphicalFunction()) {
//			sb.append(lookupName+"("+eqns.get(0).getEquation()+")");
			sb.append("WITH LOOKUP(\n"+eqns.get(0).getEquation()+",\n");
		} else {
			if (eqns != null && eqns.size() > 0) {
				sb.append(eqns.get(0).getEquation());
			} else {
				if (access.equals("input")) {
					sb.append("SOME SHADOW VARIABLE");
					return "";
				} else {
					error("Missing Equation for generation");
				}
			}
		}

		
		return sb.toString();
	}

	@Override
	protected void print() {
		// TODO Auto-generated method stub
		
	}
}
