package gov.anl.gss.sdm.server.model.xmile;

import org.w3c.dom.Node;

public class Connect extends XmileObject {
	
	// this represents a "shadow" variable

	private Name to;
	private Name from;

	public Connect(Node connectNode) {

		if (XMLUtilities.hasAttribute(connectNode, "to")) {
			to = new Name(XMLUtilities.getAttribute(connectNode, "to"));
		} else {
			wellFormed = false;
		}

		if (XMLUtilities.hasAttribute(connectNode, "from")) {
			from = new Name(XMLUtilities.getAttribute(connectNode, "from"));
		} else {
			wellFormed = false;
		}


	}
	
	public String getEquation() {
		String units = null;
		String doc = null;
		return to.getNormalizedNameQuoted() + " = " + from.getNormalizedNameQuoted() +
				"\t~\t"+(units != null ? units : "")+"\t~\t"+(doc != null ? doc : "")+"|";
	}

	@Override
	protected void print() {
		System.out.println("Connect From: "+from.getAsAppears()+" To: "+to.getAsAppears());

	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
		if (to != null)
			to.disperse(xmileModel);
		if (from != null)
			from.disperse(xmileModel);
	}

	/**
	 * @return the to
	 */
	public Name getTo() {
		return to;
	}

	/**
	 * @return the from
	 */
	public Name getFrom() {
		return from;
	}

}
