package gov.anl.gss.sdm.server.model.xmile;

import org.w3c.dom.Node;

public class Connector extends XmileObject {
	
	private String uid;
	private String color;

	private String type = "connector";
	
	private To to;
	private From from;

	public Connector(String modelName, Node connectorNode) {
		if (XMLUtilities.hasElementWithTag(connectorNode, "from") &&
				XMLUtilities.hasElementWithTag(connectorNode, "to")) {
			To t = new To(modelName,XMLUtilities.getElementWithTag(connectorNode, "to"));
			if (t.isWellFormed()) {
				to = t;
			} else {
				wellFormed = false;
			}
			
			From f = new From(modelName,XMLUtilities.getElementWithTag(connectorNode, "from"));
			if (f.isWellFormed()) {
				from = f;
			} else {
				wellFormed = false;
			}
			
		} else {
			wellFormed = false;
		}
		
		uid = XMLUtilities.getAttribute(connectorNode, "uid");
		color = XMLUtilities.getAttribute(connectorNode, "color");
		x = XMLUtilities.getAttribute(connectorNode, "x");
		y = XMLUtilities.getAttribute(connectorNode, "y");
		type = XMLUtilities.getAttribute(connectorNode, "type");
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}

	@Override
	protected void print() {
		System.out.println("Connector:");
		from.print();
		to.print();
		
	}
	
	public String getName() {
		return from.getVariableName().getAsAppears() + "->" + to.getVariableName().getAsAppears();
	}

	/**
	 * @return the uid
	 */
	public String getUid() {
		return uid;
	}

	/**
	 * @return the color
	 */
	public String getColor() {
		return color;
	}

	/**
	 * @return the to
	 */
	public To getTo() {
		return to;
	}

	/**
	 * @return the from
	 */
	public From getFrom() {
		return from;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}
}
