package gov.anl.gss.sdm.server.model.xmile;

import org.w3c.dom.Node;

public class Contact extends XmileObject {
	
	// optional
	private String address;
	private String phone;
	private String fax;
	private String email;
	private String website;

	
	public Contact(Node contactNode) {
		address = XMLUtilities.getNodeValue(XMLUtilities.getElementWithTag(contactNode, "address"));
		phone = XMLUtilities.getNodeValue(XMLUtilities.getElementWithTag(contactNode, "phone"));
		fax = XMLUtilities.getNodeValue(XMLUtilities.getElementWithTag(contactNode, "fax"));
		email = XMLUtilities.getNodeValue(XMLUtilities.getElementWithTag(contactNode, "email"));
		website = XMLUtilities.getNodeValue(XMLUtilities.getElementWithTag(contactNode, "website"));
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}
	
	/**
	 * @return the address
	 */
	public String getAddress() {
		return address;
	}
	/**
	 * @return the phone
	 */
	public String getPhone() {
		return phone;
	}
	/**
	 * @return the fax
	 */
	public String getFax() {
		return fax;
	}
	/**
	 * @return the email
	 */
	public String getEmail() {
		return email;
	}
	/**
	 * @return the website
	 */
	public String getWebsite() {
		return website;
	}
	@Override
	protected void print() {
		System.out.println("Contact:");
		System.out.println("   address: "+address);
		System.out.println("   phone: "+phone);
		System.out.println("   fax: "+fax);
		System.out.println("   email: "+email);
		System.out.println("   website: "+website);
		
	}

}
