package gov.anl.gss.sdm.server.model.xmile;

import java.util.LinkedHashSet;
import java.util.Set;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class Dimensions extends XmileObject {

	private Set<Dimension> dimensions = new LinkedHashSet<Dimension>();

	public Dimensions(Node dimensionsNode) {

		if (XMLUtilities.hasElementsWithTag(dimensionsNode, "dim")) {
			for (Element element : XMLUtilities.getElementsWithTag(dimensionsNode, "dim")) {
				Dimension d = new Dimension(element);
				if (d.isWellFormed()) {
					dimensions.add(d);
				} else {
					wellFormed = false;
					System.out.println("Bad Dimension");
				}
			}
		} else {
			// this may need some extra code to see if just empty dimensions tag or bad tag
			wellFormed = true;
		}
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
		for (Dimension dim : dimensions)
			dim.disperse(xmileModel);
	}

	@Override
	protected void print() {
		for (Dimension dim : dimensions) {
			dim.print();
		}

	}

	/**
	 * @return the dimensions
	 */
	public Set<Dimension> getDimensions() {
		return dimensions;
	}
	
	public Dimension getDimensionWithName(String n) {
		Dimension d = null;
		for (Dimension dim : dimensions) {
			if (dim.getName().equals(n))
				return dim;
		}
		
		return d;
	}
}
