package gov.anl.gss.sdm.server.model.xmile;

import org.w3c.dom.Element;

public class Display extends XmileObject {
	
	private Points points;
	
	private String x;
	private String y;
	private String color;
	private String labelSide;
	private String labelAngle;
	
	public Display(String x, String y, String color, String labelSide, String labelAngle) {
		this.x = x;
		this.y = y;
		this.color = color;
		this.labelSide = labelSide;
		this.labelAngle = labelAngle;
	}

	public Display(Element displayElement) {
		
		if (XMLUtilities.hasElementWithTag(displayElement, "pts")) {
			Points pts = new Points(XMLUtilities.getElementWithTag(displayElement, "pts"));
			if (pts.isWellFormed())
				points = pts;
			
		} else {
			wellFormed = false;
		}
		
		x = XMLUtilities.getAttribute(displayElement, "x");
		y = XMLUtilities.getAttribute(displayElement, "y");
		color = XMLUtilities.getAttribute(displayElement, "color");
		labelSide = XMLUtilities.getAttribute(displayElement, "labelSide");
		labelAngle = XMLUtilities.getAttribute(displayElement, "labelAngle");
		
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}

	/**
	 * @return the points
	 */
	public Points getPoints() {
		return points;
	}

	/**
	 * @return the x
	 */
	public String getX() {
		return x;
	}

	/**
	 * @return the y
	 */
	public String getY() {
		return y;
	}

	/**
	 * @return the color
	 */
	public String getColor() {
		return color;
	}

	/**
	 * @return the labelSide
	 */
	public String getLabelSide() {
		return labelSide;
	}

	/**
	 * @return the labelAngle
	 */
	public String getLabelAngle() {
		return labelAngle;
	}

	@Override
	protected void print() {
		System.out.println("Display:");
		System.out.println("  x:"+x);
		System.out.println("  y:"+y);
		System.out.println("  color:"+color);
		System.out.println("  labelSide:"+labelSide);
		System.out.println("  labelAngle:"+labelAngle);
		
	}

}
