package gov.anl.gss.sdm.server.model.xmile;

import gov.anl.gss.sdm.server.model.translator.Parser;
import gov.anl.gss.sdm.server.model.xmile.utilities.FunctionMapping;
import gov.anl.gss.sdm.server.model.xmile.utilities.IfThenElseConverter;

import java.util.List;

import org.w3c.dom.Element;

public class Eqn extends XmileObject {
	private String equation;

	public Eqn(String modelName, Element docElement) {

		String e = XMLUtilities.getNodeValue(docElement).replace("\n", " ");
//		System.out.println("EQN Enter: "+e);
		
		List<String> tokens;
		
//		System.out.println("EQN: "+e);
//		if (e.contains("birth"))
//			System.out.println("trace me");

		if (Parser.isIfThenElse(e)) {
			IfThenElseConverter itec = new IfThenElseConverter(e);			
			String c = itec.getConvertedEquation();
//			System.out.println("Converted ITE: "+c);
			
			tokens = Parser.tokenize(c, false, false, true, false, false);
			
		} else {
			tokens = Parser.tokenize(e, false, false, true, false, false);
		}
//		System.out.println("In Eqn constructor"+tokens);
		if (tokens.contains("SINWAVE"))
			System.out.println("SINWAVE");
		
		int openSquare = 0;
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < tokens.size(); i++) {
			String s = tokens.get(i);
			if (s.equals("SINWAVE"))
				System.out.println("SINWAVE");
			if (s.equals("["))
				openSquare++;
			if (s.equals("]"))
				openSquare--;
			if (XmileUtilities.isIdentifier(s)) {
				// look ahead to see if this is a func invocation
				if (Parser.isQuotedString(s)) {
					sb.append(s);
				} else if (i < tokens.size()-1 && tokens.get(i+1).equals("(")) {
//					System.out.println("Think we have a function: "+s);
					sb.append(FunctionMapping.mapFunction(i, s, tokens));
				} else {
					if (XmileUtilities.isNoArgumentFunction(s)) {
						sb.append(s+"()");
					} else {
						if (openSquare > 0) {
							sb.append(s);
						} else {
							sb.append("\""+modelName+s+"\"");
						}
					}
				}
				
			} else {
				if (XmileUtilities.isNonIdentifier(s)) {
					sb.append(s);
				} else {
					sb.append("\""+modelName+s+"\"");
				}
			}
		}
		
		
		equation = sb.toString().replace("[*]", "");

		//		equation = XMLUtilities.getNodeValue(docElement);
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}

	/**
	 * @return the equation
	 */
	public String getEquation() {
		
		return equation;
	}

	@Override
	protected void print() {
		System.out.println("Eqn: ");
		System.out.println(equation);
		
	}

}
