package gov.anl.gss.sdm.server.model.xmile;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class Flow extends BuildingBlock {

	public Flow(String modelName, Node flowNode) {
		super(modelName, flowNode);
		type = BuildingBlock.FLOW;
		
		if (XMLUtilities.hasElementWithTag(flowNode, "gf")) {
			Element element = XMLUtilities.getElementWithTag(flowNode, "gf");
				GraphicalFunction r = new GraphicalFunction(element);
				if (r.isWellFormed())
					graphicalFunction = r;
				else
					error("grahical function");
			
		} 
		
		if (XMLUtilities.hasElementWithTag(flowNode, "pts")) {
			Element element = XMLUtilities.getElementWithTag(flowNode, "pts");
				Points r = new Points(element);
				if (r.isWellFormed())
					points = r;
				else
					error("points");
			
		}
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}

	@Override
	public String getEquation() {
		String lookupName = "";
		StringBuilder sb = new StringBuilder(getComment());
		if (isGraphicalFunction()) {
			lookupName = name.getNormalizedName()+"_lookup";
			sb.append(graphicalFunction.getLookup(lookupName)+"\n");
		} 


		sb.append(name.getNormalizedNameQuoted()+getLhsArrayReference());
		sb.append(" = ");
		if (isGraphicalFunction()) {
			sb.append(lookupName+"("+eqns.get(0).getEquation()+")");
		} else {
			
			if (eqns!= null && eqns.size() > 0) {
				sb.append(eqns.get(0).getEquation());
			} else {
				if (access != null) {
//					sb.append("SOME SHADOW VARIABLE");
					return "";
				} else {
					error("Missing eqn for generation");
				}
			}
		}
		


		return sb.toString();
	}

	@Override
	protected void print() {
		// TODO Auto-generated method stub
		
	}
}
