package gov.anl.gss.sdm.server.model.xmile;

import org.w3c.dom.Element;

public class From extends XmileObject {

	private Name variableName;
	private Alias alias;
	
	public From(String modelName, Element fromElement) {
		if (XMLUtilities.hasElementWithTag(fromElement, "alias")) {
			Alias a = new Alias(XMLUtilities.getElementWithTag(fromElement, "alias"));
			if (a.isWellFormed())
				alias = a;
			else
				wellFormed = false;
		} else {
			variableName = new Name(modelName+XMLUtilities.getNodeValue(fromElement));
		}
	}
	@Override
	protected void print() {
		if (hasAlias())
			alias.print();
		else
			System.out.println("From: "+variableName.getAsAppears());

	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
		if (variableName != null)
			variableName.disperse(xmileModel);
		if (alias != null)
			alias.disperse(xmileModel);
	}
	/**
	 * @return the variableName
	 */
	public Name getVariableName() {
		return variableName;
	}
	/**
	 * @return the alias
	 */
	public Alias getAlias() {
		return alias;
	}
	
	public boolean hasAlias() {
		return alias != null;
	}

}
