package gov.anl.gss.sdm.server.model.xmile;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Element;

public class Level2Display extends XmileObject {
	
	private String orientation;
	
	private List<Connector> connectors = new ArrayList<Connector>();
	
	public Level2Display(String modelName, Element displayElement) {
		if (XMLUtilities.hasElementsWithTag(displayElement, "connector")) {
			for (Element connector : XMLUtilities.getElementsWithTag(displayElement, "connector")) {
				Connector c = new Connector(modelName, connector);
				if (c.isWellFormed()) {
					connectors.add(c);
				} else {
					wellFormed = false;
				}
			}
		} else {
			wellFormed = false;
		}
		orientation = XMLUtilities.getAttribute(displayElement, "orientation");
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
		for (Connector c : connectors)
			c.disperse(xmileModel);
	}
	

	@Override
	protected void print() {

		System.out.println("Level2Display: Connectors for this model");
		for (Connector connector : connectors)
			connector.print();

	}

	/**
	 * @return the orientation
	 */
	public String getOrientation() {
		return orientation;
	}

	/**
	 * @return the connectors
	 */
	public List<Connector> getConnectors() {
		return connectors;
	}

}
