package gov.anl.gss.sdm.server.model.xmile;

import java.util.ArrayList;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class ModelUnits extends XmileObject {

	private Set<Unit> modelUnits = new LinkedHashSet<Unit>();

	public ModelUnits(Node modelUnitsNode) {
		for (Element element : XMLUtilities.getElementsWithTag(modelUnitsNode, "unit")) {
			Unit u = new Unit(element);
			if (u.isWellFormed())
				modelUnits.add(u);
			else
				wellFormed = false;
		}
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
		for (Unit u : modelUnits)
			u.disperse(xmileModel);
	}
	
	@Override
	protected List<String> asVensim() {
		List<String> aliases = new ArrayList<String>();
		for (Unit unit : modelUnits) {
			aliases.addAll(unit.asVensim());
		}
		return aliases;
	}

	@Override
	protected void print() {
		// TODO Auto-generated method stub

	}

	/**
	 * @return the modelUnits
	 */
	public Set<Unit> getModelUnits() {
		return modelUnits;
	}
}
