package gov.anl.gss.sdm.server.model.xmile;

import gov.anl.gss.sdm.server.model.translator.Parser;


public class Name extends XmileObject {
	
	private String asAppears;
	private String normalizedName;

	public Name(String asAppears) {
		
		this.asAppears = asAppears;
		if (asAppears == null || asAppears.equals("null")) {
			this.asAppears = "No Name Supplied";
			System.out.println("BREAK no name");
		}
		
		this.asAppears = Parser.removeAllQuotes(this.asAppears);
		
		normalizedName = normalize(this.asAppears);
	}

	@Override
	protected void print() {
		System.out.println("Name: "+getAsAppears());

	}
	
	private String normalize(String identifier) {
		String id = new String(identifier);
		id = id.replace(" ", "_");
		id = id.replace("\\n", "_");
		id = id.replace("\\t", "");
//		id = id.replaceAll("_+", " ").trim();		
//		return "\""+id+"\"";
		return id;
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}

	/**
	 * @return the asAppears
	 */
	public String getAsAppears() {
//		return asAppears;
		return normalizedName;
	}

	/**
	 * @return the effectiveName
	 */
	public String getNormalizedName() {
//		return getNormalizedNameQuoted();
		return normalizedName;
	}
	
	public String getNormalizedNameQuoted() {
		return "\""+normalizedName+"\"";
	}
	
	/**
	 * @return the effectiveName
	 */
	public String getJavaName() {
		return normalizedName.replace(" ", "_");
	}
	
	public boolean equals(String s) {
		return s.equals(asAppears) || s.equals(normalizedName);
	}
}
