package gov.anl.gss.sdm.server.model.xmile;

import org.w3c.dom.Node;

public class Point extends XmileObject {
	
	private String x;
	private String y;
	
	public Point(Node pointNode) {
		if (XMLUtilities.hasAttribute(pointNode, "x") && XMLUtilities.hasAttribute(pointNode, "y")) {
			x = XMLUtilities.getAttribute(pointNode, "x");
			y = XMLUtilities.getAttribute(pointNode, "y");
		} else {
			error("Expecting x and y coordinates");
			wellFormed = false;
		}
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}

	/**
	 * @return the x
	 */
	public String getX() {
		return x;
	}

	/**
	 * @return the y
	 */
	public String getY() {
		return y;
	}

	@Override
	protected void print() {
		System.out.println("Point: x: "+x+" y: "+y);
		
	}

}
