package gov.anl.gss.sdm.server.model.xmile;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class Points extends XmileObject {
	
	List<Point> points = new ArrayList<Point>();
	
	public Points(Node pointsNode) {
		if (XMLUtilities.hasElementsWithTag(pointsNode, "pt")) {
			for (Element element : XMLUtilities.getElementsWithTag(pointsNode, "pt")) {
				Point point = new Point(element);
				if (point.isWellFormed()) {
					points.add(point);
				} else {
					wellFormed = false;
				}
			}
		}
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
		for (Point p : points)
			p.disperse(xmileModel);
	}

	@Override
	protected void print() {
		System.out.println("Points:");
		for (Point point : points)
			point.print();
		
	}

	public List<Point> getPoints() {
		return points;
	}

}
