package gov.anl.gss.sdm.server.model.xmile;

import org.w3c.dom.Node;

public class Product extends XmileObject {

	private Name name;
	private String version;
	private String lang;

	public Product(Node productNode) {
		if (XMLUtilities.hasAttribute(productNode, "version")) {
			version = XMLUtilities.getAttribute(productNode, "version");
		} else {
			error("Required product version is missing");
			wellFormed = false;
		}
		if (XMLUtilities.hasAttribute(productNode, "lang")) {
			lang = XMLUtilities.getAttribute(productNode, "lang");
		}
		if (XMLUtilities.hasAttribute(productNode, "name")) {
			name = new Name(XMLUtilities.getNodeValue(productNode));
		}

	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
		if (name != null)
			name.disperse(xmileModel);
	}
	
	/**
	 * @return the name
	 */
	public String getName() {
		return name.getAsAppears();
	}
	/**
	 * @return the version
	 */
	public String getVersion() {
		return version;
	}
	/**
	 * @return the lang
	 */
	public String getLang() {
		return lang;
	}
	@Override
	protected void print() {
		System.out.println("Product:");
		System.out.println("   name: "+getName());
		System.out.println("   version: "+version);
		System.out.println("   lang: "+lang);
	}

}
