package gov.anl.gss.sdm.server.model.xmile;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public abstract class ViewBuildingBlock extends XmileObject {
	
	protected final static String STOCK = "stock";
	protected final static String AUX = "aux";
	protected final static String FLOW = "flow";
	protected final static String ARRAY = "array";
	
	protected String type = "undefined";
	
	private Points points;
	
	// required
//	protected Name name;
	protected Display display;
	
	protected String color;
	protected String labelSide;
	protected String labelAngle;
	
	
	public ViewBuildingBlock(String modelName, Node bbNode) {
		Element e = (Element) bbNode;
		name = new Name(modelName+e.getAttribute("name"));
		x = XMLUtilities.getAttribute(e, "x");
		y = XMLUtilities.getAttribute(e, "y");
		color = e.getAttribute("color");
		labelSide = e.getAttribute("label_side");
		labelAngle = e.getAttribute("label_angle");
		display = new Display(x,y,color,labelSide,labelAngle);
		
		if (XMLUtilities.hasElementWithTag(bbNode, "pts")) {
			Points pts = new Points(XMLUtilities.getElementWithTag(bbNode, "pts"));
			if (pts.isWellFormed()) {
				points = pts;
				wellFormed = true;
			} else {  
				wellFormed = false;
			}
		}
		
	}
	
	public void print() {
		System.out.println("VBB: type: "+type+" name: "+name.getAsAppears());
	}


	/**
	 * @return the type
	 */
	public String getType() {
		return type;
	}


	/**
	 * @return the display
	 */
	public Display getDisplay() {
		return display;
	}

	public Name getNameAsName() {
		return name;
	}

	public String getColor() {
		return color;
	}

	public String getLabelSide() {
		return labelSide;
	}

	public String getLabelAngle() {
		return labelAngle;
	}

	public Points getPoints() {
		return points;
	}
	

}

