package gov.anl.gss.sdm.server.model.xmile;

import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class Views extends XmileObject {
	
	private Set<View> views = new LinkedHashSet<View>();
	
	public Views(String modelName, Node viewsNode, Map<String, ViewBuildingBlock> viewVariableInfo) {
		
		if (XMLUtilities.hasElementsWithTag(viewsNode, "view")) {
			for (Element element : XMLUtilities.getElementsWithTag(viewsNode, "view")) {
				View v = new View(modelName, element, viewVariableInfo);
				if (v.isWellFormed())
					views.add(v);
				else
					wellFormed = false;
			}
		} else {
			wellFormed = false;
		}
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
		for (View x : views)
			x.disperse(xmileModel);
	}

	@Override
	protected void print() {
		for (View view : views)
			view.print();

	}

	/**
	 * @return the views
	 */
	public Set<View> getViews() {
		return views;
	}

}
