package gov.anl.gss.sdm.server.model.xmile;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class XMLUtilities {
	
	public static final List<String> errorMessages = new ArrayList<String>();
	public static final List<String> messages = new ArrayList<String>();
	
	public static void addErrorMessage(String msg) {
		errorMessages.add(msg);
	}
	
	public static void addMessage(String msg) {
		messages.add(msg);
	}
	
	public static int elementCountWithTag(Node node, String tag) {

		int found = 0;

		// here we assume only one
		if (node.getNodeType() == Node.ELEMENT_NODE) {
			Element anElement = (Element) node;
			NodeList nodeList = anElement.getElementsByTagName(tag);
			for (int i = 0; i < nodeList.getLength(); i++) {
				Node aNode = nodeList.item(i);
				if (aNode.getParentNode().equals(node)) {
					if (aNode.getNodeType() == Node.ELEMENT_NODE) {
						found++;
					}
				}
			}
		}
		return found;
	}
	
	public static Element getElementWithTag(Node node, String tag) {

		// here we assume only one
		if (node.getNodeType() == Node.ELEMENT_NODE) {
			Element anElement = (Element) node;
			Node n = anElement.getElementsByTagName(tag).item(0);
			if (n == null)
				return null;
			if (n.getNodeType() == Node.ELEMENT_NODE) {
				Element toReturn = (Element) n;
				return toReturn;
			}
		}
		return null;
	}
	
	public static boolean hasElementsWithTag(Node node, String tag) {

		int found = 0;

		// here we look for one or more 
		if (node.getNodeType() == Node.ELEMENT_NODE) {
			Element anElement = (Element) node;
			NodeList nodeList = anElement.getElementsByTagName(tag);
			for (int i = 0; i < nodeList.getLength(); i++) {
				Node aNode = nodeList.item(i);
				if (aNode.getParentNode().equals(node)) {
					if (aNode.getNodeType() == Node.ELEMENT_NODE) {
						found++;
					}
				}
			}
		}
		return found > 0;
	}
	
	public static List<Element> getElementsWithTag(Node node, String tag) {

		List<Element> elements = new ArrayList<Element>();
		// here we assume only one
		if (node.getNodeType() == Node.ELEMENT_NODE) {

			Element anElement = (Element) node;
			NodeList nl = anElement.getElementsByTagName(tag);
			for (int i = 0; i < nl.getLength(); i++) {

				Node n = anElement.getElementsByTagName(tag).item(i);
				if (n.getParentNode().equals(node)) {
				if (n.getNodeType() == Node.ELEMENT_NODE) {
					elements.add((Element) n);
				}
				}
			}
		}
		return elements;

	}
	
	public static boolean hasAttribute(Node node, String attribute) {
		String attr = null;
		if (node.getNodeType() == Node.ELEMENT_NODE) {

			Element anElement = (Element) node;
			attr = anElement.getAttribute(attribute);
			return attr.length() != 0;
		}
		
		return false;
	}
	
	public static String getAttribute(Node node, String attribute) {
		String attr = null;
		if (node.getNodeType() == Node.ELEMENT_NODE) {

			Element anElement = (Element) node;
			attr = anElement.getAttribute(attribute);
		}
		
		return attr;
	}
	
	public static String getNodeValue(Node node) {
		String attr = null;
		if (node != null) {
			if (node.getNodeType() == Node.ELEMENT_NODE) {
				Element anElement = (Element) node;
				if (anElement == null || anElement.getChildNodes() == null || anElement.getChildNodes().item(0) == null) {
					return null;
				} else {
				attr = anElement.getChildNodes().item(0).getNodeValue();
				}
			}
		}

		return attr;
	}

	public  static boolean hasElementWithTag(Node node, String tag) {

		int found = 0;

		// here we assume only one
		if (node.getNodeType() == Node.ELEMENT_NODE) {
			Element anElement = (Element) node;
			NodeList nodeList = anElement.getElementsByTagName(tag);
			for (int i = 0; i < nodeList.getLength(); i++) {
				Node aNode = nodeList.item(i);
				if (aNode.getParentNode().equals(node)) {
					if (aNode.getNodeType() == Node.ELEMENT_NODE) {
						found++;
					}
				}
			}
		}
		return found == 1;
	}
	


}
