package gov.anl.gss.sdm.server.model.xmile;

import gov.anl.gss.sdm.server.model.documentor.xmlwriter.NumberFormatter;

import org.w3c.dom.Element;

public class XPoints extends XmileObject {

	private String xpoints;

	public XPoints(Element xptsElement) {
		xpoints = XMLUtilities.getNodeValue(xptsElement);
	}
	
	public XPoints(XScale xScale, int numPoints) {
		StringBuilder sb = new StringBuilder(xScale.getMin());
		double start = Double.parseDouble(xScale.getMin());
		double range = Double.parseDouble(xScale.getMax()) - Double.parseDouble(xScale.getMin());
		double increment = range / numPoints;
		for (int i=1; i < numPoints-1; i++) {
			sb.append(",");
//			sb.append(Double.toString(start + ((double) i) / (double) (numPoints-1)));
			sb.append(NumberFormatter.formatForSmall(start + (i*increment)));
		}
		
		sb.append(",");
		sb.append(xScale.getMax());
		xpoints = sb.toString();
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}


	@Override
	protected void print() {
		System.out.println("XPoints: "+xpoints);

	}


	/**
	 * @return the xpoints
	 */
	public String getXpoints() {
		return xpoints;
	}
	
	public int getNumPoints() {
		return xpoints.split(",").length;
	}

}
