package gov.anl.gss.sdm.server.model.xmile;

import gov.anl.gss.sdm.server.model.translator.InformationManagers;

import java.io.File;
import java.io.IOException;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;


public class XmileReader {

	private String xmlFile;

	public XmileReader(String xmlFile) {
		this.xmlFile = xmlFile;
	}


	public static void main(String[] args) throws Exception {
		XmileReader reader = new XmileReader(args[0]);
		reader.process();
	}
	
	public void readAndTranslate() {
		InformationManagers.getInstance().getFunctionManager().load("./data/implementedFunctions.txt");
		process();
	}
	
	public void process() {
		XmileModel model = loadModel();
		if (model != null) {
//			EquationBuilder eb = new EquationBuilder(model);
//			Map<String, Equation> equations = eb.build();
			GraphicsBuilder gb = new GraphicsBuilder(model);
			List<String> raw = gb.buildRaw();
			System.out.println("Raw Size = "+raw.size());
		} else {
			System.out.println("Model load failed");
		}
	}

	public XmileModel loadModel() {

		Document doc = null;

		try {
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
			doc = docBuilder.parse(new File(xmlFile));
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


		XmileModel model =  new XmileModel(doc);
//		model.print();
//		model.printVensimToConsole();
		String file = getMDLFileName();
		model.writeVensimToFile(file);
		if (model.isWellFormed()) {
			return model;
		} else {
			return null;
		}
	}
	
	private String getMDLFileName() {
//		return xmlFile.replaceAll("\\.[Xx][Mm][Ii][Ll][Ee]$", "_xmile.mdl");
		return gov.anl.gss.sdm.server.model.support.Utilities.getConvertedFileName(xmlFile);
	}

}
