package gov.anl.gss.sdm.server.model.xmile.options;

import gov.anl.gss.sdm.server.model.xmile.XMLUtilities;
import gov.anl.gss.sdm.server.model.xmile.XmileModel;

import org.w3c.dom.Node;

public class UsesArrays extends AbstractUses {

	private String maximumDimensions;
	private String invalidIndexValue = "NaN";
	
	public UsesArrays(Node usesArrayNode) {
		if (XMLUtilities.hasAttribute(usesArrayNode, "maximum_dimensions")) {
			maximumDimensions = XMLUtilities.getAttribute(usesArrayNode, "maximum_dimensions");
		} else {
			wellFormed = false;
		}
		
		if (XMLUtilities.hasAttribute(usesArrayNode, "invalidIndexValue")) {
			invalidIndexValue = XMLUtilities.getAttribute(usesArrayNode, "invalidIndexValue");
		}
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}

	@Override
	protected void print() {
		// TODO Auto-generated method stub
		
	}

	/**
	 * @return the maximumDimensions
	 */
	public String getMaximumDimensions() {
		return maximumDimensions;
	}

	/**
	 * @return the invalidIndexValue
	 */
	public String getInvalidIndexValue() {
		return invalidIndexValue;
	}
}
