package gov.anl.gss.sdm.server.model.xmile.options;

import gov.anl.gss.sdm.server.model.xmile.XMLUtilities;
import gov.anl.gss.sdm.server.model.xmile.XmileModel;

import org.w3c.dom.Node;

public class UsesInputs extends AbstractUses {

	private boolean numericInput = false;
	private boolean list = false;
	private boolean graphicalInput = false;
	
	public UsesInputs(Node usesInputsNode) {
		if (XMLUtilities.hasAttribute(usesInputsNode, "numeric_input")) {
			numericInput = Boolean.parseBoolean(XMLUtilities.getAttribute(usesInputsNode, "numeric_input"));
		} 
		
		if (XMLUtilities.hasAttribute(usesInputsNode, "list")) {
			list = Boolean.parseBoolean(XMLUtilities.getAttribute(usesInputsNode, "list"));
		} 
		
		if (XMLUtilities.hasAttribute(usesInputsNode, "graphical_input")) {
			graphicalInput = Boolean.parseBoolean(XMLUtilities.getAttribute(usesInputsNode, "graphical_input"));
		} 
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}
	
	@Override
	protected void print() {
		// TODO Auto-generated method stub
		
	}
	/**
	 * @return the numericInput
	 */
	public boolean isNumericInput() {
		return numericInput;
	}
	/**
	 * @return the list
	 */
	public boolean isList() {
		return list;
	}
	/**
	 * @return the graphicalInput
	 */
	public boolean isGraphicalInput() {
		return graphicalInput;
	}
}
