package gov.anl.gss.sdm.server.model.xmile.options;

import gov.anl.gss.sdm.server.model.xmile.XMLUtilities;
import gov.anl.gss.sdm.server.model.xmile.XmileModel;

import org.w3c.dom.Node;

public class UsesMacros extends AbstractUses {

	private boolean referencesMacros;
	private boolean optionFilters;
	
	public UsesMacros(Node usesMacrosNode) {
		if (XMLUtilities.hasAttribute(usesMacrosNode, "references_macros")) {
			referencesMacros = Boolean.parseBoolean(XMLUtilities.getAttribute(usesMacrosNode, "references_macros"));
		} else {
			wellFormed = false;
		}
		
		if (XMLUtilities.hasAttribute(usesMacrosNode, "option_filters")) {
			optionFilters = Boolean.parseBoolean(XMLUtilities.getAttribute(usesMacrosNode, "option_filters"));
		}  else {
			wellFormed = false;
		}
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}
	
	@Override
	protected void print() {
		// TODO Auto-generated method stub
		
	}
	/**
	 * @return the referencesMacros
	 */
	public boolean isReferencesMacros() {
		return referencesMacros;
	}
	/**
	 * @return the optionFilters
	 */
	public boolean isOptionFilters() {
		return optionFilters;
	}


}
