package gov.anl.gss.sdm.server.model.xmile.options;

import gov.anl.gss.sdm.server.model.xmile.XMLUtilities;
import gov.anl.gss.sdm.server.model.xmile.XmileModel;

import org.w3c.dom.Node;

public class UsesOutputs extends AbstractUses {

	private boolean numericDisplay = false;
	private boolean lamp = false;
	private boolean gauge = false;
	
	public UsesOutputs(Node usesOutputsNode) {
		if (XMLUtilities.hasAttribute(usesOutputsNode, "numeric_display")) {
			numericDisplay = Boolean.parseBoolean(XMLUtilities.getAttribute(usesOutputsNode, "numeric_display"));
		} 
		
		if (XMLUtilities.hasAttribute(usesOutputsNode, "lamp")) {
			lamp = Boolean.parseBoolean(XMLUtilities.getAttribute(usesOutputsNode, "lamp"));
		} 
		
		if (XMLUtilities.hasAttribute(usesOutputsNode, "gauge")) {
			gauge = Boolean.parseBoolean(XMLUtilities.getAttribute(usesOutputsNode, "gauge"));
		} 
	}
	
	public void disperse(XmileModel xmileModel) {
		setXmileModel(xmileModel);
	}
	
	@Override
	protected void print() {
		// TODO Auto-generated method stub
		
	}
	/**
	 * @return the numericDisplay
	 */
	public boolean isNumericDisplay() {
		return numericDisplay;
	}
	/**
	 * @return the lamp
	 */
	public boolean isLamp() {
		return lamp;
	}
	/**
	 * @return the gauge
	 */
	public boolean isGauge() {
		return gauge;
	}
}
