package gov.anl.gss.sdm.server.model.xmile.utilities;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class FunctionMapping {

	private static Map<String, String> xmileToSDMDocFunction = new LinkedHashMap<String, String>();	

	static {

		xmileToSDMDocFunction.put("EXPRND#1", "XmileEXPRND1");
		xmileToSDMDocFunction.put("EXPRND#2", "XmileEXPRND2");

		xmileToSDMDocFunction.put("LOGNORMAL#2", "XmileLOGNORMAL2");
		xmileToSDMDocFunction.put("LOGNORMAL#3", "XmileLOGNORMAL3");

		xmileToSDMDocFunction.put("NORMAL#2", "XmileNORMAL2");
		xmileToSDMDocFunction.put("NORMAL#3", "XmileNORMAL3");

		xmileToSDMDocFunction.put("POISSON#2", "XmilePOISSON2");
		xmileToSDMDocFunction.put("POISSON#3", "XmilePOISSON3");

		xmileToSDMDocFunction.put("RANDOM#2", "XmileRANDOM2");
		xmileToSDMDocFunction.put("RANDOM#3", "XmileRANDOM3");

		xmileToSDMDocFunction.put("DELAY#2", "XmileDELAY2");
		xmileToSDMDocFunction.put("DELAY#3", "XmileDELAY3");

		xmileToSDMDocFunction.put("DELAY1#2", "XmileDELAY12");
		xmileToSDMDocFunction.put("DELAY1#3", "XmileDELAY13");

		xmileToSDMDocFunction.put("DELAY3#2", "XmileDELAY32");
		xmileToSDMDocFunction.put("DELAY3#3", "XmileDELAY33");

		xmileToSDMDocFunction.put("DELAYN#3", "XmileDELAYN3");
		xmileToSDMDocFunction.put("DELAYN#4", "XmileDELAYN4");

		xmileToSDMDocFunction.put("FORCST#3", "XmileFORCST3");
		xmileToSDMDocFunction.put("FORCST#4", "XmileFORCST4");

		xmileToSDMDocFunction.put("SMTH1#2", "XmileSMTH12");
		xmileToSDMDocFunction.put("SMTH1#3", "XmileSMTH13");

		xmileToSDMDocFunction.put("SMTH3#2", "XmileSMTH32");
		xmileToSDMDocFunction.put("SMTH3#3", "XmileSMTH33");

		xmileToSDMDocFunction.put("SMTHN#3", "XmileSMTHN3");
		xmileToSDMDocFunction.put("SMTHN#4", "XmileSMTHN4");

		xmileToSDMDocFunction.put("TREND#2", "XmileTREND2");
		xmileToSDMDocFunction.put("TREND#3", "XmileTREND3");

		xmileToSDMDocFunction.put("PULSE#2", "XmilePULSE2");
		xmileToSDMDocFunction.put("PULSE#3", "XmilePULSE3");
		
		xmileToSDMDocFunction.put("SINWAVE#2", "XmileSINWAVE2");

	};


	public static String mapFunction(int ptr, String funcToken, List<String> eqnTokens) {
		String key = funcToken+"#"+numParams(ptr, funcToken, eqnTokens);
		if (xmileToSDMDocFunction.containsKey(key)) {
			return xmileToSDMDocFunction.get(key);
		} else {
			return funcToken;
		}

	}

	private static int numParams(int ptr, String funcToken,List<String> eqnTokens) {
		int numComma = 0;
		int p = ptr;
		int openParen = 0;
		for (int i = p; i < eqnTokens.size(); i++) {
			String s = eqnTokens.get(i);
			if (s.equals("(")) {
				openParen++;
			}
			if (s.equals(")")) {
				openParen--;
			}
			
			if (openParen == 1 && s.equals(",")) {
				numComma++;
			}
		}
		return numComma+1;
	}
	
	public static boolean isXmileFunction(String funcToken) {
		
		for (String xmlFunc : xmileToSDMDocFunction.values()) {
			if (xmlFunc.startsWith("Xmile"+funcToken)) {
				return true;
			}
		}
		return false;
	}
}
