package gov.anl.gss.sdm.server.model.xmile.utilities;

import gov.anl.gss.sdm.server.model.support.Utilities;
import gov.anl.gss.sdm.server.model.translator.Parser;

import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;


public class TreeProcessor {
	
	private String treeFile;
	
	public TreeProcessor(String treeFile) {
		this.treeFile = treeFile;
	}
	
	private void process() {
		Set<String> paths = new LinkedHashSet<String>();
		List<String> path = new ArrayList<String>();
		List<String> lines = Utilities.getAsList(treeFile);
		int currentLevel = -1;
		for (String line : lines) {
			int l = getLevel(line);
			if (l > currentLevel) {
				path.add(line.replace("\t", ""));
				currentLevel = l;
			} else {
				// save this complete path if previously found
				String p = asPath(path);
				if (!paths.contains(p))
					paths.add(p);
				int toRemove = currentLevel - l + 1;
				for (int i = 0; i < toRemove; i++)
					path.remove(path.size()-1);
				path.add(line.replace("\t", ""));
				currentLevel = l;
			}
		}
		
		for (String p : sorted(paths))
			System.out.println(p);
	}
	
	private List<String> sorted(Set<String> s) {
		List<String> al = new ArrayList<String>(s);
		Collections.sort(al);
		return al;
	}
	
	private String asPath(List<String> path) {
		StringBuilder sb = new StringBuilder();
		for (String p : path)
			sb.append(p);
		
		return sb.toString();
	}

	
	public static void main(String[] args) throws Exception {
//		TreeProcessor tp = new TreeProcessor("data/tree.txt");
		TreeProcessor tp = new TreeProcessor("data/housingTree.txt");
		tp.process();
	}
	
	private int getLevel(String tag) {
		int i = 0;
		while (Parser.characterAt(i++, tag).equals("\t"));
		return i;
	}
}
