package gov.anl.gss.sdm.server.model.xmile.utilities;

import gov.anl.gss.sdm.server.model.translator.Parser;

import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class VensimToXmileFormatter {
	
	public static String format(String s1) {

		String s = translate(s1);
		String formatted = new String(s.replace("\t~", "~").replace("\t|", "|"));
//		if (s.contains("WITH LOOK")) {
//			System.out.println("WITH LOOK Break");
//		}
//			String[] parts = formatted.split("WITH LOOKUP \\(");
//			String[] args = parts[1].split(",",2);
//			formatted = parts[0]+"WITH LOOKUP(\n\t"+args[0]+",\n\t"+args[1].replace("~", "\n\t~").replace("|", "\n\t|\n");
//			
//		} else {
			formatted = formatted.replaceFirst("=", "=\n\t").replace("~", "\n\t~\t").
					replace("<<MULTI>>", "\t~~|\n").
					replace("<<VERT>>", "vbar").replaceFirst("\\|$", "\n\t|\n");
			
//		}
		String la = adjust(formatted);
//		System.out.println("FORMAT: "+s1);
//		System.out.println("LA: "+la);
		return la;
	}
	
	private static String translate(String s1) {
		
		String s = new String(s1);
		// perform any required translations
		
		// & in name
		
//		s = s.replace("&", "_amp_");
		
		// Random(x,y) ==> x + (RANDOM 0 1() * (y-x))
		
		int startPos = 0;
		
		while (containsRandomInvocation(s)) {
			
			int start = Parser.functionStart(s, "RANDOM", startPos);
			List<String> fAndA = Parser.extractFunctionAndArguments(s, start);
			String original = asString(fAndA);
			String invoke = fAndA.get(1) + "+ (RANDOM 0 1 () * ("+fAndA.get(2)+"-"+fAndA.get(1)+"))";
//			System.out.println("\nRANDOM IN: "+s);
			s = s.replace(original, invoke);
//			System.out.println("RANDOM OUT: "+s);
			startPos= start + 1;
		}
		
		startPos = 0;
		
//		2.0E-149
//		2.-E127
		
		while (containsNormal2ArgInvocation(s) || containsNormal3ArgInvocation(s)) {
			
			int start = Parser.functionStart(s, "NORMAL", startPos);
			List<String> fAndA = Parser.extractFunctionAndArguments(s, start);
			String original = asString(fAndA);
			String invoke = "RANDOM NORMAL(2.0E-149, 2.0E-149, " +fAndA.get(1)+", "+fAndA.get(2)+",0)";
			System.out.println("\nNORMAL IN: "+s);
			s = s.replace(original, invoke);
			System.out.println("NORMAL OUT: "+s);
			startPos= start + 1;
		}
		
		startPos = 0;
		
		// INT()
		
		while (containsIntInvocation(s)) {

			int start = Parser.functionStart(s, "INT", startPos);
			List<String> fAndA = Parser.extractFunctionAndArguments(s, start);
			String original = asString(fAndA);
			String invoke = original.replaceFirst("[iI][nN][tT] *\\(", "INTEGER(");
//			System.out.println("\nINT IN: "+s);
			s = s.replace(original, invoke);
//			System.out.println("INT OUT: "+s);
			startPos= start + 1;
		}
		
		
		// PULSE
		while (containsPulse2ArgInvocation(s)) {

			
			int start = Parser.functionStart(s, "PULSE", startPos);
			List<String> fAndA = Parser.extractFunctionAndArguments(s, start);
			String original = asString(fAndA);
			String invoke = fAndA.get(1) + "* PULSE TRAIN("+fAndA.get(2)+", TIME STEP, FINAL TIME - INITIAL TIME, FINAL TIME)";
//			System.out.println("\nPULSE2 IN: "+s);
			s = s.replace(original, invoke);
//			System.out.println("PULSE2 OUT: "+s);
			startPos= start + 1;
		}
		
		while (containsPulse3ArgInvocation(s)) {
			
			int start = Parser.functionStart(s, "PULSE", startPos);
			List<String> fAndA = Parser.extractFunctionAndArguments(s, start);
			String original = asString(fAndA);
			String invoke = fAndA.get(1) + "* PULSE TRAIN("+fAndA.get(2)+", TIME STEP, "+fAndA.get(3)+", FINAL TIME)";
//			System.out.println("\nPULSE3 IN: "+s);
			s = s.replace(original, invoke);
//			System.out.println("PULSE3 OUT: "+s);
			startPos= start + 1;
		}

		return s;
	}
	
	private static String asString(List<String> aList) {
		StringBuilder sb = new StringBuilder();
		
		int i = 0;
		for (String s : aList) {
			sb.append(s);
			if (i == 0)
				sb.append("(");
			else if (i < aList.size()-1)
				sb.append(",");
			i++;
		}
		sb.append(")");
		return sb.toString();
	}
	
	private static boolean containsNormal2ArgInvocation(String s) {

		String notation = "[nN][oO][rR][mM][aA][lL] *\\( *[^,]+, *[^,)]+\\)";
		Pattern p = Pattern.compile(notation);
		Matcher m = p.matcher(s);
		boolean found = false;
		while (m.find()) {
			String not = m.group();
			return true;
		}
		return found;
		
	}
	
	private static boolean containsNormal3ArgInvocation(String s) {

		String notation = "[nN][oO][rR][mM][aA][lL] *\\( *[^,]+, *[^,]+, *[^,)]+\\)";
		Pattern p = Pattern.compile(notation);
		Matcher m = p.matcher(s);
		boolean found = false;
		while (m.find()) {
			String not = m.group();
			return true;
		}
		return found;
		
	}
	
	private static boolean containsPulse2ArgInvocation(String s) {

		String notation = "[pP][uU][lL][sS][eE] *\\( *[^,]+, *[^,)]+\\)";
		Pattern p = Pattern.compile(notation);
		Matcher m = p.matcher(s);
		boolean found = false;
		while (m.find()) {
			String not = m.group();
			return true;
		}
		return found;
		
	}
	
	private static boolean containsPulse3ArgInvocation(String s) {

		String notation = "[pP][uU][lL][sS][eE] *\\( *[^,]+, *[^,]+, *[^,)]+\\)";
		Pattern p = Pattern.compile(notation);
		Matcher m = p.matcher(s);
		boolean found = false;
		while (m.find()) {
			String not = m.group();
			return true;
		}
		return found;
		
	}
	
	private static boolean containsIntInvocation(String s) {

		String notation = "[iI][nN][tT] *\\(.*\\)";
		Pattern p = Pattern.compile(notation);
		Matcher m = p.matcher(s);
		boolean found = false;
		while (m.find()) {
			String not = m.group();
			return true;
		}
		return found;
		
	}
	
	private static boolean containsRandomInvocation(String s) {

		String notation = "[Rr][Aa][Nn][Dd][Oo][Mm] *\\( *[^,]+, *[^,)]+\\)";
		Pattern p = Pattern.compile(notation);
		Matcher m = p.matcher(s);
		boolean found = false;
		while (m.find()) {
			String not = m.group();
			return true;
		}
		return found;
		
	}
	
//	private static String lengthAdjusted(String s) {
//		StringBuilder adjusted = new StringBuilder();
//		StringBuilder line = new StringBuilder();
//		
//		boolean added = false;
//		
//		String splitChar = " ";
//		if (s.contains("WITH LOOKUP")) 
//			splitChar = ",";
//		
//		String[] parts = s.split(splitChar);
//		
//		List<String> decomp = Parser.decompose(s);
//		
//		// need to grab by position
//		int i = 0;
//		while(i < decomp.size()) {
//		
////		for (String str : decomp) { // parts
//			String str = decomp.get(i);
//			line.append(str);
//			added = false;
//			if (i < decomp.size()-1 && line.length() > 100) {
//				str = decomp.get(++i);
//				line.append(str);
//				while(i < decomp.size()-1 && !Parser.isOperator(str) && !str.equals(",") && !str.equals(")") && !str.equals("(")) {
//					str = decomp.get(++i);
//					line.append(str);
//				}
//				adjusted.append(line);
//				adjusted.append("\n");
//				added = true;
//				line.setLength(0);	
//			}
//			i++;
//		}
//		
//		if (!added)
//			adjusted.append(line);
//		
//		return adjusted.toString().replaceAll(",$", "");
//	}
	
	private static String adjust(String s) {
		StringBuilder adjusted = new StringBuilder();
		
		String[] parts = s.split("\n");
		for (String p : parts) {
			adjusted.append(lengthAdjusted(p));
			if (s.contains("WITH LOOKUP")) 
				adjusted.append("\n");
			else
				adjusted.append("\n");
		}
		
		return adjusted.toString();
	}
	
	private static String lengthAdjusted(String s) {
		StringBuilder adjusted = new StringBuilder();
		StringBuilder line = new StringBuilder();
		
		boolean added = false;
		String splitChar = " ";
		
		// if this is a long string without "many" blanks, but lots of commas, split on that
		int numBlanks = s.split(" ").length-1;
		int numComma = s.split(",").length-1 + (s.endsWith(",") ? 1 : 0);
		int lineLength = s.length();
		
		if (s.length() > 80) {
			// we will need to break into multiple lines.
			// decide on split character
			int aveB = numBlanks > 0 ? lineLength / numBlanks : Integer.MAX_VALUE;
			int aveC = numComma > 0 ? lineLength / numComma : Integer.MAX_VALUE;
			
			if (aveC < aveB)
				splitChar = ",";
			
		}
		
//		if (s.contains("WITH LOOKUP")) 
//			splitChar = ",";

		String[] parts = s.split(splitChar);
		List<String> decomp = Parser.decompose(s, false, true);
		
		// need to grab by position
		int i = 0;
		while(i < decomp.size()) {
		
//		for (String str : decomp) { // parts
			String str = decomp.get(i);
			line.append(str);
			added = false;
			if (i < decomp.size()-1 && line.length() > 160) {
				str = decomp.get(++i);
				line.append(str);
				while(i < decomp.size()-1 && splitChar.equals(",") && !Parser.isOperator(str) && !str.equals(",") && !str.equals(")") && !str.equals("(")) {
					str = decomp.get(++i);
					line.append(str);
				}
				adjusted.append(line);
				// this is where a continuation is added.
				// make sure that we don't add where not wanted after multi marker
//				if (i < decomp.size())
//					adjusted.append("\\");
//				adjusted.append("\n\t\t");
				added = true;
				line.setLength(0);	
			}
			i++;
		}
		
//		// need to grab by position
//		int i = 0;
//		while(i < parts.length) {
//		
//			String str = parts[i];
//			line.append(str+" ");
//			added = false;
//			if (i < parts.length-1 && line.length() > 80) {
//				str = parts[++i]; 
//				line.append(str+" ");
//				adjusted.append(line);
//				adjusted.append("\\\n\t\t");
//				added = true;
//				line.setLength(0);	
//			}
//			i++;
//		}
		
		if (!added)
			adjusted.append(line);
		
//		return adjusted.toString().replaceAll(",$", "");
		return adjusted.toString();
	}
	


}
