package gov.anl.gss.sdm.shared;

import java.io.Serializable;
import java.util.List;

@SuppressWarnings("serial")
public class CustomGraphObject implements Serializable{
	String name;
	List<String> variables;
	public CustomGraphObject(){
	}
	public CustomGraphObject(String name){
		this.name=name;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public List<String> getVariables() {
		return variables;
	}
	public void setVariables(List<String> variables) {
		this.variables = variables;
	}
	
	public String asRawData() {
		StringBuilder sb = new StringBuilder();
		sb.append(name);
		for (String v : variables) {
			sb.append("\t"+v);
		}
		
		sb.append("\n");
		return sb.toString();
	}
	
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("cgo: <"+name+"> "+variables);
		
		return sb.toString();
	}
	
}