package gov.anl.gss.sdm.shared;

import java.io.Serializable;
import java.util.ArrayList;

@SuppressWarnings("serial")
public abstract class DatabaseObject implements Serializable{
	
	protected long id;
	protected boolean edited =false;
	protected boolean added =false;
	protected boolean deleted =false;
	
	DatabaseObject(){
		
	}
	DatabaseObject(long id){
		this.id=id;
	}
	public abstract void reset();
	
	public long getId(){
		return id;
	}
	public void setId(long id) {
		this.id = id;
	}
	public boolean isEdited() {
		return edited;
	}
	public void setEdited(boolean edited) {
		this.edited = edited;
	}
	public boolean isAdded() {
		return added;
	}
	public void clearFlags(){
		added=false;
		edited=false;
		deleted=false;
	}
	public void setAdded(boolean added) {
		this.added = added;
	}
	public boolean isDeleted() {
		return deleted;
	}
	public void setDeleted(boolean deleted) {
		this.deleted = deleted;
	}
	public static String colonSeparate(ArrayList<String> strings){
		String resultString="";
		for(String string:strings){
			if(resultString.length()>0)resultString = resultString+":";
			resultString = resultString+string;
		}
		return resultString;
	}
	public static String commaSeparate(String[] strings){
		String resultString="";
		for(String string:strings){
			if(resultString.length()>0)resultString = resultString+",";
			resultString = resultString+string;
		}
		return resultString;
	}
	public static String commaSeparate(ArrayList<String> strings){
		String resultString="";
		for(String string:strings){
			if(resultString.length()>0)resultString = resultString+",";
			resultString = resultString+string;
		}
		return resultString;
	}
	public static String quoteIt(String string){
		// first look for quotes to escape
		String newString = "";
		char charArray[]= new char[string.length()];
		string.getChars(0, string.length(),charArray,0);
		for(char c:charArray){
			newString = newString + c;
			if(c=='\"')newString = newString + c;
		}
		return "\""+newString+"\"";
	}
	public static String singleQuoteIt(String string){
		if(string==null)string="";
		// first look for quotes to escape
		String newString = "";
		char charArray[]= new char[string.length()];
		string.getChars(0, string.length(),charArray,0);
		for(char c:charArray){
			newString = newString + c;
			if(c=='\'')newString = newString + "\'";
		}
		return "\'"+newString+"\'";
	}
}
