package gov.anl.gss.sdm.shared;

/**
* @author Mary Ann Bitz
* Argonne National Laboratory
* Global Security Sciences Division 
*/
/**
 * Class to hold one of the levers used in a simulation model
 */
@SuppressWarnings("serial")
public class Lever extends Variable{
	private double minVal;
	private double maxVal;
	private int increment;
	private boolean editable;

	public Lever() {
	}
	public Lever(int position,String name, String description,String units, double minVal, double maxVal, 
			int increment,String displayName, String displayUnits, boolean editable,boolean included,
			String type) {
		super(position,name,description,units,displayName,displayUnits, included, type);
		this.minVal=minVal;
		this.maxVal=maxVal;
		this.editable=editable;
	}
	
	public double getMinVal() {
		return minVal;
	}
	public void setMinVal(double minVal) {
		this.minVal = minVal;
	}
	public double getMaxVal() {
		return maxVal;
	}
	public void setMaxVal(double maxVal) {
		this.maxVal = maxVal;
	}
	public int getIncrement() {
		return increment;
	}
	public void setIncrement(int increment) {
		this.increment = increment;
	}
	public boolean isEditable() {
		return editable;
	}
	public void setEditable(boolean editable) {
		this.editable = editable;
	}
	public boolean canBeEdited(){
		return isEditable();
	}
	
	public String toString() {
		return "Lever: " + name;
	}
}
