package gov.anl.gss.sdm.shared;

import java.io.Serializable;
import java.util.List;

@SuppressWarnings("serial")
public class LoopObject implements Serializable{
	String variable;
	String extendedName;
	String name;
	String loopPolarity;
	List<String> intermediates;
	List<String> linkPolarities;
	List<String> linkThickness;
	boolean modified = false;
	public LoopObject(){
	}
	public LoopObject(String name){
		this.name=name;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getVariable() {
		return variable;
	}
	public void setVariable(String variable) {
		this.variable = variable;
	}
	public List<String> getIntermediates() {
		return intermediates;
	}
	public void setIntermediates(List<String> intermediates) {
		this.intermediates = intermediates;
	}
	
	public int getLength() {
		return intermediates.size()+1;
	}
	
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(variable);
		for (String s : intermediates) {
			sb.append(" -> "+s);
		}
		
		sb.append(" -> "+variable);
		return sb.toString();
	}
	public List<String> getLinkPolarities() {
		return linkPolarities;
	}
	public void setLinkPolarities(List<String> polarities) {
		this.linkPolarities = polarities;
	}
	public String getLoopPolarity() {
		return loopPolarity;
	}
	public void setLoopPolarity(String loopPolarity) {
		this.loopPolarity = loopPolarity;
	}
	public List<String> getLinkThickness() {
		return linkThickness;
	}
	public void setLinkThickness(List<String> linkThickness) {
		this.linkThickness = linkThickness;
	}
	public boolean isModified() {
		return modified;
	}
	public void setModified(boolean modified) {
		this.modified = modified;
	}
	public String getExtendedName() {
		return extendedName;
	}
	public void setExtendedName(String id) {
		this.extendedName = id;
	}
	
}