package gov.anl.gss.sdm.shared;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

// define node here
@SuppressWarnings("serial")
public class Node  implements Serializable{
	public int level=0;
	public boolean leaf=false;
	public int value;
	public boolean visited = false; 
	public int x;
	public int y;
	public List<Node> vertices = new ArrayList<Node>();
	public final static int USES=0;
	public final static int CAUSES=1;
	public int purpose;
	public List<String> polarities = new ArrayList<String>();
	public String polarity;
	
	private String variable;
	
	public Node(){
	}
	public Node(String val) {
		super();
		variable=val;
	}
	public Node(int value) {
		super();
		this.value = value;
		variable="Variable "+value;
	}
	
    public Node(String variable, int level) {
        super();
        this.variable = variable;
        this.level = level;
}

public void addVertex(Node n, String polarity) {
        vertices.add(n);
        polarities.add(polarity);
        leaf = false;
}

	public void addVertex(Node n) {
		vertices.add(n);
	}
	public String toString() {
		return variable;
	}
	public String getVariable() {
		return variable;
	}
	public void setVariable(String variable) {
		this.variable = variable;
	}
	public int getPurpose() {
		return purpose;
	}
	public void setPurpose(int purpose) {
		this.purpose = purpose;
	}
	public List<String> getPolarities() {
		return polarities;
	}
	public void setPolarities(List<String> polarities) {
		this.polarities = polarities;
	}
	public String getPolarity() {
		return polarity;
	}
	public void setPolarity(String polarity) {
		this.polarity = polarity;
	}
	
	public String toTreeString() {
		StringBuilder sb = new StringBuilder();
		sb.append(getVariableAndLevel()+" -> ");
		
		int index = 0;
		for (Node bn : getVertices()) {
			sb.append(" [ "+bn.getVariableAndLevel()+"{"+getPolarities().get(index)+"} ]");
			index++;
		}
		for (Node bn : getVertices()) {
			sb.append("\n"+bn.toString());
		}
		
		return sb.toString(); 
	}
	
	public String getVariableAndLevel() {
		return variable+"{"+level+"}";
	}
	
	/**
	 * @return the vertices
	 */
	public List<Node> getVertices() {
		return vertices;
	}
	
}