package gov.anl.gss.sdm.shared;


import java.io.Serializable;
import java.util.ArrayList;

@SuppressWarnings("serial")
public class ResultsData implements Serializable{
	Variable variable;
	ArrayList<Double>values;
	public ResultsData(){
		values=new ArrayList<Double>();
	}
	public void fakeIt(Variable variable){
		setVariable(variable);
		
	}
	public ResultsData(Variable variable) {
		this();
		this.variable=variable;
	}
	
	public void addValues(double[] dvalues){
		if(dvalues!=null){
			for(double val:dvalues){
				values.add(new Double(val));
			}
		}
	}
	public void addValue(double dvalue){
		values.add(new Double(dvalue));
	}
	public Variable getVariable() {
		return variable;
	}
	public void setVariable(Variable variable) {
		this.variable = variable;
	}
	public ArrayList<Double> getValues() {
		return values;
	}
	public void setValues(ArrayList<Double> values) {
		this.values = values;
	}
	public double getValueFor(int timeIndex){
		return values.get(timeIndex);
	}
	public void clear(){
		values.clear();
	}
	public int size(){
		return values.size();
	}
}