package gov.anl.gss.sdm.shared.drawView;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;



public abstract class ModelGraphic{
	protected int id;
	public Color color;
	protected int minX,minY,maxX,maxY;
	public ModelDiagram modelView;
	protected int hideLevel;
	public ModelGraphic(ModelDiagram view){
		modelView=view;
		hideLevel=0;
	}

	public void drawBoundingBox(Graphics2D context, Color color, int lineWid) {
		context.setPaint(color);
		context.setStroke(new BasicStroke(lineWid));
		context.drawRect(minX,minY,maxX-minX,maxY-minY);
	}
	public void fillBoundingBox(Graphics2D context, Color color) {
		context.setPaint(color);
		context.fillRect(minX,minY,maxX-minX,maxY-minY);
	}
	public void drawSelected(Graphics2D context){
		// highlight the bounding box
		drawBoundingBox(context,Color.blue,2);
	}
	public void draw(Graphics2D context){
		if(modelView.isSelected(this)){
			drawSelected(context);
		}
	}
	
	abstract public void shift(int xShift, int yShift);

	
	abstract public boolean isValid();
	public void computeRelations(){}
	public int getMinX() {
		return minX;
	}
	public int getMaxX() {
		return maxX;
	}
	public int getMinY() {
		return minY;
	}
	public int getMaxY() {
		return maxY;
	}
	public String toString(){
		return ""+id;
	}
}