package gov.anl.gss.sdm.shared.drawView;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

public class ModelView extends ModelDiagram{
	
	public static final int FONT_ADJUSTMENT = 0;
	public static final int LINE_THICKNESS_ADJUSTMENT = 0;

	public static void main(String[] args){
		// try it out
		// make a sample graphics context to use in calculations
		BufferedImage offImage = new BufferedImage(100, 100, BufferedImage.TYPE_INT_ARGB);

		Graphics2D g2 = offImage.createGraphics();
		
		ModelView view = new ModelView("test");
		view.context=g2;
		if(sampleStrings.length>1){
			view.parseDefaults(sampleStrings[3]);
			// get rid of first three strings
			String[] strings = new String[sampleStrings.length-3];
			for(int i=0;i<strings.length;i++){
				strings[i]=sampleStrings[i+3];
			}
			view.parseContents(strings);
		}
		view.showWholeArea();
		view.calcBoundingBox();

		// draw it with real image of proper size 
		offImage =
				new BufferedImage(view.maxX, view.maxY,
						BufferedImage.TYPE_INT_ARGB);

		g2 = offImage.createGraphics();
		view.context=g2;
		view.drawContents(g2);
		try {
			// retrieve image
			File outputfile = new File("saved.gif");
			ImageIO.write(offImage, "gif", outputfile);
		} catch (IOException e) {

		}


	}
	public static ModelDiagram getModelView(String string,String[] contentStrings) {
	//	contentStrings=simple2;
		ModelView view = new ModelView(string);
		if(contentStrings.length>1){
			view.parseDefaults(contentStrings[3]);
			// get rid of first three strings
			String[] strings = new String[contentStrings.length-3];
			for(int i=0;i<strings.length;i++){
				strings[i]=contentStrings[i+3];
			}
			view.parseContents(strings);
		}
		view.showWholeArea();
		return view;
	}
	
	private void parseDefaults(String string) {
		// initArrow
		// Font
		// fontsize
		// fontoptions
		// shapeColor
		// arrowColor
		// fillColor or -1--1--1 for nones
		// background color
		
		// ppix,ppiy,zoom,tf
		
		String[] tokens = string.split("\\|");
		if(tokens.length<0)return;
		
		String[] tokenF = tokens[0].split(",");
		if(tokenF.length>2){
			fontString=tokenF[2];
		}
		
		fontSize=Integer.parseInt(tokens[1])+ModelView.FONT_ADJUSTMENT;
		
		textColor=getColorFrom(tokens[3]);
		shapeColor=getColorFrom(tokens[4]);
		arrowColor=getColorFrom(tokens[5]);
		fillColor=getColorFrom(tokens[6]);
		bgColor=getColorFrom(tokens[7]);
		
	}
	public static String[] sampleStrings = {
		"junk","junk","junk",
		"$192-192-192,0,Times New Roman|18||0-0-0|0-0-0|0-0-255|-1--1--1|-1--1--1|120,120,5,0",
		"10,1,\"Ab: Absenteeism Level\",867,683,108,34,3,131,0,4,-1,0,0,0,0-0-0,192-192-192,|18||0-0-0",
		"10,2,\"Mo: Morale Index\",1267,246,75,34,8,3,0,34,0,0,0,0,0-0-0,0-0-0,Times New Roman|18||255-0-0",
		"10,3,\"Ab: Effect of Fatigue on Absenteeism\",745,431,134,34,8,3,0,0,-1,0,0,0",
		"1,4,3,1,1,0,43,14,35,64,0,0-0-0,Times New Roman|18||0-0-0,1|(804,543)|",
		"10,5,\"Ab: Effect of TSO Morale on Absenteeism\",1074,433,150,34,8,131,0,0,-1,0,0,0",
		"1,6,5,1,1,0,43,14,35,64,0,0-0-0,Times New Roman|18||0-0-0,1|(977,549)|",
		"1,7,9,1,1,0,0,14,1,64,0,0-0-0,|18||0-0-0,1|(663,681)|",
		"1,8,2,5,1,0,45,13,35,64,0,255-0-0,Times New Roman|18||0-0-0,1|(1177,332)|",
		"10,9,\"Ab: Absenteeism Level Normal\",480,681,108,34,8,3,0,0,-1,0,0,0",
		"10,10,\"Op: Fatigue Index\",665,253,74,34,8,3,0,32,-1,0,0,0,0-0-0,0-0-0,Times New Roman|18||0-0-0",
		"1,11,10,3,1,0,0,14,3,64,0,0-0-0,|18||0-0-0,1|(702,327)|",
		"10,12,\"Ab: Time to Register Adjustments to Absenteeism Level\",1254,682,131,50,8,3,0,0,-1,0,0,0",
		"1,13,12,1,0,0,0,13,3,64,0,0-0-0,|18||0-0-0,1|(1058,682)|",
		"10,14,\"Mo: Morale Normal\",1325,122,85,34,8,2,0,3,-1,0,0,0,128-128-128,0-0-0,|18||128-128-128",
		"1,15,14,2,0,0,0,0,3,64,0,0-0-0,|18||0-0-0,1|(1299,177)|",
		"10,16,\"Mo: Morale\",1484,206,94,16,8,2,0,3,-1,0,0,0,128-128-128,0-0-0,|18||128-128-128",
		"1,17,16,2,0,0,0,0,3,64,0,0-0-0,|18||0-0-0,1|(1376,225)|",
		"10,18,\"Sw: Switch to Activate Morale Effects\",1065,124,104,50,8,2,0,3,-1,0,0,0,128-128-128,0-0-0,|18||128-128-128",
		"1,19,18,2,0,0,0,0,3,64,0,0-0-0,|18||0-0-0,1|(1172,189)|",
		"10,20,\"Op: Fatigue Normal\",759,119,84,34,8,2,0,3,-1,0,0,0,128-128-128,0-0-0,|18||128-128-128",
		"1,21,20,10,0,0,0,0,3,64,0,0-0-0,|18||0-0-0,1|(716,180)|",
		"10,22,\"Op: Fatigue\",545,119,93,16,8,2,0,3,-1,0,0,0,128-128-128,0-0-0,|18||128-128-128",
		"1,23,22,10,0,0,0,0,3,64,0,0-0-0,|18||0-0-0,1|(591,171)|",
		"10,24,\"Ab: Absenteeism Normal Percent of Work Hours\",430,816,155,51,8,2,0,3,-1,0,0,0,128-128-128,0-0-0,|18||128-128-128",
		"1,25,24,9,0,0,0,0,0,64,0,-1--1--1,,1|(455,746)|",
		"10,26,\"Sc: Weighed number of work hours per month\",439,542,140,51,8,2,0,3,-1,0,0,0,128-128-128,0-0-0,|18||128-128-128",
		"1,27,26,9,0,0,0,0,0,64,0,-1--1--1,,1|(459,613)|",
		"10,28,\"Sw: ON Condition\",1339,375,71,34,8,2,0,3,-1,0,0,0,128-128-128,0-0-0,|18||128-128-128",
		"1,29,28,2,0,0,0,0,0,64,0,-1--1--1,,1|(1306,316)|",
		"10,30,\"Ab: Absenteeism Index\",871,849,106,34,8,3,0,0,0,0,0,0",
		"1,31,1,30,0,0,0,0,0,64,0,-1--1--1,,1|(868,759)|",
		"1,32,9,30,0,0,0,0,0,64,0,-1--1--1,,1|(668,762)|"
	};
	public static String[] simple={
		"10,1,\"Ab: Absenteeism Level\",867,683,108,34,3,131,0,4,-1,0,0,0,0-0-0,192-192-192,|18||0-0-0",
		"10,2,\"Mo: Morale Index\",1267,246,75,34,8,3,0,34,0,0,0,0,0-0-0,0-0-0,Times New Roman|18||255-0-0",
		"10,3,\"Ab: Effect of Fatigue on Absenteeism\",745,431,134,34,8,3,0,0,-1,0,0,0",
		"1,4,3,1,1,0,43,14,35,64,0,0-0-0,Times New Roman|18||0-0-0,1|(804,543)|",
		"10,5,\"Ab: Effect of TSO Morale on Absenteeism\",1074,433,150,34,8,131,0,0,-1,0,0,0",
		"1,6,5,1,1,0,43,14,35,64,0,0-0-0,Times New Roman|18||0-0-0,1|(977,549)|",
		"1,7,9,1,1,0,0,14,1,64,0,0-0-0,|18||0-0-0,1|(663,681)|",
		"1,8,2,5,1,0,45,13,35,64,0,255-0-0,Times New Roman|18||0-0-0,1|(1177,332)|",
		"10,9,\"Ab: Absenteeism Level Normal\",480,681,108,34,8,3,0,0,-1,0,0,0",
		"10,10,\"Op: Fatigue Index\",665,253,74,34,8,3,0,32,-1,0,0,0,0-0-0,0-0-0,Times New Roman|18||0-0-0",
		"1,11,10,3,1,0,0,14,3,64,0,0-0-0,|18||0-0-0,1|(702,327)|",
		"10,12,\"Ab: Time to Register Adjustments to Absenteeism Level\",1254,682,131,50,8,3,0,0,-1,0,0,0",
		"1,13,12,1,0,0,0,13,3,64,0,0-0-0,|18||0-0-0,1|(1058,682)|"
		
	};
	public static String[] simple2={
		"","","",
		"$192-192-192,0,Times New Roman|12||0-0-0|0-0-0|0-0-255|-1--1--1|-1--1--1|96,96,100,0",
		"10,1,FINALTIME,378,340,42,42,2,130,0,31,-1,0,0,0,128-128-128,64-64-0,|16|B|128-128-128",
		"12,2,48,745,272,10,8,0,3,0,0,-1,0,0,0",
		"1,3,5,2,4,0,0,22,0,0,0,-1--1--1,,1|(681,272)|",
		"1,4,5,1,100,0,0,22,0,0,0,-1--1--1,,1|(561,272)|",
		"11,5,48,621,272,6,8,34,3,0,0,1,0,0,0",
		"10,6,\"This is a valve/flow\",621,291,59,11,40,3,0,0,-1,0,0,0",
		"10,7,This is a variable,354,388,52,11,8,3,0,0,0,0,0,0",
		"1,8,7,1,1,0,0,0,0,64,0,-1--1--1,,1|(364,303)|",
		"12,9,0,882,259,65,46,3,132,0,5,-1,0,0,0,255-0-0,255-255-255,|12||0-0-0",
		"This is comment for the \"cloud\" at the end of the flow arrow",
		"10,10,\"This is a variable\",639,384,74,22,8,130,0,3,-1,0,0,0,128-128-128,0-0-0,|12||128-128-128",
		"12,11,0,899,421,87,49,3,132,0,5,-1,0,0,0,255-0-0,255-255-255,|12||0-0-0",
		"A shadow variable is a variable that has already been defined in another view"
	};
	
	public void parseContents(String[] strings){
		// do the string for the defaults
		
		// get the string for the model view
		for(int i=0;i<strings.length;i++){
			String string=strings[i];
			// try to parse it
			String[] tokens = string.split(",");
			if(tokens.length<0)continue;
			switch(tokens[0]){
			case "1":
				Arrow arrow = new Arrow(this);
				arrow.parseFromStrings(tokens);
				graphics.add(arrow);
				break;
			case "10":
				VariableGraphic variable = new VariableGraphic(this);
				variable.parseFromStrings(tokens);
				graphics.add(variable);
				break;
			case "11":
				ValveGraphic variable2 = new ValveGraphic(this);
				variable2.parseFromStrings(tokens);
				graphics.add(variable2);
				break;
			case "12":
				if((i+1)>=strings.length){
					Comment comment = new Comment(this);
					comment.parseFromStrings(tokens);

				}
				Comment comment = new Comment(this);
				comment.parseFromStrings(tokens,strings[i+1]);

				// see the bit status
				if(comment.hasStringBit()){
					i=i+1;
				}

				
				graphics.add(comment);
				break;
			}
		}
		computeRelations();

	}

	public ModelView(String modelName){
		super(modelName);
		
	}
	static String selectedString;
	
}
