package gov.anl.gss.visualization;

import gov.anl.gss.sdm.server.model.documentor.xmlwriter.NumberFormatter;

public class Coordinate implements Comparable<Coordinate>{

	private double x;
	private double y;
	private double minX;
	private double maxX;
	
	private double minY;
	private double maxY;
	
	public Coordinate(double x, double y, double minX, double maxX, double minY, double maxY) {
		this.x = x;
		this.y = y;
		this.minX = minX;
		this.maxX = maxX;
		
		this.minY = minY;
		this.maxY = maxY;
	}

	public double getX() {
		return x;
	}

	public double getY() {
		return y;
	}
	
	public double[] asPoint() {
		return new double[] {x,y};
	}
	
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("x: "+NumberFormatter.formatForSmall(x)+" y: "+NumberFormatter.formatForSmall(y)+" i: "+getIndexI()+" j: "+getIndexJ());
		return sb.toString();
		
	}
	
	public int getIndexI() {
		// .2 - .24 - .28 - .32 - .36 - .4 - .44
		//  0 - .04 - .08 - .12 - .16 - .2 - .24
		// 0 - .2 - .4 - .6 - .8 - 1.0 - 1.2
		
		// y / range
		
		double range = maxY - minY;
		double tick = range/5;
		int index = 5 - (int) ((y-minY)/tick);
		// make sure that no coordinates land in row 0
		if (y == maxY)
			index = 1;
		if (index < 0)
			System.out.println("Negative Index");
		
		return index;
		
//		return 5 - ((int) (y * 10.0) / 2);
	}
	
	public int getIndexJ() {		
//		return (int) (x * 10.0) / 2;
		double range = maxX - minX;
		double tick = range/5;
		int index = (int) ((x-minX)/tick);
		if (index > 4)
			index = 4;
		if (index < 0)
			System.out.println("Negative Index");
		return index;
	}
	
	public double distanceTo(Coordinate other) {
		return SFEXYPointerAnnotationMetaData.distance(x, y, other.getX(), other.getY());
	}
	
	@Override
	public int compareTo(Coordinate arg0) {
		if (this.y < arg0.y)
			return -1;
		if (this.y > arg0.y)
			return 1;
		if (this.x < arg0.x)
			return 1;
		if (this.x > arg0.x)
			return -1;
		return 0;
	}
}
