package gov.anl.gss.visualization;


import gov.anl.gss.sdm.server.model.documentor.xmlwriter.NumberFormatter;
import gov.anl.gss.sdm.server.model.support.MutableInteger;

import java.util.ArrayList;
import java.util.List;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;

import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;

public class GraphTable {

	
//	public static final int PLOT_WIDTH = 1000;
//	public static final int PLOT_HEIGHT = 750;
	
	public static final int FONT_SIZE_FEWER_COLUMNS = 14;
	public static final int FONT_SIZE_MORE_COLUMNS = 12;
	public static final int FONT_SIZE_EVEN_MORE_COLUMNS = 10;
	
	public GraphTable() {
		
	}
	
	public static String order(MutableInteger i) {
		return NumberFormatter.formatForCountNotConditional(i.valueAndInc());
	}
	
	public static JPanel wrap(JFreeChart jfc, int PLOT_WIDTH, int PLOT_HEIGHT) {
		
	
		NextColor color = new NextColor();
		ChartPanel chartPanel = new ChartPanel(jfc);
		chartPanel.setPopupMenu(null);

		chartPanel.setDomainZoomable(true);
		chartPanel.setRangeZoomable(true);
		chartPanel.setPreferredSize(new java.awt.Dimension(PLOT_WIDTH, PLOT_HEIGHT));

		JPanel p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.PAGE_AXIS));
		


		p.setPreferredSize(new java.awt.Dimension(PLOT_WIDTH, PLOT_HEIGHT+0)); /*400*/

		p.add(chartPanel);

		JFrame jf = new JFrame();
		jf.add(p);
		jf.setPreferredSize(new java.awt.Dimension(PLOT_WIDTH, PLOT_HEIGHT+120));
		jf.pack();

		return p;
	}
	
	protected List<List<String>> configureDataTable(List<List<String>> allRows, int numRows) {
		
		for (int i = 0; i < numRows; i++) {
			allRows.add(new ArrayList<String>());
		}
		return allRows;
	}
}
