package gov.anl.gss.visualization;

import gov.anl.gss.sdm.server.model.support.Utilities;

import java.io.BufferedWriter;
import java.io.IOException;
import java.util.List;

public class HtmlGrouper {
	
	String in;
	String out;
	
	public static void main(String[] args) {
		HtmlGrouper hg = new HtmlGrouper(args);
		hg.execute();
	}
	
	public HtmlGrouper(String[] args) {
		in = args[0];
		out = args[1];
	}
	
	public void execute() {

		StringBuilder sb = new StringBuilder();
		BufferedWriter bw = Utilities.openFileForWriting(out);
		List<String> al = Utilities.getAsList(in);
		boolean inTableRow = false;
		boolean inTable = false;
		for (String l : al) {
			String chars = l.trim();
			if (chars.startsWith("<tbody>")) {
				inTable = true;
			} else if (chars.startsWith("</tbody>")) {
				inTable = false;
			}
			if (inTable) {
				if (inTableRow) {
					sb.append(chars);
					if (chars.startsWith("</tr>")) {
						sb.append("\n");
						inTableRow = false;
					}
				} else {
					if (chars.startsWith("<tr>")) {
						sb.append(chars);
						inTableRow = true;
					} else {
						sb.append(chars);
						sb.append("\n");
					}
				}
			} else {
				sb.append(chars);
				sb.append("\n");
			}
		}
		try {
			bw.append(sb.toString());
			bw.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
