package gov.anl.gss.visualization;


import java.awt.Color;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class NextColor {
	
//	public static final Color[] COLOR_SEQUENCE = {Color.red,  Color.green, Color.cyan, Color.gray, /* Color.orange, */ 
//		Color.magenta, Color.orange,  Color.yellow, Color.pink, /* Color.gray, */ Color.blue, Color.black, };
	
//	public static final Color[] COLOR_SEQUENCE = {Color.green, Color.yellow, Color.gray, Color.red,  Color.cyan,
//		Color.orange,   Color.magenta,  Color.pink,  Color.blue, Color.black,  };
	
//	public static final Color[] COLOR_SEQUENCE = {Color.orange, Color.blue, Color.yellow, Color.cyan,   
//		     Color.black, Color.pink, Color.gray };
	
//	public static final Color[] COLOR_SEQUENCE = {Color.blue, Color.blue.brighter(), 
//		Color.blue.brighter().brighter(), Color.blue.brighter().brighter().brighter(),   
//	     Color.blue.brighter().brighter().brighter().brighter(), 
//	     Color.blue.brighter().brighter().brighter().brighter().brighter(), Color.black };
	
	public static final Color[] COLOR_SEQUENCE = {
		new Color(0,0,0), 
		new Color(230,159,0),
		new Color(86,180,233),
		new Color(0,158,115),
		new Color(240,228,66), 
		new Color(0,114,178), 
		new Color(204,121,167),
		new Color(213,94,0)
		};
	
	public static final String[] COLOR = {"Green",  "Yellow", "Gray", "Red",   "Cyan", 
		"Orange",  "Magenta", "Pink", "Blue", "Black", };
	
	public static String[] airports = new String[] {"CLT", "DFW", "DTW", "JFK", "PHX", "SEA", "TPA", };
	public static String[] airportIDs = new String[] {"A1", "A2", "A3", "A4", "A5", "A6", "A7"};
	
	public static final int GRAY = 8;
	
	public int colorPtr = -1;
	public int colorPass = 0;
	private int numColors;
	
	public NextColor() {
		numColors = COLOR_SEQUENCE.length;
	}
	
	public NextColor(int numColors) {
		this.numColors = numColors;
	}
	
	public static Color getSequence(int i) {
		
		int limit = 8;
		
		// we limit ourselves to the first 8 colors don't what blue and black for this
		int index =  i % limit;
		Color c = COLOR_SEQUENCE[index];
		
//		int wrap = i / 8;
//		
//		for (int j = 0; j < wrap; j++)
//			c = c.darker();
		
		return c;
	}
	
	public static Color getSequenceNotGray(int i) {
		
		// we limit ourselves to the first 8 colors don't what blue and black for this
		// nor gray
		
		int limit = 8;
		
		int it = i;
//		if (i >= GRAY)
//			it++;
		int index =  it % limit;
		Color c = COLOR_SEQUENCE[index];
		
		int wrap = i / limit;
		
		for (int j = 0; j < wrap; j++)
			c = c.darker();
		
		return c;
	}
	
	public static List<Color> getAirportOrder() {
		List<Color> al = new ArrayList<Color>();
		List<String> ap = new ArrayList<String>();
		for (String a : airportIDs)
			ap.add(a);
		Collections.sort(ap);
		for (String a : ap) {
			al.add(getAirportIDColor(a));
		}
		return al;
	}
	
	public static boolean isColorName(String name) {
		for (int i = 0; i < COLOR.length; i++) {
			if (COLOR[i].equals(name)) {
				return true;
			}
		}
		return false;
	}
	
	public static Color getColor(String name) {
		for (int i = 0; i < COLOR.length; i++) {
			if (COLOR[i].equals(name)) {
				return COLOR_SEQUENCE[i];
			}
		}
		return Color.BLACK;
	}
	
	public static String getNameFor(Color c) {
		for (int i = 0; i < COLOR_SEQUENCE.length; i++) {
			if (COLOR_SEQUENCE[i].equals(c))
				return COLOR[i];
		}
		return "Unknown";
	}
	
	public static Color getAirportColorForCluster(String cluster) {
		String airport = cluster.split("_")[0];
		for (int i = 0; i < airports.length; i++) {
			if (airports[i].equals(airport)) {
				return COLOR_SEQUENCE[i];
			}
		}
		return Color.black;
	}
	
	public static Color getAirportColor(String airport) {
		for (int i = 0; i < airports.length; i++) {
			if (airports[i].equals(airport)) {
				return COLOR_SEQUENCE[i];
			}
		}
		return Color.black;
	}
	
	public static Color getAirportIDColor(String airportID) {
		for (int i = 0; i < airportIDs.length; i++) {
			if (airportIDs[i].equals(airportID)) {
				return COLOR_SEQUENCE[i];
			}
		}
		return Color.black;
	}
	
	public String currentColorName() {
		return COLOR[colorPtr];
	}
	
	public Color next() {
		Color c;
		
		if (++colorPtr >= numColors /*COLOR_SEQUENCE.length */) {
			colorPtr = 0;
			colorPass++;
		}
		c = COLOR_SEQUENCE[colorPtr];
		
		for (int i = 0; i < colorPass; i++)
			c = c.darker();
		
		return c;
	}
	
	public Color nextNotGray() {
		Color c;
		if (colorPtr+1 == GRAY)
			colorPtr++;
		
		if (++colorPtr >= numColors /*COLOR_SEQUENCE.length */) {
			colorPtr = 0;
			colorPass++;
		}
		c = COLOR_SEQUENCE[colorPtr];
		
		for (int i = 0; i < colorPass; i++)
			c = c.darker();
		
		return c;
	}

}

//package gov.anl.gss.visualization;
//
//
//import java.awt.Color;
//import java.util.ArrayList;
//import java.util.Collections;
//import java.util.List;
//
//public class NextColor {
//	
////	public static final Color[] COLOR_SEQUENCE = {Color.red,  Color.green, Color.cyan, Color.gray, /* Color.orange, */ 
////		Color.magenta, Color.orange,  Color.yellow, Color.pink, /* Color.gray, */ Color.blue, Color.black, };
//	
//	public static final Color[] COLOR_SEQUENCE = {Color.green, Color.yellow, Color.gray, Color.red,  Color.cyan,
//		Color.orange,   Color.magenta,  Color.pink,  Color.blue, Color.black,  };
//	
//	public static final String[] COLOR = {"Green",  "Yellow", "Gray", "Red",   "Cyan", 
//		"Orange",  "Magenta", "Pink", "Blue", "Black", };
//	
//	public static String[] airports = new String[] {"CLT", "DFW", "DTW", "JFK", "PHX", "SEA", "TPA", };
//	public static String[] airportIDs = new String[] {"A1", "A2", "A3", "A4", "A5", "A6", "A7"};
//	
//	public static final int GRAY = 2;
//	
//	public int colorPtr = -1;
//	public int colorPass = 0;
//	private int numColors;
//	
//	public NextColor() {
//		numColors = COLOR_SEQUENCE.length;
//	}
//	
//	public NextColor(int numColors) {
//		this.numColors = numColors;
//	}
//	
//	public static Color getSequence(int i) {
//		
//		// we limit ourselves to the first 8 colors don't what blue and black for this
//		int index =  i % 8;
//		Color c = COLOR_SEQUENCE[index];
//		
//		int wrap = i / 8;
//		
//		for (int j = 0; j < wrap; j++)
//			c = c.darker();
//		
//		return c;
//	}
//	
//	public static Color getSequenceNotGray(int i) {
//		
//		// we limit ourselves to the first 8 colors don't what blue and black for this
//		// nor gray
//		
//		int it = i;
//		if (i >= GRAY)
//			it++;
//		int index =  it % 8;
//		Color c = COLOR_SEQUENCE[index];
//		
//		int wrap = i / 8;
//		
//		for (int j = 0; j < wrap; j++)
//			c = c.darker();
//		
//		return c;
//	}
//	
//	public static List<Color> getAirportOrder() {
//		List<Color> al = new ArrayList<Color>();
//		List<String> ap = new ArrayList<String>();
//		for (String a : airportIDs)
//			ap.add(a);
//		Collections.sort(ap);
//		for (String a : ap) {
//			al.add(getAirportIDColor(a));
//		}
//		return al;
//	}
//	
//	public static boolean isColorName(String name) {
//		for (int i = 0; i < COLOR.length; i++) {
//			if (COLOR[i].equals(name)) {
//				return true;
//			}
//		}
//		return false;
//	}
//	
//	public static Color getColor(String name) {
//		for (int i = 0; i < COLOR.length; i++) {
//			if (COLOR[i].equals(name)) {
//				return COLOR_SEQUENCE[i];
//			}
//		}
//		return Color.BLACK;
//	}
//	
//	public static String getNameFor(Color c) {
//		for (int i = 0; i < COLOR_SEQUENCE.length; i++) {
//			if (COLOR_SEQUENCE[i].equals(c))
//				return COLOR[i];
//		}
//		return "Unknown";
//	}
//	
//	public static Color getAirportColorForCluster(String cluster) {
//		String airport = cluster.split("_")[0];
//		for (int i = 0; i < airports.length; i++) {
//			if (airports[i].equals(airport)) {
//				return COLOR_SEQUENCE[i];
//			}
//		}
//		return Color.black;
//	}
//	
//	public static Color getAirportColor(String airport) {
//		for (int i = 0; i < airports.length; i++) {
//			if (airports[i].equals(airport)) {
//				return COLOR_SEQUENCE[i];
//			}
//		}
//		return Color.black;
//	}
//	
//	public static Color getAirportIDColor(String airportID) {
//		for (int i = 0; i < airportIDs.length; i++) {
//			if (airportIDs[i].equals(airportID)) {
//				return COLOR_SEQUENCE[i];
//			}
//		}
//		return Color.black;
//	}
//	
//	public String currentColorName() {
//		return COLOR[colorPtr];
//	}
//	
//	public Color next() {
//		Color c;
//		
//		if (++colorPtr >= numColors /*COLOR_SEQUENCE.length */) {
//			colorPtr = 0;
//			colorPass++;
//		}
//		c = COLOR_SEQUENCE[colorPtr];
//		
//		for (int i = 0; i < colorPass; i++)
//			c = c.darker();
//		
//		return c;
//	}
//	
//	public Color nextNotGray() {
//		Color c;
//		if (colorPtr+1 == GRAY)
//			colorPtr++;
//		
//		if (++colorPtr >= numColors /*COLOR_SEQUENCE.length */) {
//			colorPtr = 0;
//			colorPass++;
//		}
//		c = COLOR_SEQUENCE[colorPtr];
//		
//		for (int i = 0; i < colorPass; i++)
//			c = c.darker();
//		
//		return c;
//	}
//
//}
