package gov.anl.gss.visualization;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

public class SFEScatterPlotDataSet {

	private List<SFEScatterPlotDataPoint> points = new ArrayList<SFEScatterPlotDataPoint>();
	private List<XYSeries> connectors = new ArrayList<XYSeries>();
	
	private Map<String, SFEScatterPlotDataPoint> pointMapByName = new HashMap<String, SFEScatterPlotDataPoint>();
	
	XYSeriesCollection xySeriesCollection = new XYSeriesCollection();
	
	public SFEScatterPlotDataSet() {
		
	}
	
	public void addConnector(XYSeries connector) {
		connectors.add(connector);
		xySeriesCollection.addSeries(connector);
	}
	
	public void addDataPoint(SFEScatterPlotDataPoint pt) {
		pointMapByName.put(pt.getLabel(), pt);
		points.add(pt);
		xySeriesCollection.addSeries(pt.getSeries());
	}
	
	public SFEScatterPlotDataPoint getPoint(String label) {
		return pointMapByName.get(label);
	}
	
	public int getNumClusters() {
		return points.size();
	}
	
	public int getNumConnectors() {
		return connectors.size();
	}
	
	public XYSeriesCollection  getScatterData() {
		
//        XYSeriesCollection xySeriesCollection = new XYSeriesCollection();
//        
//        for (int i = 0; i < points.size(); i++) {
//        	xySeriesCollection.addSeries(points.get(i).getSeries());
//        	if (i < connectors.size())
//        		xySeriesCollection.addSeries(connectors.get(i));
//        }
        
//        for (SFEScatterPlotDataPoint pt : points) {
//        	xySeriesCollection.addSeries(pt.getSeries());
//        }
//        
//        for (XYSeries connector : connectors) {
//        	xySeriesCollection.addSeries(connector);
//        }

        return xySeriesCollection;
    }
}
