package gov.anl.gss.visualization;

import java.awt.AWTException;
import java.awt.Rectangle;
import java.awt.Robot;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;

import javax.imageio.ImageIO;
import javax.swing.JFrame;
import javax.swing.JPanel;

import org.jfree.chart.JFreeChart;

public class Writer {



	public static void writeAsPNG( JFreeChart chart, OutputStream out, int width, int height )
	{
		try
		{
			BufferedImage chartImage = chart.createBufferedImage( width, height, null);
			ImageIO.write( chartImage, "png", out );
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public static void writeAsPNG( JFreeChart chart, String file, int width, int height ) {
		try {
			
			OutputStream out = new FileOutputStream(new File(file));
			writeAsPNG(chart, out, width, height );
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	 public static void writeAsPNG(JFrame chart, String file, int width, int height) {
	        
	        try {
	            
	            Robot robot = new Robot();
	            // Capture the screen shot of the area of the screen defined by the rectangle
	            BufferedImage bi=robot.createScreenCapture(new Rectangle(100,100));
	            ImageIO.write(bi, "jpg", new File("C:/imageTest.jpg"));
	            
	        } catch (AWTException e) {
	            e.printStackTrace();
	        } catch (IOException e) {
	            e.printStackTrace();
	        }
	    }
	 
	 public  static void renderPanelAndWrite(JPanel chart, String file) {
	     

	        BufferedImage bi = getScreenShot(chart);
	        try {
				ImageIO.write(bi, "jpg", new File(file));
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	       
	    }

	    private static BufferedImage getScreenShot(JPanel panel){
	        BufferedImage bi = new BufferedImage(
	            panel.getWidth(), panel.getHeight(), BufferedImage.TYPE_INT_BGR);
	        panel.paint(bi.getGraphics());
	        return bi;
	    }

}
